2017-01-14  Sirius Bakke <sirius@bakke.co>
    * Version 5.3.7
    * iptables:
      - Feature: fwbuilder now supports conntrack instead of state module for recent iptables
      - Feature: Add support for the iptables > 1.4.20 "-w" option
      - Bugfix: Fixed (potential) deadlock situation as sugested by https://github.com/antaflos
      - Bugfix: Proper handling of NAT chains
      - Feature: Add support for --kerneltz
    * junos:
      - Bugfix: Generated new ids for the IP fragmentation service objects in the standard object database
      - Bugfix: Use correct comment symbol
    * gui:
      - Bugfix: Don't delete object in locked group
      - Feature: Add new objects directly to the subfolder via context menu
    * compiler:
      - Feature: Add support for MSYS2
      - Update OSX buildscript for newer XCode
      - Feature: Add support for GCC 6.X
      - Refactor: Gain more C++11 compatability
      - Feature: W32: Add support for MXE and provide Docker environment for cross compiling

2015-03-10  Sirius Bakke <sirius.bakke@uninett.no>
    * Version 5.3.6
    * Several bugfixes for Junos, including rollback on syntax error,
      correct netmask for host objects and ssh password prompt lock-up

2014-09-24  Sirius Bakke <sirius.bakke@uninett.no>
    * Version 5.3.0
    * Support for Junos Access lists
    * Show release notes for previous releases

2013-08-10  Sirius Bakke <sirius.bakke@uninett.no>
	* Version 5.2.0
	* Search for objects by port number or ip addres
	* View graphical diff and autocompile firewall when loading file
	* Support for Cisco NXOS Access lists
	* Added support for dummy objects in rules
	* Port to Qt5
	* New buildscript for OSX
	* Added build instructions for Windows

2012-03-21  Vadim Kurland  <vadim@netcitadel.com>

	* running autoconf, configure as part of windows build. Merged
	qmake .pro and .inc files for Windows, Mac and Linux builds. Moved
	files needed for Windows and Mac packaging to the "packaging"
	directory.

2012-03-19  Vadim Kurland  <vadim@netcitadel.com>

	* version 5.1.0
	* switching to GPL for Mac OS X and Windows.

2012-03-18  Vadim Kurland  <vadim@netcitadel.com>

	* CompilerDriver.cpp (CompilerDriver::populateClusterElements):
	fixes #2686 "automatic rules for heartbeat are not generated for
	vlan subinterfaces"

	* clusterMembersDialog.cpp (clusterMembersDialog::clusterMembersDialog):
	fixes #2685 "Clicking "Manage Members" in a vlan subinterface of a
	cluster causes crash".

2012-02-20  Vadim Kurland  <vadim@netcitadel.com>

	* configlets/linux24/routing_functions (OLD_ROUTES): fixes SF bug
	3489096 "dd-wrt-jffs: all routes are deleted if there is an
	error". The problem affects all supported Linux-like
	systems. Shell code that restores old static routing table entries
	in case of an error with commands adding new routing entries was
	broken and left the machine with no routes at all.

	* configlets/linux24/routing_functions: using mktemp to create
	temporary directory. If mktemp is not available, fall back onto
	less secure but guaranteed to work method where I generate
	randomized the name of the temporary directory using process ID.

	* OSConfigurator_linux24_interfaces.cpp (printInterfaceConfigurationCommands):
	fixes #2684 "fix address deletion in configlet update_addresses".
	This only applies to Linux firewalls and configurations where an
	interface has two or more ip addresses. If user deleted one of the
	addresses that happens to be the "primary" address of the
	interface in the GUI, generated script deleted both addresses on
	the firewall machine instead of just one and left interface with
	no addresses at all. The fix is to use /proc variable
	/proc/sys/net/ipv4/conf/all/promote_secondaries that makes the
	kernel "promote" secondary address to a "primary" status when
	primary address is deleted. Default behavior in Linux kernel is to
	delete all addresses when primary address is deleted.

2012-02-13  Vadim Kurland  <vadim@netcitadel.com>

	* qmake.inc.in (QMAKE_CXXFLAGS_DEBUG): fix for SF bug #3468802.
	Need to define macro __STDC_FORMAT_MACROS. This still needs to be
	tested on all build machines.

	build 3594
	
2012-01-02  Vadim Kurland  <vadim@netcitadel.com>

	* PolicyCompiler_ipt.cpp (specialCaseAddressRangeInRE::processNext):
	fixed SF bug #3468358 "change in rule-compilation between 5.0.0
	and 5.0.1". Rule with cluster interface in "Destination"
	should compile into matching ip addresses assigned to the cluster
	interface object and corresponding member firewall's interface
	object, but in v5.0.1 it only matched member interface
	address. This bug triggered when iptables version was set to
	1.2.11 or greater. This was a regression from v5.0.0

	* VERSION (FWB_MICRO_VERSION): v 5.0.2

2011-12-23  Vadim Kurland  <vadim@netcitadel.com>

	* v5.0.1 released

2011-12-07  Vadim Kurland  <vadim@netcitadel.com>

	* pix.g (nat_command_last_parameters): fixes #2678 Policy importer
	for PIX/ASA could not parse nat command with parameter "outside"

	* PIXImporterNat.cpp (PIXImporter::buildNoNATRule): fixes #2679
	Policy importer for PIX/ASA could not import "nat exemption" rule
	(for example: "nat (inside) 0 access-list EXEMPT")

	* pix.g (nat_addr_match): fixes #2677 Policy importer for PIX/ASA
	could not parse command "nat (inside) 1 0 0"

	* iptAdvancedDialog.cpp (iptAdvancedDialog::iptAdvancedDialog):
	fixed strings that should be translated; these strings
	caused problems when translation was loaded at the run time.

2011-11-30  Vadim Kurland  <vadim@netcitadel.com>

	* NATCompiler_pf.cpp (NATCompiler_pf::compile): fixes #2674
	NAT compiler for PF crashed when AttachedNetworks object
	was used in Translated Source of a NAT rule.

2011-11-28  Vadim Kurland  <vadim@netcitadel.com>

	* NATCompiler_PrintRule.cpp (_printIpSetMatch): fixed SF bug
	#3443609 Return of ID: 3059893": iptables "--set" option
	deprecated".  Need to use --match-set instead of --set if iptables
	version is >= 1.4.4. The fix done for #3059893 was only in the
	policy compiler but needs to be done in both policy and nat
	compilers.

	* PolicyCompiler_PrintRule.cpp (_printDirectionAndInterface): more
	fixes for SF bug #3439613. Adding "-i" / "-o" clause to match
	parent bridge interface. This allows us to correctly match which
	bridge the packet comes through in configurations using wildcard
	bridge port interfaces. For example, when br0 and br1 have "vnet+"
	bridge port interface, iptables can still correctly match which
	bridge the packet went through using "-o br0" or "-o br1"
	clause. This can be useful in installations with many bridged
	interfaces that get created and destroyed dynamically, e.g.  with
	virtual machines. Note that the "-i br0" / "-o br0" clause is only
	added when there is more than one bridge interface and bridge
	port name ends with a wild card symbol "+"

2011-11-21  Vadim Kurland  <vadim@netcitadel.com>

	* TableFactory.cpp (TableFactory::createTablesForRE): see #2671
	Duplicate objects appear in PF table when option "preserve group
	and addresses table object names" is in effect. This happened if
	the same user-defined group was used in multiple rules or
	different rule element of the same rule. In this case generated PF
	table would have several copies of the same addresses.

	* TableFactory.cpp (TableFactory::createTablesForRE): see #2672 PF
	option "preserve group and addresses table object names" does not
	work right when the same object is used in several different
	groups. If the same object was a member of multiple groups and
	these groups were used in the same or different rules of the same
	PF firewall, compiler used all groups in all rules. This could
	create match for objects that were not intended to be part of some
	rules. This problem has been fixed. Note that configuration with
	a combination of ipv4 and ipv6 objects as members of the same
	user-defined group when group is used in mixed ipv4+ipv6 rule
	set still does not work right. In this case compiler generates
	table that exactly reflects configuration user created in the
	GUI (i.e. includes both ipv4 and ipv6 addresses) and then uses
	this table in both "inet" and "inet6" rules.

	* PolicyCompiler_pf.cpp (createTables): With this fix, when option
	"preserve group and addresses table object names" is in effect,
	compiler for PF will create named tables for the user-defined
	object group even if it contains just one object.

	* PolicyCompiler_PrintRule.cpp (_printDirectionAndInterface): SF
	bug #3439613.  physdev module does not allow --physdev-out for
	non-bridged traffic anymore. We should add --physdev-is-bridged to
	make sure this matches only bridged packets.


2011-11-16  Vadim Kurland  <vadim@netcitadel.com>

	* InetAddrMask.cpp (InetAddrMask::setNetworkAndBroadcastAddress):
	fixed bug (no number) introduced when I was working on #2670.
	Setting broadcast address in the network object with netmask /31
	to 255.255.255.255 broke rule shadowing algorithm.

2011-11-15  Vadim Kurland  <vadim@netcitadel.com>

	* CustomServiceDialog.cpp (loadFWObject): fixes #2669 "Cant
	inspect custom Service object in Standard objects library".

2011-11-10  Vadim Kurland  <vadim@netcitadel.com>

	* configlets/linux24/check_utilities: fixes #2664 Update error
	message when "which" command fails. Generated iptables script uses
	"which" to check if all utilities it uses exist on the machine.
	We should also check if "which" itself exists and issue meaningful
	error message if not.

	* IC_PlatformWarningPage.cpp (initializePage): fixes #2668 Remove
	"static routes" from the explanation text in ASA/PIX import
	dialog.  We can not import PIX/ASA routing configuration at this
	time.

2011-11-08  Vadim Kurland  <vadim@netcitadel.com>

	* InetAddrMask.cpp (setNetworkAndBroadcastAddress): see #2670. Per
	RFC3021 network with netmask /31 has no network and direct
	broadcast addresses.

	* PolicyCompiler_ipt.cpp (specialCaseAddressRangeInRE): fixed bug
	in the rule processor that replaces AddressRange object that
	represents single address with an IPv4 object. Also eliminated
	code redundancy.

	* PolicyCompiler_ipt.cpp (splitIfDstMatchingAddressRange): fixes
	#2663 "Rule with "old-broadcast" object results in invalid
	iptables INPUT chain".  Compiler was choosing chain INPUT with
	direction "outbound" for rules that had old broadcast address in
	"Source", this lead to invalid iptables configuration with chain
	INPUT and "-o eth0" interface match clause.

	* ObjectMatcher.cpp (checkComplexMatchForSingleAddress): see #2663
	Special handling of the "old broadcast" address. This
	address (0.0.0.0) should be treated just like 255.255.255.255 when
	we check if an address "matches" the firewall.

	* RuleSetViewDelegate.cpp (sizeHint): fixes #2665 "Adding text to
	comment causes rule to go from 2 rows to 1 row"

	* ACL.cpp (ciscoACL::trimLine): fixed SF bug 3435004: "Empty lines
	in comment result in "Incomplete Command" in IOS".

	* CompilerDriver_pf_run.cpp (CompilerDriver_pf::run): fixed SF bug
	#3429377 "PF: IPv6 rules are not added in IPv4/IPv6
	ruleset (anchor)". Compiler for PF did not inlcude rules generated
	for IPv6 in generated PF anchor configuration files.

	* CompilerDriver_pf_run.cpp (CompilerDriver_pf::run): fixed SF bug
	3428992: "PF: rules order problem with IPv4 and IPv6". Compiler
	for PF should group ipv4 and ipv6 NAT rules together, before it
	generates ipv4 and ipv6 policy rules.

	* BaseObjectDialog.cpp (connectSignalsOfAllWidgetsToSlotChange):
	fixed SF bug #3433587 "Manual edit of new service Destination Port
	END value fails". This bug made it impossible to edit the value of
	the end of the port range because as soon as the value became less
	than the value of the beginning the range, the GUI would reset it
	to be equal to the value of the beginning of the range. This
	affected both TCP and UDP service object dialogs.

	* PolicyCompiler_ipfw_writers.cpp (PrintRule::_printAddr): fixed
	SF bug #3426843 "ipfw doesn't work for self-reference, in
	5.0.0.3568 version".

2011-10-19  Vadim Kurland  <vadim@netcitadel.com>

	* PolicyCompiler_pix.cpp (AddressRangesIfTcpServiceToFW::processNext): 
	see #2662 "Crash when compiling ASA rule with IP range". Need to
	split address range if it is used in "source" of a rule that
	controls telnet, ssh or http to the firewall itself and firewall's
	version is >= 8.3. Commands "ssh", "telnet" and "http" (those that
	control access on the corresponding protocols to the firewall
	itself) accept only ip address of a host or a network as their
	argument. They do not accept address range, named object or object
	group. This is so at least as of ASA 8.3. Since we expand address
	ranges only for versions < 8.3 and use named object for 8.3 and
	later, we need to make this additional check and still expand
	address ranges in rules that will later convert to "ssh", "telnet"
	or "http" command. Compiler also generates redundant object-group
	statement with CIDR blocks generated from the address range but
	does not use this group in the rule. This does not break generated
	configuration but the object-group is redundant since it is never
	used. This will be rectified in future versions.

	* CompilerDriver_files.cpp (CompilerDriver::getOutputFileNameInternal):
	fixed a bug (no number): if the file name user entered in "Output
	file name" field in the "advanced settings" dialog of a firewall
	object ended with a white space, policy installer failed with an error
	"No such file or directory"

	* build 5.0.1.3583

2011-10-02  Vadim Kurland  <vadim@netcitadel.com>

	* shell_functions: see SF bug #3416900 "Replace `command` with
	`which`".  Generated script (Linux/iptables) used to use "command
	-v" to check if command line tools it needs are present on the
	system. This was used to find iptables, lsmod, modprobe, ifconfig,
	vconfig, logger and others. Some embedded Linux distributions,
	notably TomatoUSB, come without support for "command". Switching to
	"which" that is more ubuquitous and should be available pretty
	much everywhere.

2011-09-29  Vadim Kurland  <vadim@netcitadel.com>

	* SSHSession.cpp (startSession): enable fwbuilder to take
	advantage of GSSAPIAuthentication with openssh using suggestion by
	Matthias Witte witte@netzquadrat.de

	* PolicyCompiler_ipt.cpp (compile): fixes SF bug #3414382
	"Segfault in fwb_ipt dealing with empty groups". Compiler for
	iptables used to crash when an empty group was used in the
	"Interface" column of a policy rule.

2011-09-24  Vadim Kurland  <vadim@netcitadel.com>

	* NamedObjectsAndGroupsSupport.cpp (CreateObjectGroups::processNext):
	fixes #2660 "compiler for IOSACL crashed when address range appears
	in a rule AND object-group option is turned ON"

2011-09-19  Vadim Kurland  <vadim@netcitadel.com>

	* PolicyCompiler_cisco_acls.cpp (setInterfaceAndDirectionBySrc):
	see #2656 "Generated Cisco ASA access-list has duplicate entry".

	* snmp.cpp (SNMPCrawler::run_impl): fixes #2658 "snmp network
	discovery creates duplicate address and network objects"

	* ND_ProgressPage.h (class ND_ProgressPage): see #2657 snmp
	network discovery crashed if option "Confine scan to network" was
	used.

	* iosInterfaces.cpp (iosInterfaces::basicValidateInterfaceName):
	see #2655 Interface names are not allowed to have dash "-" even
	with interface verification off. We should allow "-" in the
	interface name for Cisco IOS

2011-09-04  Vadim Kurland  <vadim@netcitadel.com>

	* IPTImporter.cpp (IPTImporter::isSupportedTable): see #2653
	Importer for iptables checks that netfilter table used in
	the original iptables config is one of the tables we support.
	Currently only "filter", "mangle" and "nat" are supported. Also
	see #2651, #2652

	* FWObjectDatabase_tree_ops.cpp (_recursively_copy_subtree): see
	#2654 fixes GUI crash that occured if user copied a rule from file
	A to file B, then closed file B, opened file C and tried to copy
	the same rule from A to C'

2011-08-30  Vadim Kurland  <vadim@netcitadel.com>

	* fixes SF bug 3247094 "Nomenclature of IP address edit dialog".
	Network ipv6 dialog says "Prefix length".

	* linux24advanceddialog_q.ui: fixes SF bug 3302121 "cosmetic
	mis-format in fwb Linux paths dialog"

	* DNSNameDialog.cpp (applyChanges): fixes SF bug 3388055 Adding a
	"DNS Name" with a trailing space causes failure.

2011-08-25  Vadim Kurland  <vadim@netcitadel.com>

	* see #2646 and SF bug 3395658: Added few ipv4 and ipv6 network
	objects to the Standard objects library: TEST-NET-2,
	TEST-NET-3 (RFC 5735, RFC 5737), translated-ipv4, mapped-ipv4,
	Teredo, unique-local and few others.

	* ObjectManipulator.cpp (openLibForObject): fixes #2648 "right
	mouse click on firewall object in "Deleted objects" library causes
	GUI crash"

	* PolicyCompiler_ipt.cpp (processNext): fixes #2650 "rules with
	address range that includes firewall address in Src are placed in
	OUTPUT chain even though addresses that do not match the firewall
	should go in FORWARD"

2011-08-14  Vadim Kurland  <vadim@netcitadel.com>

	* InetAddr.cpp (InetAddr::isValidV4Netmask): function
	InetAddr::isValidV4Netmask() checks that netmask represented by
	the object consists of a sequence of "1" bits, followed by the
	sequence of "0" bits and therefore does not have zeroes in the
	middle.

	* NetworkDialog.cpp (NetworkDialog::validate): added check to make
	sure user does not enter netmask with zeroes in the middle for the
	IPv4 network object. Netmasks like that are not supported by
	fwbuilder.

	* RuleSetView.cpp (RuleSetView::addColumnRelatedMenu): fixes #2643
	"GUI crashes when user cuts a rule, then right-mouse click in any
	rule element of another"

2011-08-11  Vadim Kurland  <vadim@netcitadel.com>

	* freebsd/carp_interface: see #2638 "When CARP password is empty
	the advskew value is not read". Should skip "pass <word>"
	parameter of the ifconfig command that creates carp interface
	if user did not set up any password.

	* OSConfigurator_linux24_interfaces.cpp (validateInterfaces):
	see #2639 "support for vlan subinterfaces of bridge interfaces
	(e.g.  br0.5)". Currently fwbuilder can not generate script to
	configure vlan subinterfaces of bridge interfaces, however if user
	did not request this configuration script to be generated,
	compiler should not abort when it encounters this combination.

	* InterfaceEditorWidget.cpp (validateAddress): fixes #2641
	"newFirewall dialog does not accept ipv6 addresses with long
	prefixes". The dialog did not allow ipv6 addresses of inetrfaces
	with netmask > 64 bit.

	* newFirewallDialog.cpp (cleanup): fixes #2642 "GUI crashes if
	user cancels newFirewall dialog".

	* RuleOptionsDialog.cpp (fillInterfaces): the drop-down list of
	interfaces for the "route-through" rule option for PF and iptables
	should include not only cluster interfaces, but also interfaces of
	all members. This way, we can make compiler generate configuration
	"pass in quick on em0 route-to { ( em0 10.1.1.2 ) } ... " for a
	rule of a PF cluster. Here "em0" is an interface of a member, not
	the cluster.

2011-08-08  Vadim Kurland  <vadim@netcitadel.com>

	* configlets/freebsd/rc_conf_carp_interface: see #2636 "carp :
	Incorrect output in rc.conf.local format". Should use
	create_args_carp0 instead of ifconfig_carp0 to set up CARP
	interface vhid, pass and adskew parameters.

2011-08-05  Vadim Kurland  <vadim@netcitadel.com>

	* RuleElement.cpp (RuleElementItf::validateChild): see #2635
	Object type AttachedNetworks is not allowed in the "interface"
	rule element.

2011-08-03  Vadim Kurland  <vadim@netcitadel.com>

	* newFirewallDialog_from_template.cpp (replaceReferencesToObject):
	see #2628 fixed crash that happened if user create new firewall
	object from a template and changed one of the ip addresses, while
	another firewall object created from the same template already
	existed in the tree.

2011-08-02  Vadim Kurland  <vadim@netcitadel.com>

	* instDialog_ui_ops.cpp (instDialog::getInstOptions): moved "batch
	install" button from the main installer wizard to the dialog where
	user enters their password. Now user can start in a non-batch
	install mode but continue in batch install mode at any time if all
	their firewalls authenticate with the same user name and password.

2011-08-01  Vadim Kurland  <vadim@netcitadel.com>

	* pix.g (static_command_common_last_parameters): changed token
	name from "ESP" to "ESP_WORD" to avoid conflict with macro "ESP"
	that happened during build on OpenSolaris

	* unit_tests/ObjectMatcherTest/ObjectMatcherTest.cpp (matchTest):
	fixed unit test (ObjectMatcher matches ipv6 only when internal
	flag is set accordingly)

	* VERSION: set version to 5.0.1

2011-07-28  vadim  <vadim@netcitadel.com>

	* version 5.0.0. release

2011-07-22  vadim  <vadim@netcitadel.com>

	* ObjectManipulator.h (QWidget): see #2622 "Remove Back and
	Forward buttons". We have decided behavior of the GUI was too
	complicated since user can both act on objects directly and
	navigate backwards and forwards to the objects found in their
	browsing history.  Navigation using browsing history was broken
	when quick filter was in use, too. All in all, it feels the value
	of "back" and "forward" buttons was relatively low.

2011-07-21  vadim  <vadim@netcitadel.com>

	* XMLTools.cpp (convert): see #2577 Updated error message that
	appears when user tries to open .fwb file created by the future
	version of fwbuilder.

	* TextFileEditor.cpp (save): fixes #2567 "If file doesn't exist
	when clicking 'edit file', then you have to hit save button twice".
	The bug affected "edit file" function in the Address Table object
	dialog.

	* NATCompiler_pf_writers.cpp (_printAddr): fixes #2590 "PF: NAT
	compiler fails when run-time address table object is used in a
	rule"

	* RoutingCompiler.cpp (processNext): fixes #2565 "Run-time dns
	name or address table in routing policy -> crash". Compiler for PF
	crashed if user placed run-time DNSName object in "destination"
	of a routing rule.

	* RuleSetModel.cpp (initRule): see #2515 Expanded set of options
	the user can change to pre-set parameters in the new policy rules
	they create. Now user can set default values for action ("Deny" or
	"Accept"), direction, the "stateless" flag and logging.

	* FindObjectWidget.cpp (matchAttr): see #2516 "Enhance Find to
	include searching for IP addresses in ranges". Function "find"
	now finds ip addresses inside address ranges.

2011-07-20  vadim  <vadim@netcitadel.com>

	* FWBTree.cpp (init_statics): see #2619 "Attempting to
	copy-and-paste a tag service results in an error". Pasting of a
	TagService object to the "Tag Services" group did not work.

	* RuleSetView.cpp (itemDoubleClicked): fixes #2566, #2618 Fix for
	the regression introduced when I worked on #2566 "Double-clicking
	on rule when program first starts results in empty editor pane".
	Double click on the rule number should not do anything, but double
	click on rule options, comment and other fields should open the
	editor. Change done for #2566 broke this.

2011-07-20  Vadim Kurland  <vadim@netcitadel.com>

	* ObjectMatcher.cpp (dispatch): removed optimization in
	dispatch(IPv4*,void*) and dispatch(IPv6*, void*) that assumed
	address matches a host or a firewall if it is located somewhere in
	the subtree rooted at the firewall object. This assumption fails
	if the address is a child of a Variable that belongs to the
	Variables folder of this firewall. Instead, always calling
	checkComplexMatchForSingleAddress() which uses
	Interface::findAllInterfaces() and therefore only matches against
	addresses that belong to the interfaces. See #2598

	* PolicyCompiler_ipt.cpp (processSingleObjectNegationInRE):
	consolidated rule processors that deal with single object negation
	into one class. Also, taking into account Variables.

	* Interface.cpp (findAllInterfaces): added more efficient way to
	get a list of all interfaces of a firewall. This function assumes
	interfaces are direct children of the firewall and each interface
	may have a subinterface (one level deep). This function is faster
	because it does not scan whole tree rooted at the firewall object
	which might be large if firewall has lots of rules.

2011-07-19  vadim  <vadim@netcitadel.com>

	* NATCompiler_ipt.cpp (processNext): fixed SF bug 3371301 "Error
	compiling with VLAN and masquerade". Iptables NAT rules with vlan
	interface configured as "dynamic" and no ip address in Translated
	Source caused compiler crash.

2011-07-18  theron	<theron@netcitadel.com>
	* Fixed #2511: make sure auto-scroll of items in ObjectTreeView
	works, otherwise it's impossible to move an item into a
	user-defined folder if there are lots of intervening items.

2011-07-13  theron	<theron@netcitadel.com>
	* Fixed #2505: make sure that objects that we show are members of
	a dynamic group are actually objects.  Previously we were showing
	stuff like FirewallOptions objects.  To make sure that dynamic
	group expansion is done the same way in the UI and for the
	compiler, also fixed #2502 (consolidate logic for DynamicGroup).

	* Modified checks (added for #2514) for empty path in an Address
	Table object.  It's valid to have an empty path for the situation
	where a user wants to use an ipset in place of the table.
	However, if there is a path and it comes out blank in
	getSourceNameAsPath() then that means %DATADIR% expansion failed.

	* Fixed #2440.  Now when a firewall is matched in the quick
	filter, all child elements (e.g. policies, interfaces) will be
	displayed as well.

	* Fixed #2523: save the expanded/collapsed state of the tree when
	the user starts typing something into the quick filter.  When the
	quick filter is cleared, re-expand any items that started off
	expanded (so we get the union of expanded items displayed by quick
	filter plus what the user started with expanded).

	* Tried to fix #2507: set a size for the "type" column in the
	dynamic group dialog (on some platforms it comes out so narrow you
	can't see it, despite it having ResizeToContents).

2011-07-11  theron	<theron@netcitadel.com>
	* Implemented #2514, support for address table alternate paths.
	There's a "data directory" setting under user preferences.  If the
	user selects an address table file using "choose file" and that
	file is "inside" the data directory, then the appropriate part of
	the path is replaced with %DATADIR% as a variable.  If the address
	table is marked "run-time" then the path is taken from the
	firewall data directory option.

2011-07-11  Vadim Kurland  <vadim@netcitadel.com>

	* TableFactory.cpp (createTablesForRE): see #2513 "Group and
	Address Table name persistence in generated config". Compiler for
	PF can now preserve names of object groups, dynamic groups,
	compile-time AddressTable and compile-time DNSName objects in
	the generated pf.conf file. This is optional and is controlled
	by a checkbox in the firewall settings dialog.

2011-07-09  vadim  <vadim@netcitadel.com>

	* pf.g (rule_extended): see #2551 Importer should parse PF rules
	that use "route-to", "reply-to" and "dup-to" options in both
	pre-4.7 and 4.7 formats. In PF 4.7 these parameters moved to the
	end of the rule and are now part of the "filteropts" block of
	parameters.

	* PFImporter.cpp (pushPolicyRule): see #2551 Importer should
	correctly import "pool type" parameter that follows source routing
	rule options "route-to", "reply-to" and "dup-to". Also, since
	currently fwbuilder does not support source routing rules with
	multiple different interface-gateway pairs (only one interface in
	combination with one or multiple gateway addresses are supported),
	importer displays warning and marks rules as "broken" when it
	encounters this configuration.

	* ObjectManipulator_slots.cpp (makeSubinterface): see #2561
	operation of making an interface a subinterface should be
	performed using undo/redo command. Also, this should take care of
	inconvenient scrolling of the object tree after this operation.

	* ObjectManipulator.cpp (addSubinterfaceSubmenu): see #2562 "Crash
	when making an interface that has subinterfaces a subinterface of
	another interfrace". If an interface has subinterfaces, it should
	not be allowed to become subinterface of another interface.

2011-07-08  vadim  <vadim@netcitadel.com>

	* ObjectManipulator_slots.cpp (makeSubinterface): see #2561 "Add
	context menu to move an interface to be a child of another
	interface". New context menu (submenu) allows user to move an
	interface in the tree to make it a subinterface of another
	interface.

	* parsers/pf.g: see #2556 "PF import: impor of rules referring to
	undefined macros". Importer now records all parser errors in the
	comments of rules where they occurred and marks these rules
	"broken" by coloring them red. Behavior on import of pf.conf file
	with undefined macros is inconsistent at this time: undefined
	macro that appears in a rule where parser expects ip addresses is
	converted to a run-time DNSName object with name "$macro", a
	warning is displayed and rule is marked as "broken". Undefined
	macro in the position of interface name, port name or other
	parameters triggers generic parser error that looks like "Parser
	error: line 26:19: unexpected token: $ext". The rule is marked as
	"broken" and the error is recorded in the comment.

	* PFImporterRun.cpp (substituteMacros): see #2556 "PF import:
	impor of rules referring to undefined macros". Importer displays
	warnings for all undefined macros found in the file, even if there
	are several.

	* objectSignature.cpp: fixes #2559 "Crash on import when at least
	one DynamicGroup object already exists in the object tree."

2011-07-07  Vadim Kurland  <vadim@netcitadel.com>

	* RoutingCompiler.cpp (processNext): see #2191 "Crash when
	compiling a route with table object". Compiler for PF crashed
	when run-time AddressTable object was used in RDst of a routing
	rule.

	* PFImporter.cpp (makeAddressObj): see #2546 "PF import - negation
	inside of inline tables is ignored". Since we can not import
	address lists or tables that contain a mix of negated and
	non-negated items, importer should display an error when it
	enounters one of these and mark all rules that use it as "broken"
	(rule is colored red and error message is added to the comment).

	* PFImporter.cpp (makeAddressObj): see #2556 "PF import: impor of
	rules referring to undefined macros". If pf.conf file uses an
	undefined macro (there is $macro somewhere but the macro has never
	been defined), importer issues a warning, creates run-time DNSName
	object with the name "$macro" and marks all rules where it is used
	as broken, that is, rules are colored red and the error message is
	added to the comment field. Using run-time DNSName object makes
	compiler use "$macro" in the generated pf rule which means
	fwbuilder generates exactly the same pf rule as the one it tried
	to import.

	* PFImporterRun.cpp (run): see #2554 "PF import: create groups of
	address objects for macros where possible". Importer for PF
	recognizes macros that define lists of ip addresses, interfaces or
	host names and creates object groups with the same name from them.
	Only macros that contain at least one ip address in the list are
	recognized.

	* PF import: check if a macro used somewhere in the file to be
	imported is actually defined and abort if not

	* PF import: see #2551 making sure rules that have route-to option
	get the call to setRoute() in the importer

2011-07-06  Vadim Kurland  <vadim@netcitadel.com>

	* applied two patches by Vadim Zhukov persgray@gmail.com to
	replace calls to sprintf with safer calls to snprintf and fix some
	compiler warnings.

	* Importer.cpp (addStandardImportComment): see #2552 "PF import:
	add ability to suppress comments referring to line numbers in the
	original file".

	* PFImporter.cpp (pushPolicyRule): see #2551 "PF Import - source
	routing rules are not imported with rule options set". Importer
	should import "route-to" rule parameters.

	* PFImporter.cpp (newAddressTableObject): see #2546 "PF import -
	negation inside of inline tables is ignored". We can not import
	PF table definition that has some addresses negated.

	* PFImporterRun.cpp (run): see #2550 "PF import - recursive macros
	are not supported". Importer for PF should interpret macro
	definitions that use other macros. See #2545 "PF import error when
	using macro names with same base name and incrementing digit
	suffix". Importer should correctly interpret a macro that has name
	of another macro as a substring of its own name.

2011-07-05  vadim  <vadim@netcitadel.com>

	* PolicyCompiler_pf_writers.cpp (processNext): see #2549 "Update
	generated route-to configuration for PF versions 4.7 and later",
	SF bug 3348931. The "route-to" parameter moved to the end of
	pass rules in PF 4.7

	* pf.g: fixed bug in PF import: address lists such as "{ addr1,
	addr2, ... }" defined as macros or inside the rule could not be
	imported correctly.

	* pf.g: we should be able to import both "block quick log" and
	"block log quick".

2011-06-29  theron	<theron@netcitadel.com>
	* Fixed #2547, made keyword add/remove buttons same size.

2011-06-29  theron	<theron@netcitadel.com>
	* Fixed #2540.  On mac we can get a drop event even if
	dragMoveEvent() says the drop is invalid.  So in ObjectTreeView we
	validate the drop the same we we validate in dragMove to make sure
	the drop is valid.

	* Fixed #2542.  Catch exception inside preprocessor loop so that
	loop continues after error (for unit tests).  Also make sure to
	set ".loaded" variable before calling loadFromSource so that if an
	exception happens we won't try to load it again later.

	* Fixed #2539.  Make sure user folders are added properly.  Also
	deal with case of an object that has a folder attribute that
	doesn't exist in the parent's subfolders list (shouldn't ever
	happen, but in case it does it no longer crashes).  Also make sure
	that subfolders don't have commas in them.

	* Partially fixed #2544.  Adding new icons for dynamic group.

2011-06-27  theron	<theron@netcitadel.com>

	* Fixed #2530, where adding a subfolder opens the parent folder in
	the object editor.

	* Fixed #2529, where dragging and dropping items between
	subfolders could cause a crash.

	* Fixed #2528, display icon next to "new subfolder" menu item.

	* Added feature #2517: directory location caching.  Use
	FWBSettings::{get|set}OpenFileDir() any time we use QFileDialog so
	that the directory you navigated to last time shows up in the next
	file dialog.  This behavior is overridden by setting a working
	directory.  If the directory no longer exists, gracefully fall
	back to something sensible.

2011-06-23  theron	<theron@netcitadel.com>

	* Added support for creating user-defined subfolders.  The
	subfolders exist purely in the display and are not reflected in
	the FWObject tree, in order to keep changes in the back-end to a
	minimum.  New attribute "subfolders" on a system folder tells the
	gui what additional child elements to display in the tree, and
	attribute "folder" on any FWObject tells gui which child tree
	element to put it in.

2011-06-22  Vadim Kurland  <vadim@netcitadel.com>

	* ObjectManipulator_ops.cpp (autorename): fixed #2520 "Attached
	Network objects are not renamed if a firewall is renamed"

	* AttachedNetworksDialog.cpp (addAddressToList): see #2519 Avoid
	creating duplicate network objects for the AttachedNetwork object
	if the parent interface has multiple ip addresses that belong to
	the same subnet.

	* CompilerDriver.cpp (CompilerDriver): fixed #2521 "Compile fails
	if firewall has locked interface that is set to dynamic".

	* NATCompiler_pf_writers.cpp (_printProtocol): see #2524 'avoid
	" {tcp udp icmp} " in place of protocol'. NAT compiler for PF does
	not need to generate protocol match "proto {tcp udp icmp}" when
	service object used in the NAT rule is "any". The reason this was
	done this way is lost in the mist of time; it's been like this
	since very early versions of fwbuilder.

2011-06-21  vadim  <vadim@netcitadel.com>

	* NATCompiler_pf.cpp (compile): fixed #2428 "PF compiler crashes
	when ipv4+ipv6 NAT rule uses only ipv4 address". This has been
	reported as SF bug 3305234.

2011-06-20  Vadim Kurland  <vadim@netcitadel.com>

	* ObjectManipulator_slots.cpp (forward): see #2493 implemented
	"forward" function in addition to the "back" function, added
	a button to the roolbar, using new icons for Back and Forward
	buttons.

	* src.pro (SUBDIRS): see #2477 removed transfer agent
	code.

	* gui.pro: see #2506 Removed obsolete localization files (Russian
	and Japanese). These were incomplete and have never been updated for
	v4.

2011-06-10  Theron Tock  <theron@netcitadel.com>

	* implementation of keywords associated with objects in the GUI;
	ability to filter by keywords, dialog layout changes to add GUI
	controls for keywords.

	* imlementation of the DynamicGroup object type. Dynamic group
	automatically expands to a set of objects using matching rules
	that at this time can match object types and keywords.

2011-06-09  Vadim Kurland  <vadim@netcitadel.com>

	* fixed several GUI crashes that happened when user performed
	various operations on the object tree that contained locked
	objects. see #2487

2011-06-04  vadim  <vadim@netcitadel.com>

	* FWWindow_editor.cpp (openEditor): this change is a part of the
	GUI usability improvements: when user double clicks on a firewall
	object to open it in the editor, rule set view panel switches to
	the rule set of that firewall. To decide which rule set to show,
	the program scans history of the objects the user opened before in
	the same GUI session and shows that firewall's rule set they
	opened last. If user never opened any rule sets of this firewall,
	then the first Policy object is shown. See #2465.

	* RuleSetView.cpp (itemDoubleClicked): as part of the GUI
	usability improvements, its behavior when user double clicks on
	"any" in a rule has changed. Now the program opens object "any" in
	the editor and shows prompt text that explains its behavior.  The
	editor stays read-only and should appear grayed-out if palette
	is set up for that. This reverses the change made for #1731. See #2454.

2011-06-03  vadim  <vadim@netcitadel.com>

	* applied patch to provide configure command line option to specify
	path to ccache. Thanks to user "a. k. huettel " on SourceForge.

	* NATCompiler_pf.cpp (_expand_addr): see #2455 NAT Compiler for PF
	should use "(interface)" syntax to the right of "->" in NAT rules.
	This now works for all interfaces, including those that have ip
	addresses in fwbuilder configuration, when interface object
	appears in "Translated Source" in a nat rule. When firewall object
	appears in "Translated Source", it gets replaced with a set of its
	interfaces which also get translated into "-> (interface)".

	* NATCompiler_ipt.cpp (compile): see #2456 Added support for
	single object negation in "Inbound Interface" and "Outbound
	Interface" columns in compiler for iptables.

	* NATCompiler_pf.cpp (compile): see #2456 Added support for single
	object negation in "Interface" rule element of PF NAT rules. Now
	compiler can produce PF commands such as "nat on ! em0 ... " (for
	PF <4.7) or "match on ! em0 ..." (for PF >= 4.7)

	* Compiler.cpp (singleObjectNegation::processNext): moved rule
	processor that processes single object negation in any rule
	element to the base class Compiler.

2011-06-02  Vadim Kurland  <vadim@netcitadel.com>

	* pf.g (set_rule): see #2464 implemented import of PF "set timeout",
	"set limit" and other "set" commands. Known limitations:
	  - commands "set ruleset-optimization", "set loginterface",
	    "set block-policy", "set state-defaults", "set require-order",
	    "set fingerprints", "set reassemble", "set hostid" are not supported.

2011-05-30  vadim  <vadim@netcitadel.com>

	* pf.g (nat_rule): see #2449 Implementd import of PF "nat"
	rules. Known limitations:
	  - as of v4.2 we can not generate optinal parameters for the
	    "source-hash" pooltype. "sticky-address" is not supported either.
	  - Interface group names are not recognized

2011-05-27  vadim  <vadim@netcitadel.com>

	* PFImporter.cpp: see #2394 pf.conf import. This version implements
	import of pf.conf configuration with the following limitations:
	  - anchors are not imported.  Anchor rules are imported but rules
	    inside anchors are not.
	  - only pf.conf configurations designed with the use of keyword
	    "quick" can be imported.
	  - Macros are expanded during import and are not recreated as
	    objects.  Tables are imported as run-time AddressTable obejcts
	    configured with the file name, or object groups.
	  - User has to specify host OS and PF version number during import
	    process because interpretation of rules with default settings
	    of some parameters is version-dependent.
	  - Import of IPv6 addresses and ICMPv6 matches in pf.conf is not
	    supported at this time.
	  - Import of TCP flag matches for flags 'E' and 'W' is not supported.
	  - Import of "include" clause is not supported
	  - Import of "user" and "group" matches is not supported

2011-05-26  Vadim Kurland  <vadim@netcitadel.com>

	* PolicyCompiler_pf.cpp (compile): see #2434 "PF compiler should
	use 'self' keyword where appropriate". Compiler for PF now uses
	keyword 'self' in rules where firewall object is used in Source
	or Destination.

	* fwcompiler/Compiler.cpp (processNext): added rule processor to
	replace firewall object with special run-time object "self" in
	Source and Destination rule elements. This rule processor can
	be used in policy compilers for any platform.

2011-05-17  vadim  <vadim@netcitadel.com>

	* FWObjectDatabase_tree_ops.cpp (merge): see #2420 "Crash when
	selecting New Firewall and existing firewall has interface that is
	locked". Fixed GUI crash that happened on some operations if an
	object in the tree was locked. For example, if the user locked an
	interface of one of the firewall objects that then proceeded to
	create new firewall object, the GUI would crash. The problem was
	not limited to locking specifically interface objects.

2011-05-15  vadim  <vadim@netcitadel.com>

	* IPTImporter.cpp (pushPolicyRule): see #2411 Implemented import
	of iptables rules with target CLASSIFY.

2011-05-14  vadim  <vadim@netcitadel.com>

	* CompilerDriver_ipt.cpp (findBranchesInMangleTable): see #2405
	"Tag and classify actions dont work properly with branches".
	When branching rule points to a rule set that has rules with Tag
	and Classify options, branching should occur in mangle table even
	when checkbox "create branch in mangle table" is not checked. The
	fix in this change is tentative as it creates branch in chains
	PREROUTING, POSTROUTING and OUTPUT. Since target CLASSIFY is only
	allowed in POSTROUTING, this may create conflict. Need to test
	more.

	* AttachedNetworks.cpp (AttachedNetworks): see #1580 New object
	type: network object that automatically matches subnets an
	interface is attached to. The object can be a child of an
	interface. The object is optional and is not created automatically
	for all interfaces; user can add it using context menu associated
	with an interface. Dialog for this object allows editing of the
	name and comment. List of network addresses represented by this
	object is always generated automatically. Compiler for PF
	translates this object to "en0:network" construct that is
	supported by PF. Compiler for iptables expands it to the list of
	ipv4 and ipv6 networks defined by the addresses of the parent
	interface if interface has static addresses. If interface is
	confgiured as "dynamic" and has no address in fwbuilder, then
	compiler treats AttachedNetworks object as run-time and uses shell
	function to determine network addresses during activation of the
	firewall script. Compilers for other firewall platforms always
	treat this object as compile-time and abort if it is used with
	dynamic interface.

2011-05-13  vadim  <vadim@netcitadel.com>

	* PolicyCompiler_ipt.cpp (processNext): see #2402 "Tag action
	should be done in PREROUTING so it can be acted on later". If a
	rule has both tagging and classification options, the rule should
	be split so that iptables command doing tagging goes in PREROUTING
	and rule doing classification goes into POSTROUTING chain.

	* PolicyCompiler_ipt.cpp (processNext): see #2401 "Deprecating
	Route option for iptables".  This target is not included in any of
	the popular Linux distributions (checked in Ubuntu, Fedora and
	CentOS). The GUI dialog and all support in the compiler will be
	removed in future version of fwbuilder. Beginning with 4.3.0,
	compiler aborts with an error when it encounters a rule using this
	option. In older versions of fwbuilder (4.2.x and before) this
	option was presented as an action "Route".

	* CompilerDriver_ipt_run.cpp (run): see #2400 'Mixing Actions
	"Accept" and "Classify" results in incorrect rules', see #2399
	'Mixing Actions "Accept" and "Tag" results in incorrect ruleset'.
	After we made Tag, Classify and Route rule options instead of
	actions, rules that mix these options with actions "Accept" and
	others, except for "Continue", should be treated differently. The
	action are now implemented using iptables rules in the table
	"filter" and additional rules in table "mangle" is used to
	implement only tagging, classification or routing. Generated
	script does not change default action in table "mangle" and
	assumes it is "ACCEPT" so adding rules with target ACCEPT in
	mangle table should not be necessary. Another change because of
	this affects branching rules that use option "create branch in
	mangle table in addition to the filter table". These rules used to
	duplicate the same action and logging rules in mangle.  Now they
	dont do this and only create rules in mangle if branch rule set
	performs tagging, classification or routing.

2011-05-11  vadim  <vadim@netcitadel.com>

	* v4.2.2 released

	* newFirewallDialog.cpp (finishClicked): fixes #2395 "Crash when
	setting installer directory location" and fixes #2396 "Crash when
	changing firewall name". These two bug reports where the
	manifestation of the same problem that was introduced by the fix
	for #2380. When user hits OK in the newFirewallDialog and it
	merges temporary object tree into the main object tree, it should
	call fixTree() to fix all pointers to the root of the tree.

2011-05-10  vadim  <vadim@netcitadel.com>

	* v4.2.1 released

2011-05-10  Vadim Kurland  <vadim@netcitadel.com>

	* fwbuilder 4.2.1.3540 released; started v4.3.0

	* merged from branch multiple_actions to add changes that
	implement conversion of actions Tag, Classify and Route to
	options. Now one policy rule can have any combination of these
	options. See #2367.

2011-05-09  Vadim Kurland  <vadim@netcitadel.com>

	* FWCmdAddObject.cpp (redo): fixes #2391 "selecting 'new library'
	when editor panel not on 'editor' tab causes crash"

2011-05-06  vadim  <vadim@netcitadel.com>

	* PolicyCompiler_pf_writers.cpp (_printQueue): see #2390 Classify
	does not generate "queue" string for rules created in V4.2.1.3538
	This completes the fix for the bug #2385.

2011-05-05  Vadim Kurland  <vadim@netcitadel.com>

	* FWObjectDatabase_19.xslt: see #2385 "PF action Classify uses
	wrong parameter". This change fixes a bug introduced in 4.2.0
	that affects rules with action Classify in PF firewalls.

	The bug causes the following problems:

	For users who built their rules before v4.2.0:
	  - rules compile normally, both in the single rule compile and
	    when the whole firewall is compiled
	  - if they opened the action of one of such rules in the action
	    editor, the classification string would look empty
	  - if they entered new classification string in the editor,
	    compiler kept using the old one (which they can not see or
	    change in the editor)

	For users who tried to build rules with action Classify with v4.2.0:
	  - no matter what classification string they enter in the action
	    dialog, generated code does not use it

2011-05-04  Vadim Kurland  <vadim@netcitadel.com>

	* FWObjectDatabase_18.xslt: XSLT transformation to upgrade data
	files from DTD v18 to DTD v19. This transformation finds
	"PolicyRule" elements with missing "Itf" child elements and fixes
	them by adding such element with a reference pointint to "any".
	Fixes #2383

	* fwbuilder.dtd.in: Element "Itf" (an interface) of "PolicyRule"
	should be required. DTD version increment.

2011-05-03  vadim  <vadim@netcitadel.com>

	* PolicyCompiler_ipt.cpp (processNext): see #2367 "Multiple
	actions per policy rule". Options "Tag", "Classify" and "Route"
	work with iptables in a combination with any action. This
	implementation has one restriction: option Route can not be used
	in combination with options Tag or Classify and any action that is
	not Continue. This is because option Route can yield rules in
	PREROUTING or POSTROUTING chains that are also used by options Tag
	and Classify. For this combination we create two user-defined
	chains that perform routing and tagging (or classification). In
	case of a terminating action both chains end with it. This means
	if one matches the packet, the other is never going to see it.
	Non-terminating action "Continue" does not create this problem.
	This limitation may be removed in future versions of fwbuilder.

2011-05-03  vadim  <vadim@netcitadel.com>

	* newFirewallDialog.cpp (finishClicked): see #2380 "Firewall
	object is created in the middle of the "new firewall" wizard and
	clicking Back creates two firewall objects". If user chose to
	create new firewall object from a template and clicked Back after
	choosing the template, the program actually created two firewall
	objects but only one was visible in the tree.

2011-04-30  vadim  <vadim@netcitadel.com>

	* RuleSetModel.cpp (objectChanged): see #2373 "GUI becomes
	unresponsive for a long time when an object that is used in a
	large number of rules is modified". The program spent too much
	time resizing rule set view columns.

2011-04-29  vadim  <vadim@netcitadel.com>

	* UsageResolver.cpp (findFirewallsForObject): see #2373 "GUI
	becomes unresponsive for a long time when an object that is used
	in a large number of rules is modified". This bug only affected
	configurations with very large rule sets (1500 rules) where lots
	of rules used the same object. The change in UsageResolver
	eliminates unnecessary scanning of all rule sets to check if the
	affected rule set might be used as a branch. The program used to
	scan the same objects many times.

	* iosaclAdvancedDialog.cpp (accept): fixes #2368 and SF bug
	3294457 "External install script". External install script name
	and arguments weren't saved for IOS firewall objects.

	* snmpNetworkDiscoveryWizard/ND_ProgressPage.h: fixes #2370, #2371
	"broken signals in network discovery wizard". Network discovery
	wizard was not correctly initializased and did not work.

2011-04-25  Vadim Kurland  <vadim@netcitadel.com>

	* instDialog_ui_ops.cpp (readInstallerOptionsFromDialog):
	tentative fix for SF bug 3169045 "Batch installer lists IPv4
	address as management address". Built-in installer wanted to use
	management interface address in batch mode even when alternative
	address or putty session name was provided. This happens only in
	batch mode install.

	* VERSION (GENERATION): version 4.2.0 released; started 4.2.1

2011-04-20  vadim  <vadim@netcitadel.com>

	* configlets/pix_os/script_skeleton: fixed bug (no #): "clear"
	commands were not added when option "generate only access-list,
	access-group, nat, static..." was in effect; also making sure
	"clear" commands for object-groups and ssh are not added when
	option "do not add clear commands" is on. This affects PIX/ASA/FWSM.

2011-04-19  Vadim Kurland  <vadim@netcitadel.com>

	* RoutingCompiler_ipt.cpp (compile): see #2359 "Crash when
	compiling single rule with IPv6 destination and IPv4 gateway or
	interface". Routing compiler for iptables does not support ipv6 at
	this time and will issue a warning when user tries to place ipv6
	address or network in a routing rule. The warning does not appear
	when ipv6 address is a member of a group used in the rule. Also
	see #1575.

2011-04-17  vadim  <vadim@netcitadel.com>

	* fwbedit.cpp (main): added command line switch "-d" to function
	"import" in fwbedit. This switch activates object deduplication
	on import.

2011-04-15  vadim  <vadim@netcitadel.com>

	* fwbedit.cpp (main): see #2328 "Add ability to run firewall import
	from the command line". This has been implemented as a new function
	"import" in fwbedit. See man page fwbedit(1) and "fwbedit -h" for
	more details.

	* iptables.g (multiport_tcp_udp_port_spec): see #2245 fixed bug in
	parser for iptables that prevented correct import of iptables rules
	using module "multiport" with port range matches.

2011-04-14  vadim  <vadim@netcitadel.com>

	* CompilerDriver_pix_run.cpp (pixSecurityLevelChecks): see #2351
	Security levels of ASA and FWSM interfaces do not have to be
	unique. Removed check that enforced this.

	* IPTImporterRun.cpp (run): see #2275 Importer for iptables now
	correctly handles both "intrapositioned" ("-s ! address") and
	"extrapositioned" ("! -s address") negation.

	* platform/fwsm.xml: see #2295 Added FWSM version "3.2". According to
	Cisco documentation, FWSM version 3.2 matches PIX 7.

	* platform/pix.xml: see #2348: "Accounting action is not valid for
	FWSM platform". Actions "Accounting" and "Reject" should not
	appear in the drop-down list of actions in the GUI if platform is
	pix or fwsm.

	* PolicyCompiler_pix.cpp (printPreambleCommands): see #2347 "FWSM
	move up the "access-list mode auto-commit" command". Command that
	configures access list commit mode should be issued before any
	commands that clear and configure access lists. Also in this
	change moving commands that set up temporary access list to the
	top of the script.

	* PolicyCompiler_pix.cpp (printClearCommands): see #2322 If this
	is FWSM and if manual commit mode is used, need to commit after
	clearing ACLs before we clear object groups.

2011-04-13  Vadim Kurland  <vadim@netcitadel.com>

	* IPTImporter.cpp (pushPolicyRule): see #2338 "Empty Mangle Policy
	object created on import". Iptables rules in the table 'mangle'
	will be imported in the dedicated Policy rule set with name
	"Mangle". Rules that use chains FORWARD and POSTROUTING in table
	'mangle' can not be reproduced and will be marked as "bad" (color
	red and corresponding comment).

	* configlets/fwsm_os/ntp: see #2344 fwbuilder should not generate
	any "ntp" commands for FWSM because NTP can not be configured on FWSM.

	* OSConfigurator_pix_os.cpp (_printSysopt): see #2345 More fixes for
	FWSM 4.x: "service resetoutbound", "timeout xlate", "timeout sunrpc"

	* OSConfigurator_pix_os.cpp (_printInterfaceConfiguration): see #2343
	"Interface nameif error when installing generated config for FWSM".
	Use correct  "nameif" command sytax  in FWSM 2.x and 4.x.

	* OSConfigurator_pix_os.cpp (_printSSHConfiguration): see #2344
	"FWSM install errors for clear commands". Using correct syntax for
	"clear" commands for FWSM v4.x

2011-04-11  vadim  <vadim@netcitadel.com>

	* PolicyCompiler_PrintRule.cpp (_printTarget): see #2235 "Modified
	rule action for Continue". Rules with action "Continue" should
	translate into iptables commands without "-j TARGET" parameter. If
	such rule also has logging enabled, it should use target "-j LOG"
	instead of generating additional chain.

	* IPTImporter.cpp (pushPolicyRule): see #2206 Iptables commands with
	no "-j TARGET" parameter should be imported using action "Continue".

	* iptables.g (comment): see #2336 Importer for iptables recognizes
	version stored in the top comment by iptables-save and sets
	version in the firewall object it creates.

2011-04-10  vadim  <vadim@netcitadel.com>

	* utils.cpp (expand_interface_with_phys_address): see #2324 "NAT +
	MAC-matching rules not generated properly". Iptables NAT rules
	matching a group of host objects with both IP and MAC addresses each
	in "Original Source" were not generated properly.

	* PolicyCompiler_PrintRule.cpp (_printOptionalGlobalRules): SF bug
	3178186 "Add ND/NS allow rules for the FORWARD chain". Rules that are
	added automatically to ipv6 Linux firewall to permit neighbor discovery
	packets should be also added to the FORWARD chain if the firewall is
	a bridge.

	* ObjectManipulator_create_new.cpp (actuallyCreateObject): see #2229
	"Multiple new objects with the same name". The GUI should automatically
	choose unique object names for new objects.

	* platforms.cpp (setInterfaceTypes): see #2224 "FreeBSD - Bridge
	interfaces with the name vlan<xx> don't show as Bridge Port
	Interfaces". This actually applies to all OS where we support vlan
	and bridge interfaces. Fwbuilder GUI should allow the user to set
	subinterface type to both "ethernet" and "vlan" when its parent
	interface has type "bridge". Setting subinterface type to
	"ethernet" makes it bridge port, while setting the type to "vlan"
	signals policy compiler that it should generate code to configure
	real vlan interface. If the name of the subinterface does not
	include the name of the parent, such as "vlan101", or when the
	name does not match vlan ID, such as "vlan8101", global
	preferences option "Verify interface names and autoconfigure their
	parameters..." should turned off. The option is located in the
	Preferences dialog, tab "Objects".

2011-04-08  vadim  <vadim@netcitadel.com>

	* FWBSettings.cpp (init): fixed bug (no #): "Show text
	description in rule columns" does not persist across sessions

	* clusterMembersDialog.cpp (createMember): see SF bug 3211769
	"Member interfaces not sorted". Sorting interfaces by name in the
	dialog where user adds them to the cluster member group.

	* os/ios.xml: see #2330 "Crash when creating a cluster of IOS
	router firewalls". Added support for basic IOS router clusters.
	No failover protocol support at this time, but the cluster can be
	configured with protocol "None" and fwbuilder will do address
	substitutions at compile time.

	* PolicyCompiler_cisco.cpp (processNext): see #2308 "ASA rules
	with service set to "http" and destination set to asa firewall
	object should generate different command syntax". Policy rules
	that have firewall object in Destination and http object in
	Service now generate "http" commands. This is similar to how
	fwbuilder generates "ssh", "telnet" and "icmp" commands to permit
	corresponding services to the firewall itself.

	* pix.g (static_starts_with_tcp_udp): more fixes for import of
	PIX/ASA "static" command in different variations. See #2334

	* ObjectEditor.cpp (changed): see #2335 "GUI switches between data
	files upon closing editor panel". If user opened two data files in
	the GUI and was in the process of editing objects in one of them,
	the GUI would flip to the other file under certin circumstances.

2011-04-07  vadim  <vadim@netcitadel.com>

	* PIXImporterNat.cpp (buildDNATRule): resolved several problems
	with import of "static" commands that use access list that matches
	source or destination tcp/udp ports. See #2326, #2327

	* pix.g (network_top_level_command): see #2295 fixes in the grammar
	to support import of FWSM configs

	* PIXImporter.cpp (fixServiceObjectUsedForBothSrcAndDstPorts):
	see #2265 "ASA 8.3 acl import: access-list commands using two
	named objects or object-groups", see #2290 "Access lists that
	include mix of service objects and inline service definitions are
	not properly imported". To import access-list command that matches
	both source and destination tcp/udp ports and uses object-group in
	either match I should create a new service group with a collection
	of TCP or UDP service objects matching all combinations of source
	and destination port ranges defined by the rule. This should work
	when one or both matches use object-group in combination with
	inline port match.

	* PIXImporter.cpp (pushPolicyRule): see #2297 Added warning when
	importer enounters access-list command that matches tcp or udp
	ports with "neq" port operators in both source and
	destination. This configuration is not supported by import at this
	time.

	* PIXImporterNat.cpp (buildSNATRule): see #2319 "Imported nat
	rules with multi-line access-lists have only the first entry"

	* PIXImporterRun.cpp (run): see #2167 Implemented import of
	"names" and "name" commands in PIX/ASA configs.

	* CompilerDriver_pix_run.cpp (pixNetworkZoneChecks): see SF bug
	3213019 "FWSM Network zone and IPv6". Currently we do not support
	ipv6 with PIX/ASA and FWSM. If user creates a group to be used as
	network zone object and places ipv6 address in it, this address
	should be ignored while compiling the policy but this should not
	be an error.

	* FirewallInstaller.cpp (executeExternalInstallScript): see SF bug
	3212988 "external script makes getopt difficult". User-defined
	parameters for the external script moved to the end of the command
	line.

	* res/os/fwsm_os.xml: updated filesystem path on FWSM where
	fwbuilder built-in installer should place generated configuration
	when it is installed using scp. Currently using path "disk:".

2011-04-05  vadim  <vadim@netcitadel.com>

	* pix.g (static_command_common_last_parameters): see #2314 "Import
	of static NAT statements drops netmask value and uses host
	instead".  "Netmask" parameter of a "static" command applies to
	the real address.

	* PIXImporterNat.cpp (buildDNATRule): see #2313 "NAT with
	access-list destination address and original service not set".
	"Nat" and "static" commands that use access-list should import all
	components of the access-list command (source, destination and
	service/protocol).

	* PIXImporterNat.cpp (buildSNATRule): see #2310 "Imported global /
	nat rule has wrong interface defined". Importer mixed up inbound
	and outbound interfaces in NAT commands created from combination
	of "global" and "nat" PIX/ASA commands.

	* pix.g (nat_new_top_level_command): since import of ASA8.3
	"new" nat commands is not implemented yet, importer should issue
	a warning when such command is encountered. See #2315

2011-04-01  vadim  <vadim@netcitadel.com>

	* FWObject.cpp (insert_before): see #2171 "Undoing delete of rule
	ends up with rules being created with duplicate rule
	numbers". Also see #2172 "Crash when deleting rule - related to
	#2171". When user deleted the last rule in a rule set, then used
	Undo to restore it, the program lost track of rules in the rule
	set and became unstable.

	* FWObject.cpp (shallowDuplicate): see #2286 "Crash when closing
	file". The GUI crashed if user imported iptables or pix
	configuration, then deleted a rule and tried to close project
	window.

	* PIXImporter.cpp (mirrorServiceObjectRecursively): see #2291 The
	same service object-group that matches some tcp or udp ports can
	be used to match both source and destination ports in an
	access-list command. Importer should recognize when such group
	is used to match source ports and create mirrored group with
	potentially mirrored service objects. This should work when group
	includes other groups.

	* FWWindow_editor.cpp (openOptEditor): fixes #2307 "GUI switches
	to another file after editor panel is closed"

2011-03-31  vadim  <vadim@netcitadel.com>

	* parsers/pix.g (http_command): see #2164 fixed import of "ssh"
	commands and added import of "http" commands

	* objectMaker.h (ObjectMakerErrorTracker): see #2302 Importer
	should log and continue when it encounters an error. This matches
	its behavior in older versions and makes it more resilient to
	changes in target platform firewall languages. Rule that had an
	error or unrecognized syntax in it should be marked by changing
	its color to red and an explanation should be added to its
	comment.

	* PIXImporterNat.cpp (buildSNATRule): import of PIX/ASA "global"
	and "nat" commands works.

2011-03-30  vadim  <vadim@netcitadel.com>

	* PIXImporterNat.cpp (buildDNATRule): import of PIX/ASA "static"
	commands works for the most part. Needs more testing.

2011-03-28  vadim  <vadim@netcitadel.com>

	* ObjectManipulator.cpp (getDeleteMenuState): see #2226 fixed GUI
	crash that happened when user tried to delete or cut an object
	from locked library.

	* RuleOptionsDialog.cpp (loadFWObject): see #2230 the GUI should
	allow limit-burst values of up to 10000

2011-03-27  vadim  <vadim@netcitadel.com>

	* import/PIXImporter.cpp (addLogging): see #2279 Support for import
	of ASA access-list lines with log levels and intervals

	* parsers/pix.g (tcp_udp_port_spec): see #2284 fixed import of
	tcp/udp port ranges using mix of port numbers and port names

	* getServByName.cpp (getPortByName): see #2268 Making sure all tcp
	and udp port names are recognized on import; also since PIX/ASA
	converts udp port numbersin "show run" output to the same names
	as if they were tcp, using the same name mapping table.

2011-03-25  vadim  <vadim@netcitadel.com>

	* Importer.cpp (pushRule): fixes #2280 Rules created from PIX
	config import showed an icon that indicated non-default
	combination of rule options, yet all rule options looked normal
	when opened in the editor.

	* parsers/pix.g (icmp_top_level_command): see #2164 Implemented
	import of "ssh", "telnet" and "icmp" PIX/ASA commands. These
	commands are imported as regular rules in the main Policy ruleset.

	* PIXImporter.cpp (finalize): see #2277 "Create policy objects for
	ASA access-lists that are not applied in an access-group". Policy
	rule set will be created and populated with rules found in the
	corresponding access-list even if this access-list is not applied
	to an interface with access-group command.

	* parsers/pix.g (tcp_udp_rule_extended): see #2273 Improvements in
	the parser for PIX/ASA configs to make it recognize object-group
	and named object names used to define source port, destination
	address or destination port in "access-list ... tcp|udp" rules,
	including ambiguous situation when an object-group appears after
	source address specification because this group can define either
	source port or destination address.

2011-03-24  vadim  <vadim@netcitadel.com>

	* ASA8ObjectGroup.cpp: see #2263 looks like "object-group service"
	that includes named objects defined as "service-object" can not be
	used in access-list commands and therefore is useless. Unless I
	misunderstood and there is a way to use it, I should not generate
	ASA configuration like this:

        object-group service id5102X14531.srv.tcp.0 tcp
          service-object object http.0
          service-object object https.0

	Object-group with "tcp" or "udp" type-suffix in the end does not
	allow "service-object" statements at all, so this configuration
	is incorrect anyway. However even without "tcp" in the end to
	make "service-object" references acceptable, the group can be built
	but can not be used in access-list statements.

	Instead, the group should use port-object statements:

	object-group service id5102X14531.srv.tcp.0 tcp
	  port-object eq 80
	  port-object eq 443

	* IOSImporter.cpp (createTCPUDPServicePair): see #2267 added
	support for import of object-group and service-object statements
	of type "tcp-udp" (these get imported as service group object with
	two tcp and udp service objects).

	* getServByName.cpp (getPortByName): see #2268 updated list of
	named tcp and udp ports recognized by the importer for Cisco ASA.
	It is still unclear what port does the name "cifs" correspond to.

2011-03-23  vadim  <vadim@netcitadel.com>

	* addressObjectMaker.cpp (createObject): see #1548 Improved
	algorithm used to deduplicate Network objects on import.

	* FWWindow.cpp (prepareToolsMenu): fixed SF bug 3238026: build
	failure on systems without net-snmp development libraries.

2011-03-22  vadim  <vadim@netcitadel.com>

	* parsers/pix.g (acl_xoperator_src): first attempt at PIX/ASA
	access-list import. Not done yet.

	* parsers/pix.g (port_object): see #2234 added support for import
	of "obejct-group service name tcp|udp" constructs in ASA 8.3 with
	subsequent "port-object" statements.

2011-03-21  vadim  <vadim@netcitadel.com>

	* PortRangeConverter.h (PortRangeConverter): see #2252 TCP and UDP
	service objects that define port ranges assume port ranges are
	inclusive, that is, range boundaries are included in the
	match. This is the behavior of port range matches in iptables and
	PF, however policy compilers for Cisco IOS ACL and PIX used to
	convert these objects into ios and pix access list configurations
	that excluded port range boundaries from the match. This behavior
	made TCP and UDP service objects with port ranges incompatible
	between firewall platforms, that is, the same object could not be
	used in rules of firewall objects of different platforms because
	generated configurations would behave differently. This change
	makes port ranges inclusive in generated IOS and PIX
	configurations. Users should verify their configurations and
	adjust port range boundaries in TCP and UDP service objects if
	necessary.

2011-03-20  vadim  <vadim@netcitadel.com>

	* ImportFirewallConfigurationWizard.cpp (accept): see #2253
	"importer should not creates objects while still in the middle of
	the wizard". Importer wizard creates new objects in the object
	tree only when user clicks Finish and abandons results if they
	click Cancel.

2011-03-19  vadim  <vadim@netcitadel.com>

	* IOSImporter.cpp (createTCPUDPNeqObject): see #2248 implemented
	import of Cisco IOS and PIX/ASA service configurations using port
	operation "neq". Since object model in fwbuilder does not provide
	direct support for "port not equal to" expression, this
	configuration is conveted into two tcp or udp service objects with
	port range extending below and above specified port and these two
	service objects are then placed in a group.

	* objectMaker.cpp (findMatchingObject): see #2240 better
	deduplication algorithm on import: we consider objects created
	from in-line address/netmask and port specifications found inside
	object-group, access-list, filter or nat commands "anonymous"
	objects. These objects get automatically generated names and are
	deduplicated using only their relevant attributes but not names.
	Objects created from pix named object ("object network foo",
	"object service bar") statements are considered "named"
	objects. They get the name matching the name in corresponding pix
	config line and are deduplicated using both relevant attributes
	and the name.

2011-03-17  vadim  <vadim@netcitadel.com>

	* PIXImporter.cpp (newObjectGroupNetwork): see #2234 Added support
	for import of PIX/ASA "object-group" statements.

	* FirewallInstaller.cpp (getActivationCmd): see #2239 Added
	variable "firewall_name" to configlets that define commands
	installer runs on the firewall to activate new policy (all
	platforms).

2011-03-16  vadim  <vadim@netcitadel.com>

	* Importer.cpp (prepareForDeduplication): fixed #1548 "Object
	de-duplication during import process". Also SourceForge 3030072
	"remove duplicates during any import". Now the program can
	optionally re-use existing objects from both Standard Objects and
	user-defined libraries when it imports existing firewall
	configuration. This works for any firewall platform for which we
	support policy import. Objects are matched by attributes such as
	address, netmask, port etc. Object name and comment are not taken
	into account. Importing the same configuration file twice creates
	two firewall objects with the same interfaces and rules but
	re-uses address and service objects created on the first import.

2011-03-14  vadim  <vadim@netcitadel.com>

	* pix.g (named_object_network): see #2223 Implemented import of
	named objects for Cisco PIX and ASA ("object network name" and
	"object service name")

2011-03-12  vadim  <vadim@netcitadel.com>

	* Compiler.cpp (expandGroupsInRuleElement): sorting objects in the
	rule element by name after group is expanded, this helps ensure
	stable ordering of objects in generated configuration.

	* Compiler.cpp (replaceClusterInterfaceInItfRE::processNext):
	sorting objects in rule element after cluster interfaces have been
	replaced, this helps ensure stable ordering of objects in generated
	configuration.

	* FWObject.h (FWObjectNameCmpPredicate): moved this class from
	gui-specific module to libfwbuilder as it is universally useful.
	It can compare FWObject objects by name and can optionally can
	follow references; it can be used with std::sort() to sort lists
	of FWObject pointers or directly sort rule elements.

	* Compiler.cpp (_init): see #2212 "Performance improvement in
	compilers". This change brings significant improvement in compile
	time on large object trees. The speed-up is especially noticeable
	in single rule compile where the time before generated firewall
	configuration appears in the GUI shrank by up to a factor of 10.

2011-03-11  vadim  <vadim@netcitadel.com>

	* FWObject.cpp (add): fixes #2209 "do not allow the same object to
	be child of different objects in the tree". Method FWObject::add()
	enforces this. Subsequent clean-up and fixes in many places to
	follow this logic. This makes code much cleaner, better organized
	and more reliable.

2011-03-10  vadim  <vadim@netcitadel.com>

	* libfwbuilder/src/fwcompiler/Compiler.cpp (Compiler): see #2207
	fixed memory leak in policy compilers. The impact of this leak was
	especially severe on Windows with very large object databases.

2011-03-08  vadim  <vadim@netcitadel.com>

	* CustomServiceDialog.cpp (loadFWObject): fixes #2201 "Some fields
	of locked object are editable". Some input fields of the Custom
	Service object dialog were editable even when object was locked
	read-only.

	* GroupObjectDialog.cpp (loadFWObject): fixes #2203 "Crash when
	attempting to add an object to a locked group".

	* PolicyCompiler.cpp (checkForShadowing): see #2204 "Shadowing
	detected for rule with action Continue". Policy rules with action
	"Continue" should not shadow other rules and can not be shadowed.

	* Importer.cpp (addStandardRuleComment): see #2189 Program adds
	the file name and the line number to comments of policy and nat
	rules it creates during import.

	* IPTImporter.cpp (pushPolicyRule): see #2202 importer for
	iptables creates Custom Service object to match combination of
	states it does not recognize. This includes "NEW,ESTABLISHED".

2011-03-07  vadim  <vadim@netcitadel.com>

	* IPTImporter.cpp (pushNATRule): see #2197 "iptables nat rules in
	chain OUTPUT not imported correctly"

	* iptables.g (nat_addr_range): see #2194 "iptables import problem
	with SNAT rule translating to an address range". NAT rules
	translating into address range with "-j SNAT --to-source
	192.168.1.1-192.168.1.10" did not import correctly

	* IPTImporter.cpp (pushNATRule): fixes #2195 "incorrect iptables
	import of nat rule with NETMAP target"

	* IPTImporter.cpp (pushNATRule): see #2196 "iptables nat rules
	with target REDIRECT not imported". Iptables NAT rules with target
	REDIRECT where not imported correctly.

	* IPTImporter.cpp (pushNATRule): see #2190 "support for import of
	branches in NAT rules for iptables". Implemented import of NAT
	rules in user-defined chains for iptables, these translate into
	branching NAT rules in fwbuilder.

2011-03-06  vadim  <vadim@netcitadel.com>

	* Importer.cpp (ignoreCurrentInterface): see #2152 "ASA Import -
	shutdown interfaces". Importer recognizes and skips ASA interfaces
	in "shutdown" mode.

	* IPTImporter.cpp (pushNATRule): see #2181 "Update iptables
	importer to detect inbound & outbound interfaces in NAT rules".
	Importer can now import nat rules with "-i" or "-o" interface spec.

	* NATCompiler_ipt.cpp (processNext): see #2170 "Compiler should
	generate error for invalid iptables NAT configs". Now that we
	allow the user to specify inbound and outbound interfaces in
	iptables NAT rules, compiler should verify that combination of
	requested "-i" and "-o" interfaces is in fact valid. For example
	iptables does not allow "-o" interface spec with rules that go
	into PREROUTING chain (DNAT rules) or "-i" interface spec with
	rules in POSTROUTING chain (SNAT rules).

	* IPTImporter.cpp (pushPolicyRule): see #2189 Policy importer
	warnings and errors now include line numbers to help find relevant
	lines in the original configuration file.

2011-03-05  vadim  <vadim@netcitadel.com>

	* importFirewallConfigurationWizard/IC_ProgressPage.cpp (logLine):
	see #2183 "count errors and warnings generated by the importer and
	show the numbers in the progress page of the wizard". Configuration
	import wizard now shows counters of warnings and errors generated
	by the importer.

	* FWBMainWindow_q.ui: see #2162 menu item "File / Import Policy"
	renamed to "File / Import Firewall". This menu item launches
	wizard that imports existing iptables, Cisco router IOS or
	Cisco PIX/ASA config.

2011-03-04  vadim  <vadim@netcitadel.com>

	* IC_NetworkZonesPage.cpp (setNetworkZones): see #2161 policy
	import wizard shows the page where user can set up network zones
	of interfaces if firewall platform was determined to be PIX.

	* IC_PlatformWarningPage.cpp (initializePage): see #2161 "import
	workflow and automatic detection of firewall platform from the
	config file". When user imports existing firewall configuration,
	the GUI automatically detects firewall platform from the format
	of the config file and shows platform-specific warning to explain
	what parts of the config can and can not be imported. It also
	detects firewall host name where possible (currently Cisco IOS
	and ASA/PIX). Importer wizard has been reimplemented using
	QWizard and QWizardPage classes and its workflow significantly
	improved.

2011-03-01  vadim  <vadim@netcitadel.com>

	* importAddressListWizard/ImportAddressListWizard.cpp
	(ImportAddressListWizard): see #2163 code that imports addresses
	from a file in /etc/hosts format moved to its own wizard; using
	QWizard and QWizardPage classes with correct implementation of
	page sequencing and validation; old discovery druid has been
	disabled. SNMP discovery and ios/pix/iptables configuration import
	will move to their own wizards later.

2011-02-27  vadim  <vadim@netcitadel.com>

	* DiscoveryDruid.cpp (finishClicked): fixes #2156 "After import
	the firewall should be opened in object tree".

	* instDialog_ui_ops.cpp (readInstallerOptionsFromFirewallObject):
	fixes #2160 "Installer reports error "Generated script file
	<firewall>.fw not found."". The problem was intorduced earlier
	while fixing #2047

2011-02-26  vadim  <vadim@netcitadel.com>

	* DiscoveryDruid.cpp (finishClicked): see #2153 "Add Network Zone
	explanation and selection dialog to ASA/PIX import". Wizard shows
	additional page when user imports PIX/ASA config. This page
	explains concept of network zones and offers UI to let them choose
	network objects or groups as a network zone of each interface.

	* PIXImporter.cpp (rearrangeVlanInterfaces): see #2145 "ASA Import
	of VLAN interfaces - Advanced Interface Settings not available".
	Vlan interfaces discovered in the process of PIX configuration
	import should be created as subinterfaces of the corresponding
	parent with correct interface type and vlan id.

	* parsers/pix.g (intf_address): fixes #2146 Issue a warning when
	parser encounters "standby" parameter in an interface
	configuration. We do not support import of PIX failover
	configuration at this time.

	* platforms.cpp (findBestVersionMatch): fixes #2147 "ASA Import -
	some versions are not detected correctly". when user imports
	PIX/ASA configuration, firewall object will automatically be
	configured with the version setting that best fits version
	indicated in the imported configuration. Note that fwbuilder does
	not provide the list of version numbers that match PIX/ASA
	versions exactly, for example we do not have settings "7.1" and
	"7.2". Devices running these versions of PIX/ASA software should
	be configured with version "7.0" in fwbuilder.

2011-02-25  vadim  <vadim@netcitadel.com>

	* parsers/pix.g (intf_address): see #87 "Import of PIX
	configuration".  Basic grammar that can parse host name, version,
	interfaces, their names, labels, addresses, security levels and
	few other things for PIX 6, 7 and ASA 8. PIX standby configuration
	is not parsed (so we can't import cluster configuration at this
	time). More work needs to be done to import named objects, object
	groups, as well as policy and nat rules.

2011-02-24  Vadim Kurland  <vadim@netcitadel.com>

	* FirewallInstaller.cpp (getGeneratedFileName): see #2047 "Inspect
	generated files button shows different path information". Do not
	pass full path to the output file as an argument of the "-o"
	option when the GUI launches policy compiler. Since the "-d"
	option passes directory path where files sould be saved, actual
	file names do not need to be absolute path, except if the user
	entered absolute path for the output file name in the firewall
	settings dialog.

	* configlets/freebsd/installer_commands_root: see #2143 "installer
	should run /etc/rc.d/pf script to reload PF rules on FreeBSD when
	generated script is in rc.conf format"

	* AddressTableDialog.cpp (browse): see #2140 "Attempting to create
	new Address Table file results in read-only error". Implemented
	support for the workflow when user wants to create the file used
	to feed addresses to the AddressTable object.

	* AddressTableEditor.cpp (load): fixes #2139 "Provide "Cancel"
	button if Address Table file is read-only". IF the file configured
	with Address Table object is read-only, the GUI shows warning when
	user clicks "Edit" button and offers a choice: open it for viewing
	read-only or cancel.

2011-02-23  vadim  <vadim@netcitadel.com>

	* AddressTableEditor.cpp (save): fixes #2135 "Editing table
	objects".  Dialog of the AddressTable object now offers button
	"Edit" that lets the user edit address table file. This only
	works if the file is located on the same machine where the GUI
	is running, so it is probably most useful for compile time
	objects.

2011-02-22  Vadim Kurland  <vadim@netcitadel.com>

	* configlets/linux24/shell_functions: see #2130 "unnecessary
	output when iptables script runs on the firewall". Ever since I
	switched to using "command" to verify that various system
	utilities generated script needs are present and can be used, the
	scirpt produced extra lines in the log printing full path and
	names to /usr/bin/logger, /sbin/ip etc. These lines are
	unnecessary and should not be there. This problem was introduced
	some time during the work on 4.2.0

	* instOptionsDialog.cpp (instOptionsDialog): fixes #2129
	'deprecate "test install" function'. We have decided to deprecate
	test install because it is rather heavy-handed on Linux and PIX
	where it reboots the firewall and plain does not work on *BSD.

2011-02-21  vadim  <vadim@netcitadel.com>

	* PolicyCompiler_ipt.cpp (processNext): fixes #2008 "option
	"--physdev-out" is not allowed in OUTPUT chain". After this
	change, compiler avoids INPUT/OUTPUT chain if interface in the
	rule column "Interface" is a bridge port and firewall is bridging
	firewall (which means we are going to use --physdev-in or
	--physdev-out option for this rule).

	* newFirewallDialog.cpp (monitor): see #2126 Using snmp sysDescr
	OID to guess version of the new firewall when it is created using
	snmp polling.

	* platform/pix.xml: see #1990 "Change default value for Cisco
	ASA/PIX 7+ to generate outbound ACLs". Newly created PIX/ASA
	firewall objects will now have "generate outbound acl" option
	turned on by default.

	* newFirewallDialog.cpp (showPage): fixes #1678 "When creating a
	firewall from template it appears that a default template is
	selected". When user arrives at the page where they choose
	template to create new firewall object from, the first template
	should be automatically selected.

	* AddressRangeDialog.cpp (applyChanges): fixes #1971 "Address
	range can be created with end address lower than start address".
	Address Range object dialog should not let the user enter range
	end address which is lower than range start address. Dialog
	behavior is now similar to the behavior of the tcp and udp service
	dialog where user can not enter port range end number lower than
	port range start number.

	* InterfaceData.cpp (guessLabel): fixes #2113 "ASA/PIX SNMP
	discovery - assign default labels based on interface description".
	Added pattern to match Cisco ASA interface description which is
	different from Cisco PIX interface descriptions as returned via
	snmp.

2011-02-20  vadim  <vadim@netcitadel.com>

	* BaseCompiler.cpp (getErrorsForRule): fixes #2124 "some error
	messages get multiplied when compiler splits rules". Under certain
	circumstances error messages could appear multiple times in the
	generated script.

	* Compiler.cpp (_expand_interface): fixes #1920 "Setting host
	interface to unnumbered after it has been assigned IP address
	doesn't have desired effect". Compiler still used ip addresses
	that belonged to the interface even if it switchd to "unnumbered".
	These children address objects should be ignored.

2011-02-19  vadim  <vadim@netcitadel.com>

	* NATCompiler_pix.cpp (processNext): see #2098 Added support for
	user-configurable inbound and outbound interfaces in Cisco PIX/ASA
	NAT rules. Two new columns appear in the rule set view: "Inbound
	Interface" and "Outbound Interface". If user leaves one or both
	columns blank, the GUI shows "Auto" in there and policy compiler
	picks corresponding interface automatically. Leaving both columns
	blank ("Auto") triggers backwards-compatible automatic behavior
	where both interfaces are picked automatically. Multiple interface
	objects and groups of interfaces are allowed in these columns.

	* ClusterInterfaceWidget.cpp (getInterfaceData): fixes #2117 "CARP
	interfaces in cluster that use VLAN interaces have no interface
	set to MASTER". When PF cluster configuration was built using vlan
	interfaces of member firewalls, CARP interfaces were not properly
	configured with master/slave choice user makes on the first page
	of the new cluster wizard.

	* configlets/bsd/update_addresses: fixes #2116 "When CARP
	interface IP address can't be assigned error or warning should
	appear". The problem actually affects any type of interface.
	Generated script should abort with an error termination code
	when ifconfig fails to assign ip address to an interface.

2011-02-17  vadim  <vadim@netcitadel.com>

	* NATCompiler_ipt.cpp (processNext): see #2097 #133 "support for
	inbound and outbound interface columns in iptables NAT
	rules". This also addresses SF feature requests 1954286 "DNAT with
	interface as condition not possible" and 621023 "manipulating
	interface in NAT rule".

	* platforms.cpp (setDefaultFailoverGroupAttributes): fixes #2101
	"CARP interfaces are set with same advskew". When new PF cluster
	is created, master advskew paramerer will be set to 10 and backup
	to 20 to make it deterministic.

	* NATCompiler_ipf.cpp (processNext): see #133, fixes #2108 making
	nat compiler for ipfilter work with interface column, however the
	column is not exposed to the user. Compiler behavior should be
	backwards compatible with older versions of fwbuilder.

	* NATCompiler_pf.cpp (processNext): see #133. MErged code from the
	branch, running tests. Making sure rules that have firewall
	object in ODst and interface columnblank end up with rdr command
	without "on interface" clause as before.

	* stopped making builds on Ubuntu Hardy. Old Qt (4.4.1) means more
	and more parts of the code do not compile and require workarounds,
	sometimes with loss of functionality in the GUI. v4.1.3 will be
	the last officially released version of fwbuilder to work on
	Hardy.

2011-02-16  vadim  <vadim@netcitadel.com>

	* NATCompiler_pf.cpp (compile): fixes #2095 added support for
	groups and multiple objects in column "Interface" for PF NAT
	rules. These translate into { em0 em1 em2 } groups in generated
	pf.conf lines.

	* NATCompiler_pf.cpp (compile): fixes #2096 added support for
	negation in Interface column for PF NAT rules. Sets of interfaces
	are converted to complementary sets using complete list of
	interfaces of the firewall.

	* carpOptionsDialog.cpp (validate): fixes #2100 carp password
	should be optional parameter

	* OSConfigurator_bsd_interfaces.cpp (configureInterfaces): make
	sure we print "ifconfig" commands for mtu and other parameters for
	all interfaces, including those with no ip addresses and bridge
	ports (unnumbered interfaces used to be skipped before)

	* ObjectTreeView.cpp (startDrag): fixes #2099 "Object list scrolls
	up to the last edited object". Object tree used to scroll
	spontaneously when user started dragging an object from it to a
	rule.

	* configlets/bsd/update_vlans: see #2105: generated script now
	supports vlan interfaces with names that do not match vlan IDs
	(OpenBSD, FreeBSD, shell script format).

	* OSConfigurator_bsd_interfaces.cpp (sort_interface_names): see
	#1807, #2104: arrange interface configuration commands in the
	generated scritpt in such order that bridge and carp interfaces
	are configured after all other interfaces are done.

	* compiler_lib/CompilerDriver.cpp (commonChecks2): see #2103
	removed interface name validation check in compilers, this
	check will only be done in the GUI. Comiler still verifies
	bridge inetrface configuration and makes sure vlan interfaces
	that should also be bridge ports are created as copies.

	* InterfaceDialog.cpp (applyChanges): see #2103 "complex
	vlan/bridge configurations are not supported by the interface
	validation code". Added checkbox to let the user turn off
	interface name validation functions in the GUI. Checkbox is
	located in the global Preferences dialog, tab Objects, subtab
	Interface. For backwards compatibility, the checkbox is turned on
	by default. When it is off, the GUI does not validate the name of
	inetrfaces and subinterfaces and turns off checks that enforced
	interface name patterns for VLAN, bridge and bodning interfaces.
	It also turns off check for the validity of vlan ID derived from
	vlan interface name and turns off automatic configuration of
	interface type and vlan ID. These checks sometimes were in the way
	of building complex configurations that involved multiple vlan
	interfaces with names not matching their IDs. This also fixes SF
	bug #3066714 "please dont stop me from creating a new interface"
	where user wanted to create interface "veth201.0" on Linux but the
	GUI blocked this operation because the name seemed to match vlan
	interface pattern.

2011-02-15  vadim  <vadim@netcitadel.com>

	* ActionsDialog.cpp (setRule): see #1871 "PF Actions Tag and
	Classify can be terminating or non-terminating". Added checkbox to
	the action properties dialog for actions Tag and Classify for PF
	that lets the user choose if these actions should be terminating
	or not. Old behavior (Tag was non-terminating and Classify was
	terminating) is reflected in default settings of the checkboxes.
	Terminating rules generate "pass quick" commands, while
	non-terminating rules generate "pass" commands (no "quick" option).

	* libfwbuilder/migration/FWObjectDatabase_17.xslt: see #133
	Working on adding interfaces to the NAT rule model. There will be
	two inetrfaces per NAT rule: "inbound interface" and "outbound
	interface". DTD version changes to "18", old data files need to
	be upgraded.

2011-02-14  vadim  <vadim@netcitadel.com>

	* OSConfigurator_bsd_interfaces.cpp (configureInterfaces): fixes
	#2091 "ethernet intrface options a used twice if the interface is
	a bridge port". When an interface appeared twice in the firewall
	configuration, such as when it is used as a  bridge port and
	vlan parent interface, options configured for it in its settings
	dialog were added twice to the generated configuration.

	* OSConfigurator_freebsd.cpp (interfaceConfigLineBridge): fixes
	#2092 "option "stp" should be optional in the ifconfig command
	that builds bridge interface for FreeBSD". The dialog provides
	checkbox "Enable STP", parameter "stp" will be added to the
	ifconfig command only when the checkbox is turned on.

	* pfAdvancedDialog.cpp (pfAdvancedDialog): fixes #1866 "support
	for pf option set state-policy", #1868 "support for pf
	option set block-policy", #1869 "support for pf option set debug".

2011-02-13  vadim  <vadim@netcitadel.com>

	* configlets/freebsd/carp_interface: see #2074 On FreeBSD ifconfig
	does not understand parameter carpdev

	* PolicyCompiler_pf.cpp (checkForShadowingPlatformSpecific): see
	#1867 "PF: rule with non-terminating action Tag shadows other
	rules below it". Since action Tag is non-terminating, rules with
	this action should not shadow other rules.

	* instConf.cpp (clear): see #2088 "Installer caches putty session".
	Need to initialize putty_session properly and clear it in clear().

	* snmp.cpp (run_impl): See #2084 "snmp discovery takes forever on
	devices with large routing tables". This takes very long time on
	decides with large routing tables. This code was implemented long
	time ago and apparently routing data was intended to be used to
	discover "external" interfaces, but it is unclear if this is still
	done. The concept of external/internal currently exists only for
	platforms that support security levels (PIX) and there we guess
	levels by matching addresses against RFC1918 and let the user user
	adjust levels manually anyway.

2011-02-12  vadim  <vadim@netcitadel.com>

	* ObjectManipulator_tree_ops.cpp (expandOrCollapseCurrentTreeNode):
	fixes #1895 "Add context menu option to expand all child nodes in
	object tree". Added menu item "Expand" to the context menu
	associated with all objects in the object tree. This item recursively
	expands all tree nodes under the given object and automatically
	changes to "Collapse" if the item is expanded. Also changed behavior
	of the double click on the object in tree: before, double click
	opened object in the editor and expanded or collapsed subtree. Now
	it only opens object in the editor but does not expand/collapse
	subtree.

	* fixes #2083 Added new services to the Standard Objects Library:
	rtmp, xmpp-client, xmpp-server, nrpe

2011-02-11  vadim  <vadim@netcitadel.com>

	* instDialog_ui_ops.cpp (verifyManagementAddress): see #2073 "Add
	additional information or workflow when no management inferface
	configured". The error message shown to the user when no
	interfaces has been marked as "management" is now more verbose and
	provides instructions how to do this. Also, if user provided
	alternative address to be used to communicate with the firewall,
	the check for the management interface is not performed since it
	is not needed.

	* configlets/bsd/update_carp: see #2078 added verbose error
	message in a situation when "ifconfig carp0 create" command fails
	to create CARP interface.

	* OSConfigurator_bsd_interfaces.cpp (interfaceIfconfigLine): fixes
	#2058 "Ability to configure mtu and metric of regular inetrfaces".
	"Advanced settings" dialog of the interface object provides
	controls to configure MTU and possibly add any additional ifconfig
	parameters. This is available for OpenBSD and FreeBSD.

2011-02-10  vadim  <vadim@netcitadel.com>

	* NamedObjectsManagerPIX.cpp (getClearCommands): fixes #2060
	"Existing configuration objects are not cleared in PIX 6.3".
	Commands used to clear object groups and objects have different
	syntax in PIX 6.3 and PIX 7 and later.

	* linux24/check_utilities: fixes #1999 "log() does not work" Using
	built-in utitlity "command" to verify that all the tools generated
	script needs to function properly are available and can be
	accessed either via direct full path or are in the PATH
	variable. This includes the check for the logger tool that is used
	to make log record when firewall is activated.

	* OSConfigurator_freebsd.cpp (interfaceConfigLineVlan): fixes #2071
	"vlandev missing in the vlan definition (when using rc.conf.local )"

	* NATCompiler_ipt.cpp (getAddressTableVarName): fixed SF bug
	#3102044 "Colon in (runtime) Address Table name". Variable used to
	process addresses in the run-time address table should not use
	character ":" even if it appears in the Address Table object name.

	* instDialog_ui_ops.cpp (summary): fixed SF bug 3169045: "Batch
	installer lists IPv4 address as management address". The "summary"
	display in the installer progress log output will now show putty
	session name if it is used instead of the management address.

	* NATCompiler_pf.cpp (processNext): fixes #2069 "PF: allow
	multiple objects in ODst of redirecting nat rule". This fixes SF
	bug 3162862 "NAT - more than one object in original destination"

	* newFirewallDialog_from_template.cpp (replaceReferencesToNetworks):
	fixes #1979 "New firewall created with Cisco c36xx template
	results in network object in interface column in Policy"

	* ObjectManipulator_tree_ops.cpp (getTreeLabel): fixes #2067 "Add
	way to show interface label in object tree". The tree now shows
	interface name and label if the label is not empty.

	* configlets/bsd/update_vlans: fixes #2066 "Existing VLAN
	interfaces are not properly removed from FreeBSD and install
	script fails"

2011-02-09  Vadim Kurland  <vadim@netcitadel.com>

	* RuleSetView.cpp (showToolTip): fixes #1915 "tooltip shown when
	mouse is over rule number should be added to the list of
	suppressed tooltips when 'Advanced user mode' is in effect"

	* platforms.cpp (setDefaultFailoverGroupAttributes): fixes #2064
	"CARP interfaces are not properly installed on FreeBSD cluster".
	I need to populate failover group objects with some reasonable
	defaults when they are created.

	* configlets/freebsd/installer_commands_root: fixes #2065
	"activation commands on FreeBSD and OpenBSD lose script exit
	status". Sequence of commands ran by the built-in installer on
	*BSD firewalls were losing exit status of the script which meant
	installer always declared installation a "success" even when
	there were errors.

2011-02-08  vadim  <vadim@netcitadel.com>

	* SSHUnx.cpp (SSHUnx): fixes #2061 "Installer shows success for
	failed installed on FreeBSD due to corrupt script file". Added
	bunch of common shell error messages to make sure installer
	recognizes them and mark install as a failure even if ssh fails
	to pass termination code.

	* instDialog.cpp (showPage): fixes #2037 "If there is an error
	when compiling firewall then installer should be
	aborted". Compile/install wizard should disable "Next" button
	after compile phase is done if all firewalls failed to compile
	with no errors.

	* configlets/bsd/update_bridge: fixes #2042 "add configlet and
	shell functions to manage bridge interfaces via shell script on
	OpenBSD and FreeBSD". Bridge interfaces are managed incrementally,
	that is, the script creates and destroys them as needed, then adds
	or removes bridge ports, to bring bridge configuration in sync
	with what is defined in fwbuilder GUI.

	* CompilerDriver_pf_run.cpp (run): fixes #2054 "Add support for
	load anchor PF command". Instead of loading anchors using "pfctl
	-a anchor -f file" command in the .fw initialization script, now
	generated PF configuration uses "load anchor" commands in the
	pf.conf file. This way, we can load anchors correctly when PF
	configuration is activated from the generated rc.conf.local file
	where only one pf.conf file can be referenced.

2011-02-07  Vadim Kurland  <vadim@netcitadel.com>

	* CompilerDriver_pix_run.cpp (run): fixes #2055 "Compiler shows
	success, but there was a fatal error in the config". The bug has
	been introduced recently (in 4.2.0) and really affected all
	compilers.

	* AddressTableDialog.cpp (browse): fixes #1914 "Address table
	object file name is not created properly if user clicks outside
	Editor panel"

2011-02-06  vadim  <vadim@netcitadel.com>

	* SSHUnx.cpp (SSHUnx): fixes #2049 "Installer reports success even
	if there was an error while creating static routes". Added our own
	error message generated when command used to add static route
	fails to the list of error messages recognized by the installer.

	* OSConfigurator_freebsd.cpp (updateBridgeOfInterface): see #1889, #2043
	Added support for bridge interface configuration in BSD.

2011-02-05  vadim  <vadim@netcitadel.com>

	* SSHUnx.cpp (SSHUnx): see #2039 "Installer reports success even
	if pfctl can't load config file". Added more pfctl error messages
	to the list to make code more robust.

	* CompilerDriver_pf.cpp (printStaticOptions): fixes #2038 "pfctl
	error when firewall settings include scrub option for reassembly".
	Command "scrub all reassemble tcp" does not allow direction.
	Tested and verified on OpenBSD 4.2 and FreeBSD 8.1

2011-02-04  vadim  <vadim@netcitadel.com>

	* freebsdInterfaces.cpp (manageIpAddresses): fixes #2032 "support
	for DHCP interfaces in rc.conf mode". Include dynamic interfaces
	inin the list of interfaces generated script manages when the
	script is in rc.conf format. This addds lines similar to
	'ifconfig_em0="DHCP"'.

2011-02-03  vadim  <vadim@netcitadel.com>

	* RoutingCompiler_freebsd_writers.cpp (RoutingRuleToString): fixes
	#2026 Compiler can now generate static routing configuration
	in rc.conf format for FreeBSD.

	* pfAdvancedDialog.cpp (pfAdvancedDialog): fixes #2021 "since
	rc.conf format is only supported for FreeBSD, the option in the
	dialog should not be available for other OS"

2011-02-02  vadim  <vadim@netcitadel.com>

	* OSConfigurator_freebsd.cpp: see #1888 "Add option to generate
	rc.conf.local file for BSD systems". Added ability to generate
	initialization script in rc.conf fromat for FreeBSD. Only FreeBSD
	is currently supported (not OpenBSD). Generated script includes
	variables to configure interfaces and their ipv4 and ipv6
	addresses, vlans, CARP and pfsync interfaces, as well as variables
	that initialize PF.

2011-02-01  vadim  <vadim@netcitadel.com>

	* CompilerDriver_files.cpp (determineOutputFileNames): See #2015
	"Add support for setting names of generated .fw and .conf files
	separately for PF". Added second input field in the "advanced
	settings" dialog, tab "Compiler" for the firewall platform "PF".
	Now user can set the name for both the generated .fw
	initialization script and .conf PF configuration file, as well as
	names for both files on the firewall. Support for this is generic
	and the same functions work for other platforms if corresponding
	input field in the dialog exists. The name of the initialization
	script is set as follows: 1) if user provided -o command line
	switch to the compiler, its argument is used. 2) if -o switch was
	not present but the name was configured in the firewall settings
	dialog, it is used. 3) if none of them were present, the name is
	constructed from the name of the firewall object with suffix .fw.
	The name of the .conf PF configuration file is taken from the
	settings dialog, but if it is blank, then it is constructed from
	the name of the initialization script but with suffix .conf.

2011-01-31  Vadim Kurland  <vadim@netcitadel.com>

	* RoutingCompiler_bsd_writers.cpp (_printAddr): see #1890 "Add
	support for configuring static routes on BSD". Implemented support
	for simple static routing rules. ECMP and routing via interface
	(routing to directly reachable subnets) are not
	supported. Generated script preserves static routing entries that
	existed before and attempts to recover in case of error. Needs
	testing.

2011-01-30  vadim  <vadim@netcitadel.com>

	* FWWindow_editor.cpp (clearEditorAndSearchPanels): see #2006
	"Crash when closing editor panel with find-and-replace". The GUI
	crashed if user tried to close editor panel at the bottom after
	closing objects+rules panel and while some object was still
	displayed in the editor.

2011-01-28  vadim  <vadim@netcitadel.com>

	* newFirewallDialog.cpp (fillInterfaceNZList): fixes #2000 "New
	dialog window in New Firewall wizard for ASA / PIX - Network Zone
	explanation". Added page to the new firewall wizard to let the
	user configure network zones of interfaces when chosen firewall
	platform supports network zones (only PIX/ASA right now).

	* newFirewallDialog.cpp (fillInterfaceSLList): fixes #1983 "ASA
	multiple interfaces have the same security level". Using table
	widget with spin-boxes to let the user edit security levels of
	interfaces conveniently.

2011-01-27  vadim  <vadim@netcitadel.com>

	* ProjectPanel.cpp (closeEvent): fixes #1998 "Crash after running
	find-and-replace then closing file". Specific sequence of actions
	and only on Mac OSX caused GUI to crash. To fix, I clear editor
	panel when user closes project window using MDI window title menu
	item "Close" or "Close" button.

	* ProjectPanel.cpp (registerModifiedObject): see #1996 "Crash when
	finding and replacing a large number of objects". When "find and
	replace" function was used to replace large number of objects in a
	rule set, it generated stream of calls to
	updateLastModifiedTimestampForAllFirewalls() which caused
	corresponding stream of events to update various parts of the GUI,
	both in the tree and rule set views. This caused weird corruption
	and crash on Windows. Trying to resolve the issue by optimizing
	the part that updated "last modified" timestamp on the firewall
	since all parts of the rule set updated in one call to "find and
	replace" function belong to the same firewall.

	* IOSImporterRun.cpp (run): see #1931 "Update failed import
	behavior". Added meaningful error messages for when policy
	importer fails to create firewall object or does not create
	interface objects or any rules.

	* Rule.cpp (removeRef): fixes #1997 "add removeRef and addRef
	methods to class NATRule". Now undo and redo correctly remove and
	restore references to NAT rule sets in NAT rules with action
	Branch.

	* Rule.cpp (addRef): fixes #1991 "Undo does not restore object as
	a parameter of policy rule action Branch or Tag after it was
	deleted deleted". Now Undo restores references to rule sets and tag
	services as arguments of corresponding policy rules, as well as
	references to objects configured as interface network zones.

	* Interface.cpp (removeRef): fixes #1987 "Deleting object that is
	used as Network Zone for ASA/PIX interface results in inconsistent
	behavior". When an object that is used as a network zone of an
	interface is deleted, it should be removed from the interface
	configuration as well.

	* Cluster.cpp (init): fixes #1995 "Crash when compiling a cluster
	with identical firewalls". Method Cluster::init() must call base
	class method Firewall::init() to get child Policy, NAT and Routing
	objects created.

	* CompilerDriver_pix_run.cpp (run): fixes #1994 "Crash when
	compiling a firewall in an imported Library". Compilers should
	reset any read-only flags in the copy of object tree they work
	with before they make any modifications.

2011-01-26  vadim  <vadim@netcitadel.com>

	* ProjectPanel_events.cpp (event): see #1994 "Crash when compiling
	a firewall in an imported Library". To prevent crash, added check
	to make sure firewall object is not read-only before an attempt to
	update its "last compiled" or "last installed" timestamp.

	* ProjectPanel_file_ops.cpp (fileExport): fixes #1993 "V4.2 on
	Windows - export Library shows the file type as Firewall Builder
	2"

	* FWBSettings.h (SETTINGS_PATH_PREFIX): fixes #1992 " V4.2 on
	Windows - installer error can't find Secure Shell utility"

	* init.cpp (init): fixed #1989 "variables respath and librespath
	are redundant and copy Constants::getTemplateDirectory()". Got rid
	of global variables sysfname, tempfname, librespath, respath and
	localepath; will now use class Constants to keep this information.

2011-01-25  vadim  <vadim@netcitadel.com>

	* src/fwbuilder/libfwbuilder-config.h.in: fixes #1937 "RES_DIR
	macro is defined twice". Got rid of duplicate definition of this
	macro.

	* FWObject.cpp (updateNonStandardObjectReferences): see #1985
	added virtual function updateNonStandardObjectReferences() that is
	supposed to update any references to objects stored as attributes.

	* ACL.cpp (trimLine): fixes #1986 "Cisco ASA remarks should be
	truncated to 100 characters or less". Trimming all lines used for
	access list remarks to <100 characters. Remarks can only be less
	than 101 characters on PIX/ASA and less than 100 characters on
	IOS.

2011-01-24  Vadim Kurland  <vadim@netcitadel.com>

	* PolicyCompiler.cpp (addMgmtRule): fixes #1966 "IOSACL:
	object-group can get name that consists of only suffix".  Compiler
	generated object-group statements with names such as ".src.net.0"
	in some cases.

	* ObjectIconView.cpp (dragEnterEvent): see #1980 "Objects from
	Deleted Objects should not be allowed to be used in rules". Added
	checks to not allow drag&drop of an object from Deleted Objects
	library into rules and groups.

	* NamedObject.cpp (createServiceObjectCommand): See #1958
	"consistently use "exit" to get out of nested context in pix
	config". Using "exit" to exit from nested context while adding
	network or service object in generated PIX/ASA configuraton.

	* PolicyCompiler_pix.cpp (compile): see #1970 "ASA Policy - single
	IPv6 icmp object allowed in rules". Since we do not support ipv6
	for PIX/ASA at this time, policy compiler should drop the rule
	if ipv6 address or icmpv6 service is used and issue a warning.

	* PolicyCompiler_pix_v6_acls.cpp (processNext): see #1981 "ASA /
	FWSM Policy - Generate warning message if rule will not generate
	config data"

2011-01-22  vadim  <vadim@netcitadel.com>

	* ObjectManipulator.cpp (contextMenuRequested): context menu item
	that opens object in the editor should be named "Inspect" when the
	object is read-only because the editor would not allow the user to
	change it.

	* ObjectManipulator.cpp (contextMenuRequested): fixed #1926
	"Crash when moving object in Standard library". Context menu
	item "Move" should be disabled when the object is located in
	the read-only library.

	* GroupObjectDialog.cpp (setupPopupMenu): see #1976 "Crash when
	deleting firewall object from rule after export / import library"
	Crash occurred as the result of the following sequence of actions
	in the GUI: 1) use context menu item "Cut" to delete an object in
	the tree, 2) open object group or rule and use context menu item
	"Paste" to add it, 3) export library to an external file, 4)
	import this library into different data file, 5) save the data
	file. Saved data file is invalid XML since it has unsatisfied
	reference and some operations on it cause crash. The problem is
	that since it is a reference to the object that is being added in
	case of both groups and rules, we end up with a group or rule with
	a reference to an object that is located in Deleted Objects
	library. Deleted Objects library is not included when a library
	file is merged into data file and this leads to a dangling
	reference. The fix is to not allow Paste if object in the
	clipboard has been deleted.

	* NamedObjectsAndGroupsSupport.cpp (saveObjectGroups): see #1968,
	#1972 Class NamedObjectsManager maintains its own copy of object
	tree that holds object group objects it creates during compiler
	passes. This allows me to maitain one common set of object groups
	for both policy and nat compilers and avoid creating duplicate and
	redundant object-group statements.

	* NamedObjectsManagerPIX.cpp (getClearCommands): see #1968, #1972
	class NamedObjectsManager (and derived classes for IOS and PIX)
	generate "clear" commands. This way, I can generate correct set
	of "clear" commands that take into account any named objects and
	object-groups that could be created during both policy and nat
	compiler passes.

2011-01-21  vadim  <vadim@netcitadel.com>

	* FWObject.cpp (init): see #1972 Seaprated object creation and
	initialization. Some complex objects need to create a set of
	standard child objects. Previously this was done in a special type
	of constructor which required pointer to the object tree root
	(FWObjectDatabase*). This created problems with implementation
	of the method to register functions that create objects of new
	types outside of the API. Now all objects have just a basic set
	of constructors, plus method init() that can initialize them.

	* FWObjectDatabase_create_object.cpp (registerObjectType): see
	#1972 implemented mechanism that allows me to register new object
	types created and used outside of libfwbuilder API. This means
	FWObjectDatabase can then copy and manipulate object trees that
	use these new object types.

2011-01-20  vadim  <vadim@netcitadel.com>

	* NamedObjectsAndGroupsSupport.cpp (getNamedObjectsDefinitions):
	see #1963 "move printing of object-group definitions to
	NamedObjectManager::getNamedObjectsDefinitions()". Consolidated
	code that works with named objects and object groups in the class
	NamedObjectManager. This class manages all the objects and in the
	end generates commands.

	* PolicyCompiler_cisco (printClearCommands): Refactored parts that
	generate "clear" commands to make sure they are printed in the
	right order at the top of the generated configuration. Previously
	compiler placed "clear global", "clear static" and "clear nat"
	commands above the NAT section but below policy section. Since
	ASA8.3 nat commands can use named objects and object groups, and
	since I have added support for object groups in ASA 8.3 policy
	rules, I now need to clear objects and object groups at the very
	beginning of the generated config. However in order to be able to
	clear objects and object-groups, I need to clear access-lists and
	nat commands that might be using them first. So, all clear
	commands are now grouped at the beginning of the generated
	configuration. This affects pix/asa, iosacl and procurve_acl
	platforms.

	* NamedObjectsAndGroupsSupport.cpp (printObjectsForRE): See #1959
	"ASA Policy - ranges are broken into composite network instead of
	using range command". I have to create named objects for address
	ranges and put them into an object-group, which I can then use in
	access-list commands.

	* PolicyCompiler_pix.cpp (compile): See #1965 "ASA Policy - PIX
	6.1 configurations use object groups". Policy compiler for PIX is
	now aware that object-group statement was introduced in PIX v6.2
	and avoids using object-groups when firewall object version is set
	to 6.1

	* NamedObjectsAndGroupsSupport.cpp (processNext): made names
	automatically assigned to object-groups in generated PIX
	configuration shorter by removing interface label prefix.

2011-01-19  vadim  <vadim@netcitadel.com>

	* PolicyCompiler_pix.cpp (compile): See #1959 "ASA Policy - ranges
	are broken into composite network instead of using range command."
	Added support for address ranges using named network object with
	parameter "range" for ASA 8.3 and later. NOTE: if a network or ip
	address object is used in a nat rule for ASA 8.3, a named object
	has to be created for it since ASA 8.3 does not accept ip
	addresses or subnets in "nat" commands. In the situation like
	this, if the same address or network object is used in any Policy
	rule, the same named object will be used in the generated
	access-lists command.

	* NamedObjectsAndGroupsSupport.cpp (getNamedObjectsDefinitions):
	see #1959 Moved generation of the code that defines named objects
	to class NamedObjectManager. This allows me to put all named
	object commands on top of the generated policy, nat and routing
	configurations and make sure each object is defined only once.
	Still need to do #1963 - move code that generates commands to
	define object-groups to class NamedObjectManager.

	* NATCompiler_asa8.cpp (processNext): see #1954 "ASA NAT -
	generate warning if nat rule is split and one of the resulting nat
	rules have the same real interface and mapped interface". Compiler
	issues warning when objects used in OSrc and TSrc of a NAT rule
	make it use the same interface as both real and mapped interface
	in the generated nat command. This check is only done for ASA 8.3
	NAT rules.

2011-01-19  Vadim Kurland  <vadim@netcitadel.com>

	* NamedObject.cpp (sanitizeObjectName): see #1953 "ASA NAT - two
	host objects in the same rule result in incorrect config". We now
	register and keep track of all named objects to make sure their
	names are unique.

	* newHostDialog.cpp (finishClicked): see #1953 "ASA NAT - two host
	objects in the same rule result in incorrect config". Objects that
	represent addresses of interfaces of a host object created using
	template will be automatically renamed to follow standard naming
	convention "host_name:interface_name:ip" to avoid creating
	duplicate names.

	* PolicyCompiler_pix_writers.cpp: see #1960 add support for
	CustomService for PIX policy rules. Note that CustomService
	objects are only supported in Policy rules since nat commands in
	ASA 8.3 require use of named objects and it is difficult to
	implement correct named objects and object-groups with protocol
	parameter and custom services.

2011-01-18  Vadim Kurland  <vadim@netcitadel.com>

	* PIXObjectGroup.cpp: ASA 8.3 see #1942, #1943 fixed generation of
	the "object-group" statements by adding protocol keyword at the
	end so that the group can be used in access-list commands. It
	looks like mixed service groups that have no protocol keyword at
	the end of the line that defines them cause error "specified
	object group <foo> has wrong type; expecting service type". I am
	going to avoid using mixed service groups because of this.

2011-01-17  vadim  <vadim@netcitadel.com>

	* ASA8TwiceNatLogic.cpp (getAutomaticType): fixes #1916 "nat rule
	must be "static" when subnet is present in TSrc"

	* ServiceRuleProcessors.cpp (condition): see #1942 improved
	support for CustomService objects for ASA 8.3. Generate separate
	named object and object-group for these objects, then split policy
	and nat rules so that only one custom service object is left in
	each rule and then use object-group to match it. Note: this has
	been rolled back. There is no support for CustomService objects in
	NAT rules.

	* PolicyCompiler_pix.cpp (processNext): fixes #1948 "incorrect
	configuration created when a CustomService object is used in a
	policy rule for PIX/ASA v<8.3". Since we do not support custom
	service objects in policy and nat rules for versions older than
	8.3, added check to generate fatal error when such object is used.

	* NamedObjectsAndGroupsSupport.cpp (init): fixes #1945
	"object-group names include ever-growing suffix". Object-groups
	created by the compiler for PIX/ASA had numerical suffix that was
	constantly increasing when user used single-rule compile function
	in the GUI.

	* PolicyCompiler_pix.cpp (compile): fixed #1944 "ASA Policy -
	duplicate network object groups created for mixed service group
	with TCP dst and TCP src port range objects". Need to convert
	address range objects to subnets early, before the rule is split
	for any reason, to make sure object groups created later match
	and are reused.

	* NamedObjectsAndGroupsSupport.cpp (processNext): See #1943 "ASA
	Policy - mixed service group with TCP destination port range and
	standard TCP object generates invalid config". Protocol word "tcp"
	was missing after "deny" in the generated rule.

	* NATCompiler_asa8.h (fwcompiler): see #1949 "ASA NAT - split
	objects if OSrc contains objects that are in more than one network
	zone".

2011-01-16  vadim  <vadim@netcitadel.com>

	* NamedObjectsAndGroupsSupport.cpp (processNext): Added support for
	CustomService objects in policy and nat rules for asa 8.3 using
	named objects and object-groups.
	 -- see #1942 "ASA NAT - if custom service is included in service
	group incorrect config generated"
	 -- see #1929 "move map named_objects inside class NamedObjectManager"
	 -- see #1946 "restrict generation of the named objects by
	PolicyCompiler_pix to ASA 8"
	 -- see #1885 "named network and service objects in pix8"
	Note: this has been rolled back. There is no support for
	CustomService objects in NAT rules.

	* NATCompiler_pix.cpp (processNext): see #1941 "ASA NAT - compiler
	complains about range in original destination". NAT rules
	translating destination allow Address Range objects in ODst or TDst
	for ASA 8.3

	* NamedObject.cpp (NamedObject): see #1940 "ASA NAT - fwbuilder
	host objects interface ip is reserved keyword". Added list of
	reserved words used in IOS and ASA software to make sure generated
	named objects do not conflict. Will maintain single super-set
	of reserved words instead of separate set for each version of IOS
	and ASA.

	* PolicyCompiler_pix.cpp (compile): fixed #1938 "icmp" commands
	were not generated for ASA 8.x policy rules.

	* NATCompiler_asa8.cpp (processNext): See #1927. Added check for
	NAT rules that request translation of destination address but have
	ODst "any". This only applies to ASA 8.3; these rules are
	prohibited.

2011-01-14  vadim  <vadim@netcitadel.com>

	* NATCompiler_asa8_writers.cpp (printSDNAT): fixes #1932 "Add
	description field to generated NAT rules for ASA". NAT rules
	generated for ASA 8.3 and later will have "description" keyword
	added, with rule label as an argument. Rule label includes
	word "NAT" and rule number.

	* libfwbuilder/src/fwbuilder/InetAddrMask.cpp (getOverlap): fixes
	#1934 "libfwbuilder::getOverlap() incorrectly calculates overlap
	between ipv4 networks". This should also fix SF bug 3156376 "Can
	not find interface with network zone that includes address range".

2011-01-13  vadim  <vadim@netcitadel.com>

	* NATCompiler_asa8.cpp (compile): refs #1928 "Support for
	object-group in OSrc". Implemented support for object-group
	and named objects for Osrc and ODst in ASA 8.3 NAT rules.

	* PolicyCompiler_cisco.cpp (removeRedundantAddresses): fixed #1917
	"Duplicate objects are not detected". Compiler should detect
	duplicate objects that may be created in a rule element when user
	combines Address Table object with other address or network
	objects there.

	* ASA8ObjectGroup.cpp (toString): refs #1885 Compiler uses named
	objects and objects groups to build configurations that use
	address ranges in TSrc in NAT rules. (only ASA 8.3 and later)

2011-01-12  Vadim Kurland  <vadim@netcitadel.com>

	* NATCompiler_asa8_writers.cpp (printSDNAT): refs #1907 "ASA NAT -
	fwbuilder doesn't support multiple translated sources in a single
	NAT rule". Compiler uses object-group to translate NAT rules that
	have multiple objects in Translated Source.

	* PolicyCompiler_pix_writers.cpp (_printLog): fixed #1913 "ASA/PIX
	rules with logging enabled don't have log set unless user modifies
	Firewall Settings". Added default log level setting to the
	resource xml file for platform "pix", set to "informational". ACL
	lines now get "log " keyword followed by the log level taken from
	the rule options, or if that was not configured, from the
	firewall object settings, or if that is not configured, the
	default.

2011-01-11  vadim  <vadim@netcitadel.com>

	* NATCompiler_asa8_writers.cpp (printSDNAT): refs #1908 "ASA NAT -
	cannot configure static NAT translations with (inside,outside)".
	Added NAT rule option to make source nat rules "static". The
	option is presented to the user as three radio buttons in the NAT
	rule options dialog which is only enabled when platform is "pix"
	and version >= 8.3. Policy compiler generates "twice nat" rules
	with keyword "static" in the following cases: when TSrc is
	"original", so the rule translates destination and not source or
	when numbers of ip addresses represented by OSrc and TSrc are
	equal. If TSrc is not "original" and represents different number
	of ip addresses than OSrc, compiler looks at the new rule
	option. User can use or override automatic algorithm using radio
	buttons in the NAT rule options dialog.

	* NATCompiler_asa8_writers.cpp (printSDNAT): refs #1902 "Add NAT
	rule option "translate dns" for PIX". The option is only available
	for ASA 8.3 or later.

	* NATCompiler_asa8_writers.cpp (printSDNAT): fixed #1909 "ASA NAT
	- static nat port translation where service is the same for
	original service and translated service not generated correctly"

2011-01-10  vadim  <vadim@netcitadel.com>

	* PolicyCompiler_pix.cpp (compile): fixed #1862 "fwb_pix crash".
	Compiler fwb_pix crashed when DNSName run-time object was used in
	a rule, but worked fine and issued an error when used in
	single-rule compile mode.

	* Helper.cpp (findInterfaceByNetzone): fixed #1906 "ASA NAT -
	Address objects are not properly identified by network zone and
	have the wrong real interface". The problem should have affected
	both "old" (PIX 6 and 7) and "new" (ASA 8.3) configuration. When
	an Address object was used in Original Source of a NAT rule,
	compiler used wrong interface in the (interfac1,interface2) pair
	in "nat" command.

	* CompilerDriver_pix_run.cpp (run): fixed #1905 "fwbuilder crash
	when compiling a rule with hosts folder as destination". Compiler
	issues a warning when an empty group object is used in a rule, but
	GUI crashed when user tried to compile this rule using single-rule
	compile function. The change actually affects all policy compilers
	and makes sure the GUI catches exception and does not crash, and
	prints any errors generated by the compiler in the compiler output
	panel when single-rule compile function is used.

	* CompilerDriver_ipt.cpp (findBranchesInMangleTable): fixed #1879
	"gui crash". Both GUI and fwb_ipt crashed trying to compile a rule
	with action Branch that was not configured to point to any rule
	set.

2011-01-07  vadim  <vadim@netcitadel.com>

	* NATCompiler_pix.cpp (NATCompiler_pix): fixes #1901 "add
	destructor to NATCompiler_pix and NATCompiler_asa8". This
	eliminates memory leak.

	* ASA8Object.cpp (ASA8Object): refs #1885 "named network and
	service objects in pix8". So far, these objects are only used
	for nat configuration.

	* NATCompiler_asa8_writers.cpp (processNext): fixes #1903 "correct
	order of clear commands for ASA 8.3"

	* NATCompiler_asa8_writers.cpp (printSDNAT): refs #1886 "new nat
	configuration in pix 8.3". Initial support for new style nat
	configuation.

2011-01-04  vadim  <vadim@netcitadel.com>

	* platform/fwsm.xml: FWSM v4.x does not have "fixup" command, instead,
	we should use policy-map and class commands.

	* OSConfigurator_pix_os_inspectors_pix8.cpp (_printPolicyMapTypeInspect):
	refs #1893 fixes #1883 "inspect ip options in pix8". Added support for
	"policy-map type inspect ip-options" command in PIX v8.2 and later.
	At this time, of all possible types of "policy-map type inspect"
	command only "ip-options" is implemented.

	* PIX8ObjectGroup.cpp (toString): refs #1882 "Mixed service groups
	in PIX8". Added pix versions 8.0 and 8.3; added support for mixed
	servcie groups in pix 8.0 and later.

	* PolicyCompiler_srvre_functions.cpp (processNext): fixed #1892
	"move rule processor class separateServiceObject to
	PolicyCompiler".  This rule processor used to be implemented only
	in the compiler for PF, but since it has very general meaning, the
	same function was duplicated in other compilers as well. Moved the
	class to libfwbuilder and reimplemented several other rule
	processors to inherit from this class to avoid further duplication
	for code.

	* PolicyCompiler_pix.cpp (compile): fixed #1891 "problems with TCP
	and UDP services with source ports". Policy compiler for PIX did not
	generate correct PIX ACL lines when one Policy rule tried to match
	several TCP and/or UDP objects matching source ports.

2010-12-29  vadim  <vadim@netcitadel.com>

	* VERSION (VERSION): started 4.2.0

	This version is the first one to merge libfwbuilder and fwbuilder
	packages. Libfwbuilder is now in the src/libfwbuilder subtree inside
	fwbuilder code tree.

	RPM .spec files and DEB .control files are now located in the packaging
	directory inside fwbuilder code tree.

	Changes in the versioning format: I am going to use build number
	as a "nano" version number, composing complete version as
	"4.2.0.3425". The "-N" suffix in rpm and deb package names will
	be used for package release number and most of the time will be
	"-1". This suffix should reflect minor differences in the package
	that do not affect code at all.

2010-12-16  Vadim Kurland  <vadim@netcitadel.com>

	* ActionsDialog.cpp (fillInterfaces): fixed #1872: "vlan interface
	does not appear in the list of interfaces for route-to action for
	PF".

2010-12-12  Vadim Kurland  <vadim@netcitadel.com>

	* VERSION (FWB_MICRO_VERSION): started 4.1.4

2010-12-05  Mike Horn <mike@netcitadel.com>

	* minor updates to main help dialog text to fix broken/outdated
	links

2010-12-02  Vadim Kurland  <vadim@netcitadel.com>

	* OSConfigurator_linux24.cpp (OSConfigurator_linux24::getInterfaceVarName):
	fixed #1856 "Pemit '-' in Linux interface names". OpenWRT uses
	name "ppp-dsl" for PPPoE interfaces. In addition to that, Linux
	bridge interfaces may have names with a "-" such as
	"br-lan". We will now permit a "-" in Linux interface names.

	* FWWIndow.cpp: Fixes #1858 'Remove "Summary of features" page
	from the package' and #1857 'Remove "Getting Started" guide from
	the package'. We have dediced to keep documentation and other
	content like this on the web site. Button "Watch Getting Started
	Tutorial" in the Tip of the Day dialog opens tutorial hosted on
	the web site in a web browser.

2010-11-16  Vadim Kurland  <vadim@netcitadel.com>

	* check_utilities: fixed #1851 "no need to check for modprobe when
	host OS is "dd-wrt" and possibly other embedded Linux
	systems". Generated script does not use modprobe utility when host
	OS is set to "DD-WRT" or "OpenWRT" and should not try to find this
	utility on the system. This is also related to the SourceForge bug
	3032293

2010-11-16  Vadim Kurland  <vadim@vk.crocodile.org>

	* newclusterdialog_q.ui: fixed #1848 Text formatting clean up -
	New cluster wizard dialog

2010-11-15  Vadim Kurland  <vadim@vk.crocodile.org>

	* InetAddr.cpp (InetAddr::opGT): (change in libfwbuilder) added
	module uint128 (128-bt arithmetics by Evan Teran). Implemented
	basic operations with ipv6 addresses using this module. See #1834.
	Now all policy compilers can correctly compare ipv6 addresses used
	in rules with ipv6 addresses of interfaces. This helps perform
	various optimizations and fixes issues with the algorithm used to
	pick the right interface for the Cisco IOS ACL compiled from a
	policy rule with an empty "interface" rule element and direction
	"both".

2010-11-11  Vadim Kurland  <vadim@vk.crocodile.org>

	* newClusterDialog_create.cpp (copyRuleSets): Fixed SF bug
	#3106168 "Branch destinations lost when adding to cluster".  Since
	the order in which I copy rule sets is undefined and because they
	may have references to each other via branching rules, I need to
	fix references after I create all of them.

	* configlets/linux24/load_modules: fixed #1844 "generated script
	fails if module nf_conntrack_ipv6 does not exist". Generated
	script tries to load module nf_conntrack_ipv6 if user defined
	any ipv6 rules, however the script should not fail if the module
	is not installed.

	* src/gui/gui.pro (LIBS): fixed #1840: fixed build on Mandriva
	2010, all static libraries should go first on the linker command
	line.

2010-11-10  Vadim Kurland  <vadim@vk.crocodile.org>

	* NATCompiler_ipt.cpp (processNext): fixed SF bug 3103582 "Cant
	create redirect rule in cluster firewall object".  Iptables nat
	rule with target REDIRECT could not be built in a cluster
	configuration. It should be possible to do this by putting cluster
	object in Translated Destination.

	* OSConfigurator_linux24_interfaces.cpp (printDynamicAddressesConfigurationCommands):
	fixed #1838 "function configure_interfaces() does not manage ip
	addresses of vlan interfaces". This function used to take into
	account only interfaces that were direct children objects of the
	firewall. Since vlan interfaces are children of the corresponding
	physical interface, they were not included.

	* FirewallInstaller.cpp (getGeneratedFileFullPath): fixed #1837
	"generated script gets .fw suffix even when user set output file
	name". Suffix .fw should not be appended to the name entered by
	the user in the "output file name" input field in the firewall
	settings dialog.

	* PolicyCompiler_ipfw_writers.cpp (processNext): fixed #1836
	"installer hangs and fails after activation of ipfw policy".  As
	soon as .fw script swapped ipfw sets usig command "ipfw sawp" and
	deleted temporary set 1, ssh session would hang and eventually
	break. We optionally add ipfw rules to permit ssh session used to
	manage the firewall, as well as a rule to permit reply packets but
	the latter rule was not built correctly. It should match source
	and destination reversed, as well as match keyword "established"
	and recreate state with "keep-state". This rule automatically
	recreates state for the established ssh session over which
	firewall policy is being managed. Also added a comment to the
	firewall settings dialog for ipfw to remind the user that address
	or subnet they use with this automatic rule should be as narrow as
	possible.

	* instOptionsDialog.cpp (instOptionsDialog): see #1832 if user
	wants to use putty session, show session name instead of the ip
	address in the "Address that will be used to communicate with the
	firewall" input field in the installer options dialog.

2010-11-09  Vadim Kurland  <vadim@netcitadel.com>

	* Helper.cpp (Helper::findInterfaceByAddress): see #1834 Fixed
	matching algorithm that determins which interface a rule should be
	associated with for Cisco IOS ACLs. Previously compiler did not
	compare subnets properly and because of that it interpreted some
	configurations incorrectly. For example in the case with a network
	object 10.0.0.0/8 in "source" and an interface with address
	10.0.0.1/24 (network should not be considered matching) compiler
	considered this interface matching and assigned the rule to the
	interface only with direction "inbound".

	* FirewallInstaller.cpp (FirewallInstaller::packSCPArgs): see #1832
	pscp.exe supports putty session in place of the target name but
	not if argument "-load session_name" is also present. Plink.exe
	does the same. We can not use fwb_session_with_keepalive if user
	wants to use putty session.

2010-11-08  Vadim Kurland  <vadim@netcitadel.com>

	* FirewallInstaller.cpp (FirewallInstaller::packSCPArgs): See
	#1832, SF bug 3097419 "installer uses bare IP address instead of
	putty session name". It appears pscp.exe on Windows can use putty
	session name in place of the host name. This change restores old
	behavior where session name was used like that but does it for
	both plink.exe and pscp.exe. This only affects users who run
	fwbuilder GUI on Windows

2010-11-05  Roman Bovsunivskiy <a2k0001@gmail.com>

	* see #1809 "Add Firewall Setting in Logging settings for default
	log setting on new rules". Added a tab "Policy Rule" to the
	"Objects" page of the global preferences dialog; checkbox in this
	tab allows the user to choose whether new policy rules should be
	created with logging turned on or off.

2010-11-04  Roman Bovsunivskiy <a2k0001@gmail.com>

	* see #1826 "Please place all unit tests in one directory". All GUI
	and other unit tests moved to the directory src/unit_tests

2010-11-03  Roman Bovsunivskiy <a2k0001@gmail.com>

	* code refactoring: see #1822 "refactor all GUI classes into
	libgui library and link executable with it"

	* see #1787 "new fw name input field should have focus when new
	firewall wizard opens"

	* see #1823 "Add Preference option for Advanced / Power users".
	Added checkbox to the Preferences dialog, this checkbox turns off
	some tooltips that can be annoying for users who are sufficiently
	familiar with the GUI
	
2010-11-02  Vadim Kurland  <vadim@vk.crocodile.org>

	* OSConfigurator_linux24_interfaces.cpp (printVerifyInterfacesCommands):
	fixed #1824 "should not try to verify wildcard interfaces".

2010-11-01  Vadim Kurland  <vadim@netcitadel.com>

	* CompilerDriver.cpp (CompilerDriver::getAbsOutputFileName): fixed
	SF bug 3090249 "fwb_ipt ignores -d option ". Documented behavior
	is for the compiler to create files in the directory specified by
	the argument of the "-d" command line flag. If flag "-d" is not
	provided, files should be created in the current directory.

2010-10-29  Vadim Kurland  <vadim@vk.crocodile.org>

	* PolicyCompiler_ipt.cpp (checkForStatefulICMP6Rules::processNext):
	fixed SF bug 3094273 "no state needed for ipv6-icmp in
	ip6tables". Rules that match ICMPv6 objects should be
	stateless. Compiler will check for this and reset "stateful" flag
	of a rule and issue warning if the rule was built stateful in the
	GUI. This could be version-dependent, we may need to revisit this
	in the future when netfilter fixes the underlying issue. Some
	resources: https://bugzilla.redhat.com/show_bug.cgi?id=243739
	https://bugs.launchpad.net/ubuntu/+source/iptables/+bug/479105

	* src/res/objects_init.xml.in: added ICMPv6 object "parameter
	problem" (type 4, any code) per SF feature request 3094743.  Also
	added service group object "ipv6 unreachable messages" that
	includes ICMPv6 messages "destination unreachable", "packet too
	big", "parameter problem" and "time exceeded" per SF feature
	request 3094758

	* configlets/linux24/automatic_rules: implemented SF feature
	request 3094738 "Set the HL to 255 for IPv6 Neighbor
	Discovery". Neighbor discovery packets must have hop limit of 255
	per RFC 2461. Automatically generated rules that match neighbor
	discovery packets will math hooplimit 255.

	* configlets/linux24/update_addresses: fixed SF bug 3091069:
	"Routing configuration failed". Iptables script generated by
	fwbuilder did not configure broadcast when it added ip addresses
	to interfaces. Using "ip addr add ADDR/NM boradcast + dev INTF"
	syntax to do this.

	* OSConfigurator_bsd.cpp (compare_names): fixed #1807 "wrong order
	of address assignment in the generated OpenBSD/PF/CARP cluster
	configuration". Need to assign ip addresses to regular interfaces
	before trying to assign them to carp interfaces.

	* configlets/linux24/load_modules: fixed #1820 "skip module
	"nf_conntrack_ipv6" if generated script has no ipv6 rules"
	Shell function load_modules should not try to load module
	nf_conntrack_ipv6 if generated script does not load any ipv6
	rules. Loading this module fails if ipv6 has been disabled in
	the kernel.

2010-10-29  Vadim Kurland  <vadim@netcitadel.com>

	* run_time_wrappers: fix for the SF bug #3095615 "reopen no
	PREROUTING rule with *-Interface - ID: 3077132". Configlet used wrong
	shell variable to access ip address of a wildcard interface.

	* VERSION (FWB_MICRO_VERSION): started 4.1.3

2010-10-07  Vadim Kurland  <vadim@vk.crocodile.org>

	* configlets/pix_os/installer_commands_reg_user: using command
	"terminal width 256" to turn off ANSI commands in the PIX command
	echo.

	* FindObjectWidget.cpp (showObject): rolled back change done in
	r3320 (refs #1790) "When an object is found using Find and the
	object is in the object tree, the keyboard focus shifts to the
	Object Panel". That change broke highlighting of the found object
	in rules.

	* refs #336 "Need template for PIX firewall"; added template for
	PIX 50X (501 and 506)

2010-10-06  Vadim Kurland  <vadim@vk.crocodile.org>

	* FWWindow.cpp (FWWindow::showIntroDialog): fixed compile problem
	with old Qt (v < 4.5.0).

	* FWWindow.cpp (FWWindow::showIntroDialog): See #1765, #1779 Will
	show a dialog inviting the user to watch Quick Start Guide on the
	web site when they run the GUI for the first few times. The dialog
	is shown instead of the Time of the day dialog. Switching to the
	tip of the day after 5 starts.

	* RoutingCompiler_pix.cpp (emptyRDstOrRItf::processNext): fixed
	#1783 "PIX routing entries require interface, but PIX config will
	compile without interface in Routing rule". Policy compiler for PIX
	now checks that both "interface" and "gateway" rule elements are
	not empty.

2010-10-05  Vadim Kurland  <vadim@vk.crocodile.org>

	* OSConfigurator_linux24.cpp (printRunTimeWrappers): fixed SF bug
	3077132 "no PREROUTING rule with *-Interface". Rules matching
	addresses of a wildcard interface (e.g. "ppp*") were not properly
	generated.

	* RuleSetView.cpp (updateSelectionSensitiveActions): fixed SF bug
	3039681 "context-menu items inconsistent for Single/Multiple
	rules". When several rules are selected in rule set, some context
	menu itmes should turn to plural.

	* FWWindow.cpp (prepareRulesMenu): fixed #1778 "main menu Rules
	should have the same items that context RuleSetView menu when no
	rules are selected"

2010-10-04  Vadim Kurland  <vadim@vk.crocodile.org>

	* ObjectManipulator.cpp (showObjectInTree): fixed #1777 "scroll
	new fw object to the top of the tree view panel once its created"
	This has side effect in that some other operations that open an
	object in the tree will also sc roll the tree to position this
	object at the top.

	* FWBSettings.cpp (setCustomTemplatesEnabled): fixed #1791 "Add
	preference flag to enable / disable the Custom templates button on
	the New Firewall Wizard". Use of the custom template library
	to create new firewall object is now optional, controlled by
	a checkbox in the "Object" tab of the gobal preferenes dialog.
	New users will have this option turned off by default, however
	existing users will see it enabled for backwards compatibility.

	* FindObjectWidget.cpp (showObject): fixed #1790 "When an object
	is found using Find and the object is in the object tree, the
	keyboard focus shifts to the Object Panel". The "find" pabel now
	retains keyboard focus after it shows found object in the tree,
	this allows the user to just hit Enter on the keyboard to find
	the next object.

	* FindObjectWidget.cpp (objectDeleted): fixed #1785 "Deleting
	graphic icon of object from Find tab should also remove the text
	name or label"

	* newFirewallDialog.cpp (changed): fixed #1770 Eliminated pause
	that happened when user switched from page 0 to page 1 of the new
	firewall wizard. Pause was caused by the DNS queries the program
	ran trying to determine ip address of the firewall using the name
	provided on the first page of the wizard. Now DNS query is
	launched only if user wants to create interfaces uses snmp scan.

	* InterfaceEditorWidget.cpp (InterfaceEditorWidget): fixed #1772
	improved design of the widget used to edit ip addresses and other
	attributes of an interface in the new firewall, new host and new
	cluster wizards. Removed "MAC Address" imput field and rearranged
	other input fields according to the result of usability tests.

	* SSHCisco.cpp (SSHCisco): fixed #1784 added Cisco ASA (PIX) error
	message "cannot add route entry" to the list of errors that
	built-in installer recognizes and marks install process as
	"Failure".

	* newFirewallDialog.cpp (showPage): fixed #1767 improved UI in the
	new firewall and new host dialogs where user chooses file for the
	custom template library or uses standard template library.

2010-10-03  Vadim Kurland  <vadim@vk.crocodile.org>

	* ObjectManipulator_create_new.cpp (ObjectManipulator::createNewObject):
	fixed #1776 once new firewall is created, automatically open its Policy

	* FWWindow.cpp (FWWindow::showIntroDialog): fixed #1765, #1779
	Move quick start guide to the web site. The "Quick Start Guide" is
	now part of the web site and the GUI only shows a
	dialog-invitation to watch it.

2010-10-01  Vadim Kurland  <vadim@vk.crocodile.org>

	* FWBSettings.cpp (getABTestingGroup): fixed #1763 Implemented
	basic facility for A/B testing within the GUI

2010-09-30  Vadim Kurland  <vadim@vk.crocodile.org>

	* FindObjectWidget.cpp (keyPressEvent): fixed #1755 "hitting enter
	after editing search attribute in the Find panel should trigger
	search"

	* FindObjectWidget.cpp (matchAttr): fixed #1760 'Search by
	attribute "name" should search by name or label'.

	* FindObjectWidget.cpp (objectInserted): fixed #1757 Allow
	searching by attributes even after an object is dropped into the
	drop area in search panel.

	* newFirewallDialog.cpp (browseTemplate): fixed #1759 "Use default
	template library" button seems to do nothing. This button should
	only be enabled if user switched to their own library of template
	objects. The button should be disabled if they switched back to
	the standard template library or never switched to their own one.

	* newHostDialog.cpp (finishClicked): fixed #1761 "blank interface
	name is possible in new host wizard"

	* FWObjectPropertiesFactory.cpp (getInterfaceNameExamplesForHostOS):
	fixed #1753 "Set interface name hint based on firewall platform
	and host OS". The placeholder text in the interface name and label
	input fields in the new firewall wizard will depend on the host OS
	chosen in the first page of the wizard.

	* utils.cpp (validateName): fixed #1751 "Don't allow interface
	names to be blank". The GUI should not allow the name of any
	object to be blank.

2010-09-29  Vadim Kurland  <vadim@vk.crocodile.org>

	* ProjectPanel.cpp (ProjectPanel::inspect): fixed #1718 "Inspect
	generated files" dialog says "Multiple firewalls" even when there
	is only one

	* InterfaceEditorWidget.cpp (InterfaceEditorWidget::InterfaceEditorWidget):
	added "placeholder" text to the interface name and label input
	fields. This text is displayed in greyed-out small font inside
	the imput field but is cleared as soon as user starts their input.
	The text gives user a prompt as of what is expected in each input
	field. The "placeholder" text support is available only in Qt 4.7
	and later so the code is conditional on the version of Qt.

	* WorkflowIcons.cpp (WorkflowIcons::openTutorial): fixed #1733
	"Add button for video tutorial link". Shortcut button "Watch
	Getting Started Tutorial" opens page with video tutorials in
	the standard browser.

	* InterfaceEditorWidget.cpp (InterfaceEditorWidget::isValid):
	fixed #1746 "Force user to change interface name in New Firewall
	wizard". When user creates interfaces for the new firewall or host
	using manual method and clicks on the "+" button to add a tab for
	the new interface in the wizard page, the interface tab is created
	with blank name. Wizard later checks the name when user clicks
	Finish to create new firewall or host object and does not let them
	do this while interface name is still blank. Error dialog reminds
	that the name of the interface must match the name of the
	interface on the machine.

	* ProjectPanel.cpp (ProjectPanel::updateFirewallName): fixed #1745
	"Remove path data from text above rules window that shows firewall
	name".

2010-09-28  Vadim Kurland  <vadim@vk.crocodile.org>

	* ObjectManipulator_create_new.cpp (reminderAboutStandardLib):
	refs #1748 "Add dialog about Standard Library when user creates
	first Service object". First time users will see an informational
	dialog reminding them about the Standard objects library when
	they create their first service object.

2010-09-27  Vadim Kurland  <vadim@vk.crocodile.org>

	* src/gui/Tutorial/introduction/html/page0.html: refs #1737 Added
	"Quick Start Guide" tutorial that demonstrates basic features and
	key concepts of Firewall Builder. The tutorial is accessible
	via Help / Tutorials menu and is shown to the first-time user
	on the GUI startup instead of the "tip of the day" dialog.

	* FWObjectPropertiesFactory.cpp (getObjectPropertiesDetailed):
	system folders in the tree now have tooltips that explain what
	kind of objects belong there.

	* RuleSetView.cpp (showToolTip): Added text to the tooltips shown
	for the "Direction" and "Action" rule elements to remind user that
	to change these rule parameters they need to click right mouse
	button to open list of possible settings

	* RuleSetView.cpp (showToolTip): fixed #1744 "Add tooltip to the
	rule number". The column in the RuleSetView? where rule number is
	shown now has a tooltip to remind the user that they can click
	right mouse button to the the context menu and use keyboard
	shortcut "x" to compile the rule

	* FWBSettings.cpp (init): fixed #1743 "change default for the
	option 'Show text descriptions for direction and action'". The
	option should be on by default.

	* RuleSetView.cpp (showToolTip): fixed #1730 "Add background help
	text and images to empty policy window". Showing tooltip in the
	empty space in the rule set view, this tooltip provides hints on
	how to edit rules which should be useful for the beginners.

2010-09-26  Vadim Kurland  <vadim@vk.crocodile.org>

	* ObjectManipulator.cpp (ObjectManipulator::contextMenuRequested):
	fixed #1741 "there is no way to undelete a library object".

	* FWCmdMoveObject.cpp (FWCmdMoveObject::notify): fixed #1740
	"Deleted library remains in the drop-down list". If option "Show
	deleted objects" was turned off in the Preferences dialog and user
	deleted a library, it remained in the drop-down list of libraries
	and its object tree was still displayed in the object tree panel.

	* listOfLibrariesModel.cpp (ListOfLibrariesModel::addStaticItems):
	fixed #1728 "Update Library drop down menu". Library drop down
	list shows an item "Object libraries:" at the top that can not be
	selected and that always stays on top as libraries are added,
	removed and renamed. The list always stays sorted in ascending
	order. Library names are indented by 2 spaces to make them
	visually distinguishable from the prompt item at the
	top. Implementation uses class ListOfLibrariesModel that inherits
	QStringListModel.

	* PrefsDialog.cpp (PrefsDialog::PrefsDialog): fixed #1739 "remove
	"tooltip delay" input form preferences dialog". Qt4 does not allow
	for changing tooltip delay.

2010-09-24  Vadim Kurland  <vadim@vk.crocodile.org>

	* RuleSetView.cpp (itemDoubleClicked): refs #1731 Change
	double-clicking on "Any" object behavior. Double click on "any" in
	a rule does not try to open object "any" in the tree and editor
	panel.

	* FWObjectPropertiesFactory.cpp (getObjectPropertiesDetailed):
	refs #1731 Change double-clicking on "Any" object
	behavior. Tooltip shown for the object "any" in rules says
	"to modify the rule drag and drop an object from the tree here"
	instead of atributes of the object "any".

	* FWBSettings.cpp (init): fixed #1738 "Enable tooltips by default"

	* ObjectManipulator.cpp (editSelectedObject): fixed #1729 "double
	clicking a folder in the tree should expand it rather than open it
	in the editor".

	* ObjectTreeView.cpp (edit): fixed #1732 "Double clicking on
	object with child objects should auto expand them".  Double
	clicking on objects and folders in the tree expands and collapses
	them, as well as opens object in the editor.

	* ObjectManipulator.cpp (expandObjectInTree): fixed #1715
	"automatically expand new firewall and new host objects in the
	tree once they are created"

	* configlets/linux24/check_utilities: fixed #1714 "make checking
	for MODPROBE conditional". There is no need to check if modprobe
	utility exists on the firewall machine if it is not used by the
	script.

2010-09-22  Vadim Kurland  <vadim@vk.crocodile.org>

	* instDialog_ui_ops.cpp (instDialog::readInstallerOptionsFromFirewallObject): 
	fixed #1724 . There was a problem with pscp.exe and putty
	sessions. Plink.exe accepts session name in place of the host name
	on the command line, but pscp.exe does not. We ask user to enter
	session name in the "alternative name or address to use to
	communicate with the firewall" input field in the "Installer" tab
	of the firewall settings dialog and then use it in place of the
	host name in the command line for pscp.exe and plink.exe. This
	works with plink.exe but breaks pscp.exe which interprets it as a
	host name and fails with an error ""ssh_init: Host does not
	exist". The fix checks if what user entered in the "alternative
	host or address field" is a session name and uses different
	command line with pscp.exe

2010-09-20  Vadim Kurland  <vadim@vk.crocodile.org>

	* NATCompiler_ipt.cpp (compile): fixed SF bug #3071667
	"Compilation segfault with DNS address in NAT rule". Added rule
	processors to replace Run-time DNSName and Address Table objects
	in TSrc and TDst.

2010-09-16  Vadim Kurland  <vadim@vk.crocodile.org>

	* SSHSession.cpp: Refs #1699 installation session status was reset
	from "failure" to "success" in a configuration where fwbuilder gui
	was running on Windows and talked to Cisco router using pscp.exe
	and plink.exe and ssh session failed because of authentication
	failure. This happened because plink.exe terminated with return
	status "success" even in case of authentication failure.

	* generatedScriptTestsIpfilter.cpp (GeneratedScriptTest::runCompiler):
	unit tests to test manifest and activation commands in the generated
	.fw script for ipfilter. Refs #1702

	* FirewallInstaller.cpp (FirewallInstaller::getGeneratedFileFullPath): 
	fixed how we append suffix ".fw" to the name of generated script
	when it is preconfigured in the firewall settings dialog and already
	includes ".fw" suffix (it was added twice).

	* CompilerDriver_ipf_run.cpp (CompilerDriver_ipf::run): fixed #1702
	"Wrong path in the activation script for ipfilter". Activation command
	embedded in the generated .fw script used local path to the generated
	.conf file on the machine where fwbuilder compiler was running.

2010-09-14  Vadim Kurland  <vadim@vk.crocodile.org>

	* FirewallInstaller.cpp (getGeneratedFileFullPath): fixed SF bug
	3049665 "Firewall Settings -> Output file name misses .fw
	extension"

	* CompilerDriver_ipt_policy.cpp (processPolicyRuleSet): fixed
	#1707 "call function "prolog_commands" from the main iptables
	script part instead of function "script_body" when prolog should
	be executed after iptables reset"

	* configlets/linux24/script_skeleton (cmd): fixed SF bug 3060325
	"Address table object and prolog script conflict". Generated
	script should run prolog before checking and loading run-time
	address tables.

	* NATCompiler_PrintRule.cpp (processNext): fixed SF bug 3057503
	"DNAT rule with dynamic IP has a white space, causing error".

	* PolicyCompiler_PrintRule.cpp (_printIpSetMatch): fixed #1705
	"iptables (v>=1.4.4) "--set option deprecated ..."  (SF bug 3059893)
	Option "--set" has been deprecated and renamed "--match-set" in
	iptales 1.4.4

	* CompilerDriver_pf.cpp (printPathForAllTools): fixed SF bug
	3061034 "ifconfig definition missing". Script generated for the
	ipfw firewall on Mac OS X missed definition of variable IFCONFIG.

2010-09-13  Vadim Kurland  <vadim@vk.crocodile.org>

	* IPTImporter.cpp (addPktTypeMatch), iptables.g: fixed #1703
	"importing iptables line with module pkttype causes parser
	error". We do not have any object with the behavior closely
	resembling that of iptables module "pkttype" so the importer
	creates CustomService object with the code taken from the original
	iptables rule. SF bug 3065435

	* VERSION (FWB_MICRO_VERSION): started 4.1.2

2010-08-20  Vadim Kurland  <vadim@fwbuilder.org>

	* v4.1.1 released

2010-08-19  Vadim Kurland  <vadim@vk.crocodile.org>

	* NATCompiler_ipt.cpp (splitNATBranchRule::processNext): fixed #1686
	"can not generate basic NAT branching rule". NAT branching rules
	were not generated in single rule compile mode because compiler
	needs information about targets used in the branch rule set rules
	to decide which chain the branching rule should be placed in. Now it
	will use PREROUTING and POSTROUTING in single compile mode but issue
	a warning.

	* NATCompiler_ipt.cpp (VerifyRules2::processNext): fixed #1685
	"iptables redirecting NAT rules in the OUTPUT chain". NAT rules
	should be allowed to translate from CustomService to TCP or UDP
	service, provided CustomService object is configured with matching
	protocol. See also change in libfwbuilder NATCompiler::classifyNATRule::processNext.

	* NATCompiler_ipt.cpp (localNATRule::processNext): see #1685
	"iptables redirecting NAT rules in the OUTPUT chain". This fix
	makes it possible to create iptables NAT rule with target REDIRECT
	in the OUTPUT chain. The rule should have firewall object in OSrc
	and TDst rule elements.

	* NATCompiler_PrintRule.cpp (PrintRule::processNext): fixed #1693
	SF bug 3048516 "NAT rule with 'Use SNAT instead MASQ' doesn't
	work".  NAT rule using combination of the option "Use SNAT instead
	of MASQ", dynamic address of an interface and source port
	translation produced iptables command with incorrect syntax.

2010-08-18  Vadim Kurland  <vadim@vk.crocodile.org>

	* Helper.cpp (list): fixed #1691 , this is a better fix for the
	problem reported in the earlier bug (see #1690).
	Function Helper::findInterfaceByNetzone() throws FWException, this
	changed in v4.1.0 with a fix for #1653.

2010-08-17  Vadim Kurland  <vadim@vk.crocodile.org>

	* procurveInterfaces.cpp (procurveInterfaces::parseVlan): fixed #1683
	class procurveInterfaces interprets interface "DEFAULT_VLAN" as
	vlan interface with vlan id 1.

	* newFirewallDialog.cpp (newFirewallDialog::finishClicked):
	fixed #1683 When user creates new firewall using snmp scan,
	fwbuilder will now guess and assign the type to interfaces that
	look like vlans for the given platform and host OS.

	* safety_net_acl: fixed #1687 "temporary access list commands
	syntax is incorrect". Temporary ACL generated for the Procurve
	platform was incorrect.

	* PolicyCompiler_cisco.cpp (PolicyCompiler_cisco::setAllNetworkZonesToAny): 
	fixed #1690 "IOS ACL and Procurve ACL compilers fail because
	interfaces are not assumed to have network zone "any" anymore".
	Compilers for Cisco IOS ACL and Procurve ACL always assumed all
	interfaces have network zone "any". Recent changes made in 4.1.0
	changed that and compilers stopped working for some rule configurations.

	* (PolicyCompiler_cisco::createACLObject): fixed #1688 "Procurve
	ACL remarks should be in quotes if they include space"

2010-08-14  Vadim Kurland  <vadim@vk.crocodile.org>

	* FirewallInstallerProcurve.cpp (FirewallInstallerProcurve::packInstallJobsList): 
	Policy installer for HP Procurve. Currently only works in line-by-line
	mode (no support for scp). Tested with Procurve firmware K14.31 on
	ProCurve J9470A Switch 3500-24. Caveat: manager access should not be
	configured with user name (that is, no "password manager user-name foo")

	* set version to 4.1.1
	
2010-08-10  Vadim Kurland  <vadim@vk.crocodile.org>

	* v4.1.0 released

2010-08-08  Vadim Kurland  <vadim@vk.crocodile.org>

	* ObjectManipulator_ops.cpp (ObjectManipulator::actuallyDeleteObject):
	fixed #1674 "Crash while using Undo Stack". Operation "Cut" should be
	represented by an undo macro object and should appear as one operation
	on the undo stack.

	* ObjectManipulator.cpp (ObjectManipulator::getMenuState): fixed #1676
	"Crash when deleting an interface that has multiple IP addresses
	and not all addresses are selected for deletion"

2010-08-06  vadim  <vadim@vk.crocodile.org>

	* ObjectManipulator_tree_ops.cpp (ObjectManipulator::clearObjects):
	fixed crash that happened on Mac if the GUI was started with a
	file name as command line argument. The issue was introduced recently
	when GUI state update was reimplemented as an event.

2010-08-05  Vadim Kurland  <vadim@vk.crocodile.org>

	* ProjectPanel_events.cpp (event): fixed #1660 "Crash when
	cut-and-pasting firewall between libraries". GUI crashed if user
	performed the following sequence: cut an object, switch to a
	different object library, try to paste using keyboard shortcut
	Ctrl-V while library object was selected in the tree.

2010-08-04  Vadim Kurland  <vadim@vk.crocodile.org>

	* IPTImporter.cpp (IPTImporter::finalize): fixed #1664 "Policy
	import creates firewall object w/o version". This also fixes
	crash reported in SF bug #3036934

	* pixAdvancedDialog.cpp (pixAdvancedDialog::displayCommands):
	fixed SF bug #3038945 "ASA inspect configurations not saved".
	Under some circumstances the GUI did not save changes made in the
	"Inspectors" tab of the PIX advanced settings dialog into the
	object.

	* ObjectManipulator_tree_ops.cpp (ObjectManipulator::removeObjectFromHistory):
	fixed #1661 "Crash after deleting firewall" a sequence where user deleted
	an object and then hit "Back" button caused crash.

2010-08-03  Vadim Kurland  <vadim@vk.crocodile.org>

	* pixAdvancedDialog.cpp (pixAdvancedDialog): fixed SF bug #3038948
	"ASA logging severity levels are incremented". Log levels in the
	"Logging" tab of the PIX firewall advanced settings were
	incremented every time user opened the dialog and then clicked OK.

	* PolicyCompiler_PrintRule.cpp (_printIP): fixed SF bug #3038636
	@v4.1b, "iptables v1.4.8: unknown option `--ra'". Ipv4options
	module has changed in iptables 1.4.3 and now accepts different set
	of parameters. Policy compiler generates new parameters if user
	set version in the firewall object dialog to "1.4.3 or later".

2010-08-02  Vadim Kurland  <vadim@vk.crocodile.org>

	* InterfaceDialog.cpp (loadFWObject): fixed #1657 "When no network
	zone is defined on the interface, the Interface object editor says
	it is "Any" which is a lie"

	* configlets/linux24/run_time_address_tables: fixed #1652 "support
	for adding single address to address table in the generated
	script". Generated iptables script now provides functions
	"add_to_address_table", "remove_from_address_table" and
	"test_address_table" that let administrator add or remove single
	ip address to a given address_table.

	* OSConfigurator_linux24.cpp (printRunTimeAddressTablesCode):
	fixed #1654 "Support for run-time Address Tables with empty file
	in iptables". This is an implementation of the same feature we
	already have for PF. If the file name in the configuration of the
	run-time Address Table object is blank, policy compiler generates
	firewall configuration that uses ipset with the name the same as
	the name of the object but does not generate code to load
	addresses from a file into it. All control of the ipset is left
	for the user.

	* Helper.cpp (findInterfaceByNetzone): fixed #1653 "Crash when
	compiling a rule for Cisco PIX with incorrect network zone".

2010-07-29  Vadim Kurland  <vadim@vk.crocodile.org>

	* instDialog_installer.cpp (instDialog::installerSuccess):
	fixed #1639 "Add success message to the bottom of the process log
	for the installer". Added a message to the installer log to
	display installation status.

	* stop_action: "stop" action should reset ipv4 iptables
	configuration only if firewall object configuration defines any
	ipv4 rules. This is how generated script works for ipv6; behavior
	for ipv4 and ipv6 should be similar. Fixes SF bug #3036541 "IPV6
	only firewall resets ipv4 stack"

	* script_skeleton (cmd): added action "block" to the "usage" string
	of the generated iptables script

2010-07-28  Vadim Kurland  <vadim@vk.crocodile.org>

	* PolicyCompiler_ipt.cpp (checkActionInMangleTable::processNext):
	fixed SF bug 3034628 "iptables does not allow target REJECT in
	mangle table". Iptables does not support target REJECT in mangle
	table. Added check to the policy compiler to make it detect this
	situation and issue an error.

	* FWWindow.cpp (FWWindow::compile): fixed SF bug 3035426 "canceled
	save writes .fwb ". The program created file with name ".fwb" if
	user started with an empty project paje, created some objects, then
	hit "Compile" but then clicked "Cancel" when offered a chance to
	save objects into a new data file.

	* CompilerDriver.cpp (CompilerDriver::_findImportedRuleSetsRecursively):
	fixed #1631 "Process branch rule sets recursively". Policy
	compilers used to look only one level deep while processing
	branching rules.  They should allow for arbitrary nesting and
	correctly avoid infinite loops if user creates looped branches.
	Compiler issues a warning when it detects looped bracnhing.
	This fixes SF bug 3033462 "nested shared branch rules between
	servers not working".

	* UsageResolver.cpp (UsageResolver::findWhereUsedRecursively):
	fixed #1632 "dependencies created by branching rule sets should be
	processed recursively". In the case of multi-level branches
	the GUI should trace all references to find all firewalls affected
	by a change of an object used in the rule.

2010-07-27  Vadim Kurland  <vadim@vk.crocodile.org>

	* configlets/linux24/block_action: fixed #1640 "default policy
	when the script is stopped should be optional". The "stop" command
	used to be interpreted by the iptables script generated by
	fwbuilder in a way that it blocked all connections going to, from
	and through the firewall. Luc Paulin <lpaulin@touchtunes.com>
	pointed out that this behavior is incompatible with other firewall
	management scripts, such as /etc/rc.d/init.d/iptables on Fedora
	Linux or ufw on Ubuntu, where "stop" means disabling the firewall.
	In v4.1 the "stop" command flushed all chains in all tables and
	sets default policy to ACCEPT. New command "block" does what
	"stop" used to do before, that is, flushes all chains in all
	tables and sets default policy to "DROP". The option to add
	a rule to permit ssh access from the management workstation when
	firewall is stopped now adds this rule when firewall script is
	run with "block" command instead.

2010-07-26  Vadim Kurland  <vadim@vk.crocodile.org>

	* configlets/linux24/run_time_address_tables: implemented support
	for mixed address lists for run-time address table objects using
	ipset module. Normally, one ipset set can either contain
	individual ip addresses or subnets. We create a "setlist" type set
	that includes two sub-sets, one for ip addresses and the other for
	subnets. Function reload_address_table in the configlet
	run_time_address_tables takes care of managing these three sets
	automatically. Address list file has the same format as for all
	other supported types of Address Table object: one address per
	line, subnets are defined using '/bitlength' or '/netmask' syntax,
	comments start with '#' or ';' character.

2010-07-24  Vadim Kurland  <vadim@vk.crocodile.org>

	* code cleanup. Removed bunch of warnings and cleaned up some test
	cases using small patches from Mike Slifcak  slif@bellsouth.net

2010-07-23  Vadim Kurland  <vadim@vk.crocodile.org>

	* Fixes #1635: included code generated by the configlet
	run_time_address_tables into script for all linux-based host
	OS (dd-wrt, openwrt, ipcop) even though most of they do not
	support ipset at this time. If ipset is not supported because
	iptables version is too old or the module is simply not available
	for the platform, user can just uncheck the checkbox in the
	firewall settings dialog and code generated by the configlet will
	support method of loading addresses from the file at run time
	based on script variables and a "while" loop.

	* script_skeleton: added command line argument "reload_address_table"
	that calls function reload_address_table and takes two additional
	arguments: set name and file name.

	* script_skeleton (cmd): calling functions to check if data files
	used by run time address table objects are available before making
	any changes to iptables policy. If files are not available, the
	script aborts and leaves iptables in the original state.  This
	fixes #1628 "generated script checks presence of the address table
	files after it sets default iptables policy to DROP". fixes #1628

	* run_time_address_tables: new configlet that adds shell code to
	check if all run time address table data files are present on the
	firewall machine and that ipset utility works and can communicate
	the the kernel driver. This configlet also defines a function to
	reload one ipset with given name and data file name and function
	to reload all ipsets used in the generated script. Fixes #1625, #1627

	* PolicyCompiler_PrintRule.cpp (PrintRule::normalizeSetName):
	fixed #1626 "convert space and other special characters found in
	the run time address table object into underscores". The name of
	the run-time Address Table object is used for the name of the
	ipset module set. Making sure the name is sanitized of the
	chanracters considered "special" by shell before it is used.

	* check_utilities: fixed #1625, #see 137: added ipset to the list
	of command line utilities generated iptables script can
	use. Script will check if the utility is present on the firewall
	if user requested use of iptables module "set" for run-time
	Address Table objects. Also added an input field for ipset in the
	advanced settings host OS dialog for Linux to let the user specify
	path to ipset if it is not standard.

2010-07-22  Vadim Kurland  <vadim@vk.crocodile.org>

	* PolicyCompiler_PrintRule.cpp: added support for iptables module
	"set" used to generate iptables command for rules with run-time
	AddressTable objects. This module is only available in iptables
	1.4.1.1 and later, however some embedded platforms do not have it
	even though they ship later versions of	iptables (e.g. OpenWRT).
	Use of this module is controlled by a checkbox in the iptables 
	"advanced" settings dialog which is off by default. This checkbox
	becomes disabled when iptables version is set to < 1.4.1.1.

	* newClusterDialog_create.cpp (newClusterDialog::createNewCluster):
	fixed #1622 "Crash when configuring cluster". The GUI used to crash
	if user created a cluster copying rules of one of the cluster members
	while that rule set was opened in the rule set view.

2010-07-21  Vadim Kurland  <vadim@vk.crocodile.org>

	* iptadvanceddialog_q.ui: rearranged elements in the tab
	"Compiler" of the dialog to make it shorter and wider. Still
	needs some work to make it render better.

	* InterfaceEditorWidget.ui: set minimum height for the name, label
	and few other input fields because they came out squished on Mac.
	Fixes #1613.

	* FWWindow.cpp (fileNew): fixed #1611 "File/New should create new
	project panel". Like #1612, open new data file in a new project
	panel if current project panel has no data file associated with it
	but has unsaved changes.

	* FWWindow.cpp (loadFile): fixed #1612 "File/Open should create
	new project panel". If user has some unsaved changes in the
	default project panel (the one with no associated file) and then
	uses File/Open menu to open another data file, the file should
	open in a new project panel.

2010-07-20  Vadim Kurland  <vadim@vk.crocodile.org>

	* FWWindow.cpp (FWWindow::showEvent): default main window geometry
	should be 1000x600, wider than it used to be before. This is to
	make object dialogs fit in the main window without squishing.

	* routing_functions: added a copy of the routing_functions
	configlet to the dd-wrt-nvram and dd-wrt-jjfs because newest
	versions of DD-WRT lack mktemp. The original routing_functions
	configlet does not use mktemp either, but Gentoo (and possibly
	other distros) ship patched version that needs mktemp which breaks
	fwbuilder generated script on these versions of DD-WRT. Hopefully
	they won't patch the copy of routing_functions configlet.

	* StartTipDialog.cpp (StartTipDialog::StartTipDialog): fixed #1603
	"Welcome dialog should show full version of the program".

	* set version to 4.1.0 and version of the data file format to
	"17". Data files need to be upgraded. Upgrade script changes the
	version and makes sure Standard objects library is read-only. Some
	users may have this library configured read-write in their data
	files because of a bug in the early versions of fwbuilder 4.

	* We have decided to release this version as 4.1.0 rather than
	4.0.2.  "4.0.2" will remain our internal testing version
	designation.

2010-07-19 Roman Bovsunivskiy <a2k0001@gmail.com>

	* DiscoveryDruid_q.ui, newclusterdialog_q.ui, newfirewalldialog_q.ui:
	  Set up default buttons in dialogs

	* DiscoveryDruid_q.ui, DiscoveryDruid.cpp, Importer.cpp: Added firewall
	name input field.

	* InterfaceEditorWidget.cpp: Button "Add address" now changes text
	to "Add anoter address" when there is at least one address in current 
	interface.

2010-07-19  Vadim Kurland  <vadim@vk.crocodile.org>

	* objects_init.xml.in: fixed bug #3031721 "Qt has caught an
	exception thrown from an event handler." The "Standard" objects
	library was made read-write in one of the earlier builds

2010-07-17  Vadim Kurland  <vadim@vk.crocodile.org>

	* DiscoveryDruid.cpp (DiscoveryDruid::DiscoveryDruid): fixed #1597
	import method "import configuration of a firewall" is disabled on
	the first page of the discovery druid

2010-07-15  Vadim Kurland  <vadim@vk.crocodile.org>

	* newFirewallDialog_from_template.cpp (newFirewallDialog::replaceReferencesToNetworks):
	fixed #1582 'tree is not refreshed after address substitutions in
	"new firewall" wizard'

2010-07-14  Vadim Kurland  <vadim@vk.crocodile.org>

	* FirewallInstaller.cpp (FirewallInstaller::packSCPArgs): 
	fixed #1571 "Installer does not work if firewall object name
	contains spaces". Installer should use escaping to make sure
	file name with a space is correctly interpreted by the script
	it runs on the firewall.

	* DiscoveryDruid.cpp (DiscoveryDruid::loadDataFromImporter):
	fixed #1544 "fwbuilder crashes during import of file with rtf
	formatting data". The fix should prevent crashes in other cases
	when import was unsuccessful.

2010-07-13  Roman Bovsunivskiy <a2k0001@gmail.com>
	* instdialogoptions_q.ui: Added "Cancell All" button to stop all
	firewalls installations, renamed OK button to "Install"
	* instDialog_ui_opts.cpp (instDialog::getInstOptions): added support
	for "Cancel All" dialog result code.

2010-07-12  Roman Bovsunivskiy <a2k0001@gmail.com> 
	* instDialog_ui_opts.cpp (intDialog::fillCompileSelectList): fixed
	wrong display of non-ascii symbols in cluster member compilation
	warning.
	* newFirewallDialog.cpp (newFirewallDialog::showPage): firewall names
	are now resolved to IP address. Added new input element for firewall
	IP address to use for SNMP interface discovery.

2010-07-11  Vadim Kurland  <vadim@vk.crocodile.org>

	* FirewallInstaller.cpp (FirewallInstaller::packSSHArgs): fixed
	bug 3027284: "redux settings for scp/ssh to respond to line
	failure". The solution for bug 3020381 used to force ssh and scp
	commands to use the parameters ServerAliveInterval and
	ConnectTimeout to activate and configure ssh keepalive protocol.
	These command line parameters were enforced and added to the input
	fields where user enters the path to ssh and scp utilities on the
	machine where fwbuilder GUI is running. This was confusing and
	poor GUI design as the program was changing fields that were
	supposed to be user-editable. This fix adds an input field for the
	timeout value in seconds to the "Installer" tab of the global
	preferences dialog. The program does not change strings entered by
	the user for ssh and scp path anymore. The same timeout value is
	used to set up ServerAliveInterval parameter for ssh,
	ConnectTimeout parameter for scp and registry entries required by
	plink and pscp on Windows.

2010-07-10  Vadim Kurland  <vadim@vk.crocodile.org>

	* Importer.cpp (Importer::getFirewallObject): fixed bug #3027272:
	"default values taken from unexpected sources". When new firewall
	object was created using "Import Policy" function, parts of its
	configuration were taken from default settings of an unexpected
	host OS.

2010-07-09  Roman Bovsunivskiy <a2k0001@gmail.com>

	* newFirewallDialog.cpp (newFirewallDialog::finishClicked): fixed
	crash when clicking finish after getting error about wrong IP
	address or netmask

	* FirewallCodeViewer.cpp (FirewallCodeViewer::fileSelected): now 
	when viewing again file that was viewed before scroll position is
	same as user left it.

	* instDialog_q.ui: renames "All" button to "Select all" and "None"
	to "Select none"

	* instDialog.cpp (instDialog::show): hide "Select all" and "Select none"
	buttons when there is only one firewall in list

	* instDialog.cpp (instDialog::showPage): next button on inspect page
	is now not enabled if dialog called for compile only

2010-07-05  Roman Bovsunivskiy <a2k0001@gmail.com>
	
	* instDialog.cpp (instDialog::findFirewalls): sorting of filewall
	and cluster items in compile/install dialog is now case insensitive.
	
	* ProjectPanel.cpp (ProjectPanel::inspectAll)
	* ObjectManipulator.cpp (ObjectManipulator::inspet): inspect is now
	working with cluster objects.

2010-07-03  Vadim Kurland  <vadim@vk.crocodile.org>

	* RuleSetView.cpp (RuleSetView::restoreCollapsedGroups): fixed
	SourceForge bug 3020761 "printing from command line causes
	Segmentation fault". Fixes #1533

2010-06-28  Vadim Kurland  <vadim@vk.crocodile.org>

	* utils.cpp (parseCommandLine): See #1542 since now user can enter
	differet command line parameters together with the path to ssh and
	scp clients in the global Preferences dialog, we need to parse
	these properly. This is especially important if file paths or
	arguments contain white space characters. Unit tests are in
	src/gui/unit_tests/parseCommandLineTest

2010-06-26  Vadim Kurland  <vadim@vk.crocodile.org>

	* installer_commands_reg_user: all instllation commands should be
	on the single line in the configlet so they are sent to the
	firewall as one line. When these commands were on separate lines,
	linefeed characters between them appeared on the standard input of
	command "sudo -S" and broke installation process. This only
	happened in my tests when I ran GUI installer on windows and
	looked like some sort of a race. When all commands are on the one
	line the problem disappeared. Changed only configlets that used
	sudo as part of installation script.

	* CompilerDriver_pix_run.cpp (CompilerDriver_pix::pixNetworkZoneChecks):
	do not verify network zones of unprotected interfaces. Compiler
	does not allow the same obejct to be used as network zone of two
	different interfaces, which caused problems when a vlan parent
	interface has zone "Any". Vlan parent interface can not have ACLs
	attached to it and does not need any meaningful network zone, so
	"Any" is reasonable fill-in choice. However it coinsides with network
	zone of the "outside" interface which triggered this check.

	* SSHUnx.cpp (SSHUnx::stateMachine): SF bug 3020381: "Line failure
	should abort remote firewall install". If network connection is
	lost during firewall policy activation, policy installer should
	detect this, disconnect and declare installation session a
	failure.  Prior to v4.0.2, installer detected network failures
	during policy copy (done with scp) or when it could not connect to
	the firewall at all, but hang if connection was lost in the middle
	of ssh session used to activate firewall policy. Now using ssh
	parameter "ServerAliveInterval" to make it detect connection
	failure. This does not work with plink.exe on Windows which does
	not support these command line options. Still looking for a
	solution.

	* FWBSettings.cpp (FWBSettings::init): automatically adding ssh
	parameters "-o ServerAliveInterval=2 -o ServerAliveCountMax=15" and
	scp parameter "-o ConnectTimeout=30" to the path to ssh and scp in
	the global preferecnes dialog, tab "Installer" to activate ssh
	keepalive.  This way, user can change values if they need
	to. Default values define 30 sec timeout which should be rather
	conservative. On windows automatically configuring plink.exe and
	pscp.exe to load parameters of putty session "fwb_session_with_keepalive"
	that turns keepalives on.

2010-06-25  Roman Bovsunivskiy <a2k0001@gmail.com>

	* FirewallCodeViewer.cpp (FirewallCodeViewer::FirewallCodeViewer):
	See #1346. Mostly completed implementation of the viewer panel
	that can be used to inspect generated firewall configuration files
	from within the GUI. The panel can be opened using a button in the
	mini-toolbar above firewall rules or as a page in the compile and
	install wizard.

2010-06-24  Vadim Kurland  <vadim@vk.crocodile.org>

	* OSConfigurator_linux24::printVirtualAddressesForNatCommands:
	fixed bug 3001228 "v4.0.0 iptables: NAT not creating interface
	addresses". Iptables script generated by fwbuilder used to include
	commands to configure virtual ip addresses for NAT only if option
	"configure interfaces" was turned on. Expected behavior is to
	generate these commands when option "Add virtual addresses for
	NAT" is turned on regardless of the setting of the option
	"configure interfaces".

2010-06-22  Roman Bovsunivskiy <a2k0001@gmail.com>

	* fixed #1526 "Make sure GUI unit tests work in the environment
	where user turned off tip of the day dialog". Unit tests now use
	alternative settings file with all default values and do not
	depend on user's preferences.
	
2010-06-18  Roman Bovsunivskiy <a2k0001@gmail.com>

	* fixed #1520 ("Comment field display clips comment text"
	
	
2010-06-17  Vadim Kurland  <vadim@vk.crocodile.org>

	* PolicyCompiler_ipt.cpp (specialCaseWithFWInDstAndOutbound::processNext):
	fixed #1523 "outbound ipv6 rule matching multicast ipv6 destination
	is not generated". The rule with network object fe80::/10 in source
	and ipv6 muticast ff00::/8 in destination did not produce correspondign
	ip6tables command. The change affects other cases with rules using
	broadcast or multicast objects that should be considered matching
	the firewall object.
	
	
2010-06-17  Roman Bovsunivskiy <a2k0001@gmail.com>

	* RuleSetView.cpp: fixed SF bug 3016680 "Vertical scrollbar issue"
	rules with a lot of objects did not scroll properly vertically.

	* fixed #1493 "workflow icons in the big empty space". The GUI
	shows big buttons in the empty space in the right hand side of the
	main window when no firewall policy is not opened yet. These buttons
	provide simple shortcuts to the workflow functions useful for the
	novice users. Currently this includes "Create new firewall",
	"Import configuration of existing firewall" and "Watch Getting
	Started Tutorial".

	* fixed #1521 "GUI crashes upon exit on CentOS 5". This fixes
	SourceForge bug reports 3016482 "segfault with RHEL5 pre-built
	packages on CentOS 5.5" and 3015979 "fwbuilder not exiting in
	centos 5.5"

2010-06-16  Vadim Kurland  <vadim@vk.crocodile.org>

	* IPTImporter.cpp (IPTImporter::pushPolicyRule): fixed SF bug 3017084
	"compiler adds extra quote characters to log-prefix string".

2010-06-15  Vadim Kurland  <vadim@vk.crocodile.org>

	* IPTImporterRun.cpp (IPTImporter::run): policy importer for
	iptables replaces --sport and --dport parameters of module
	multiport with --source-ports and --destination-ports to remove
	grammar ambiguity that arises from the use of the same parameters
	--sport and --dport by different iptables modules with different
	argument syntax.

	* iptables.g (match_iprange_src): Fixed SF bug 3016779: Policy
	importer for iptables should understand module iprange

	* FWWindow.cpp (FWWindow::prepareFileMenu): fixed bug 3016720
	"import policy disabled after file close". Menu items "File/Import
	Library" and "File/Import policy" became disabled after user
	closed data file using "File/Close" and never became enabled
	again.

2010-06-14  Roman Bovsunivskiy <a2k0001@gmail.com>

	* FWBSettings.cpp (FWBSettings::init): fixed #1504 Added (optional)
	text to the toolbar buttons. Text is turned on by default but
	can be turned off in the global Preferences dialog.

	* Preferences.cpp: fixed #1505 move "Clip comments in rules"
	checkbox to "Appearance" tab.

2010-06-14  Vadim Kurland  <vadim@vk.crocodile.org>

	* release_notes_4.0.2.html: Added release notes for v4.0.2 to
	the package. fixes #1515

	* IPTImporter.cpp (IPTImporter::pushPolicyRule): fixed SF bug
	3015641 "imported REJECT rule changed during compile". Importer of
	iptables rules did not handle properly parameters of the REJECT
	target.

2010-06-12  Vadim Kurland  <vadim@vk.crocodile.org>

	* IPTImporter.cpp (IPTImporter::pushPolicyRule): fixed #1516
	policy importer for iptables should not use automatic ESTABLISHED
	rule. (See also SF bug 3012953).  Policy importer for iptables
	always creates explicit rule to match ESTABLISHED,RELATED to make
	sure it goes into the same chain as the original rule. Also in the
	same fix, importer creates branch for iptables rules that match
	both regular service and state ESTABLISHED,RELATED. The service is
	matched in the main policy rule set, while ESTABLISHED,RELATED
	state is matched in the branch.

	* GroupObjectDialog.h (class GroupObjectDialog): fixed #1499
	"GroupObjectDialogTest.cpp does not compile with gcc 3.4.6" and SF
	bug 3015307.  There is no reason to make method insertObject()
	protected which caused problems (and hacky workaround) in the unit
	test.

	* IPTImporter.cpp (IPTImporter::finalize): fixed SF bug #3015305
	"compile error XML validity ". The problem was introduced with a
	change that made policy importer cabaple of reproducing default
	policies of main chains.

2010-06-11  Vadim Kurland  <vadim@vk.crocodile.org>

	* fixed SF bug #3013743 "UI build warnings"

	* longtextdialog_q.ui, objconflictresolutiondialog_q.ui: fixed
	SF bug #3013735 "invalid pixmap properties during make". Fixed
	uic warnings.

	* IPServiceDialogTest.cpp (IPServiceDialogTest::testIpOptions):
	fixed SF bug #3013855 "various fixes for run_tests". Applied
	patch suggested by Michael J. Slifcak (with changes).

	* DiscoveryDruid.cpp (DiscoveryDruid::browseForImport): fixed SF
	bug #3013532 "file chooser dialog for import policy does not show
	all files".

	* IPTImporter.cpp (IPTImporter::finalize): fixed #1513 iptables
	importer should check default policy in standard chains. Importer
	creates rules at the bottom of the policy rule set to reproduce
	default policies in the built-in chains INPUT,OUTPUT,FORWARD.
	These rules are added only when default policy in these chains is
	set to ACCEPT because generated iptables script always sets
	default policies to DROP.  Support for this in the mangle table is
	limited so far, only default policies in PREROUTING, OUTPUT and
	POSTROUTING can be implemented. Rules created for the commands
	that set default policy in chains FORWARD and INPUT will generate
	commands in PREROUTING chain instead. We will try to address this
	in the future if there is sufficient demand.

2010-06-08  Vadim Kurland  <vadim@vk.crocodile.org>

	* applied patch from slif@bellsouth.net to fix compiler
	warnings. Patch applied partially since not all fixes were
	appropriate. fixes #1510

	* IPTImporter.cpp (IPTImporter::pushPolicyRule): fixed #1512 SF
	bug 3012953: iptables importer sometimes does not recognize rule
	with " ESTABLISHED,RELATED ". Parser properly processed iptables
	rules with state "RELATED,ESTABLISHED" but not when states were
	in the opposite order.

	* IPTImporter.cpp (IPTImporter::pushPolicyRule): policy importer
	for iptables can now parse numerical log levels.

	* Importer.cpp (Importer::getUDPService): fixed sourceforge bug
	3012953 name of UDP and TCP objects created during import should
	follow the same pattern and not include "0-0" for the source ports
	if they are equal to zero.

	* IPTImporter.cpp (IPTImporter::IPTImporter): fixed #1511, SF bug 3012953:
	iptables import parse error icmp_type any

2010-06-07  Vadim Kurland  <vadim@vk.crocodile.org>

	* CompilerDriver_pix_run.cpp (CompilerDriver_pix::pixNetworkZoneChecks):
	fixed #1491 fwb_pix crashes trying to compile simple rule. Compiler
	should check validity of the object used as network zone of an interface.

	* FWBSettings.cpp (FWBSettings::init): fixed #1501 call qsrand(seed)
	to seed random generator before generating new UUID

	* TransferDevice.h (fwtransfer): fixed #1490 compile problem with
	Qt 4.7

	* FWWindow.cpp (FWWindow::prepareRulesMenu): fixed #1489 removed
	unnecessary debugging messages.

	* interfaceProperties.cpp (interfaceProperties::manageIpAddresses):
	fixed #1506 SF bug #3011516: generated iptables script tries to
	update ip addresses of unnumbered interface.

	* v4.0.2 started

2010-06-06  vadim  <vadim@vk.crocodile.org>

	* FWBSettings.cpp (FWBSettings::FWBSettings): using separate
	settings object and file in the .ini format to store instance uuid
	to ensure uuid persistence on windows across upgrades done with
	complete deinstall. Fixes #1497

	* UserWorkflow.cpp (UserWorkflow::flagsToQueryString): added user
	workflow progress flags for an attempted install and first
	successful install. Both flags are boolean true/false indicating
	that the even occurred. We do not track and do not report any
	information about the firewall, platform, rules etc. These flags
	will be used to determine how many users abandon the program
	before even trying to run install for real because it is too
	complicated or the UI is not good enough. Fixes #1495

	* UserWorkflow.cpp (UserWorkflow::flagsToQueryString): added user
	workflow flag indicating that ssh/scp have been configured in the
	Prefereces dialog. The flag is boolean and registers only the fact
	that something was entered in ssh and scp fields. Actual path and
	programs used are not registered and reported. Fixes #1496

2010-06-03  vadim  <vadim@vk.crocodile.org>

	* v4.0.1 released

2010-06-02  vadim  <vadim@vk.crocodile.org>

	* Preprocessor.cpp (Preprocessor::findMultiAddressObjectsUsedInRules):
	change in libfwbuilder: fixed #1485 "dns name object is recognized
	as an empty group when it appears in shared rule set"

2010-06-02 yalovoy <yalovoy@gmail.com>

	* fixes #1484 "paste below" function pastes rules out of order
	1) copy 2 complete rules
	2) go to a(nother) policy
	3) right click on rule 0, say "paste rules below"
	=> BUG: the two rules from the buffer become rules 0+2, the original
	rule 0 becomes rule 1
	The original should stay rule 0, the two from buffer become 1+2
	Affected files: FWCmdRule.cpp, FWCmdRule.h, RuleSetView.cpp

2010-06-01  vadim  <vadim@vk.crocodile.org>

	* Help.cpp (Help::downloadComplete): fixed #1482 Class Help should
	open window only after successful download

	* ObjConflictResolutionDialog.cpp (ObjConflictResolutionDialog::run):
	refs #1483 If program detects change in CustomService object and
	the change just adds code string for a platform that was not
	in the object in the user's data file, the change is accepted without
	showing the dialog.

	* ../src/res/objects_init.xml.in: fixed #1483 "missing code in the
	custom service object ESTABLISHED for ProCurve"

2010-05-31  vadim  <vadim@vk.crocodile.org>

	* FWWindow.cpp (FWWindow::checkForUpgrade): added mechanism for
	one-time announcements that can be pulled from the web site
	when version check server says there is one. Announcement is
	shown only once. To do this, I store time stamp when it was shown
	in settings using hash of the announcement url.

	* Help.cpp (Help::setSource): made class Help capable of
	downloading contents via HTTP.

	* FirewallDialog.cpp (FirewallDialog::fillVersion): fixed #1481
	when user changes platform in the firewall object, its version
	should change too.

2010-05-28  vadim  <vadim@vk.crocodile.org>

	* ObjectManipulator.cpp (ObjectManipulator::editSelectedObject):
	see #1447 Reverting change done for ticket #1447 in r2892 and
	r2896 because of the user complaints. It appears to be more
	convenient if Policy, NAT and Routing objects open in the rule set
	view on double click but not in the editor. Second double clik
	opens these objects in the editor.

2010-05-25  vadim  <vadim@vk.crocodile.org>

	* configure.in (CPPUNIT_LIBS): fixed #1478 always use included
	antlr run-time library. Because of the fixes I've made in
	CircularQueue?.hpp in 2008 for 64 bit systems, we should always
	link with antlr run-time that is included with fwbuilder code tree
	rather than attempt to use the one that might be installed with
	the OS.

2010-05-24  vadim  <vadim@vk.crocodile.org>

	* UserWorkflow.cpp (UserWorkflow::report): see #1466 Implemented
	instrumentation that should help us improve user experience. Will
	track few things that new users do (or don't do) and report as a
	combination of boolean flags at the end of the GUI
	session. Reporting things such as if user ever looked at the
	"Getting Started" tutorial, if they created their first firewall
	object, modified any rules, tried to compile, install or import
	existing rule set. Information passed in the report is strictly a
	set of boolean flags, it is not identifiable and does not reveal
	what firewall platform they are using or anything about their
	objects and rules. List of flags is listed in the module UserWorkflow.h

2010-05-23  vadim  <vadim@vk.crocodile.org>

	* FWCmdAddObject.cpp (FWCmdAddObject::redo): fixed #1468 Open new
	object in the editor after it has been created.

	* applied patch by Vadim Jukov <persgray@gmail.com>, maintainer of
	OpenBSD port. Patch fixes compile issues on OpenBSD

2010-05-22 yalovoy <yalovoy@gmail.com>

	* fixes #1463 Always show branch rule set name with action "Branch"
	affected files: RuleSetView.cpp, RuleSetViewDelegate.cpp, RuleSetViewDelegate.h
	* fixes #1469 some actions should always display argument, even when text labels for actions and directions is off
	affected files: RuleSetViewDelegate.cpp

2010-05-21  vadim  <vadim@vk.crocodile.org>

	* RuleOptionsDialog.cpp (RuleOptionsDialog::loadFWObject):
	fixes #1467: "rule options dialog shows iptables parameters for
	procurve_acl"

	* FWObjectPropertiesFactory.cpp (FWObjectPropertiesFactory::getPolicyRuleOptions):
	fixes #1457 "tooltips for rule options seem to be broken". Tooltip
	always includes the line telling of the rule is "stateful" or
	"stateless", the function almost never returns empty string now.
	Added missing hashlimit parameters to the rule options
	tooltip. Some of the more rarely used hashlimit parameters are
	still not included in the tooltip. Improved tooltip formatting
	using html table.

2010-05-20  vadim  <vadim@vk.crocodile.org>

	* ProjectPanel.cpp (ProjectPanel::addRule): fixed #1461 Need
	obvious button to add new rule to the empty rule set

	* instDialog.cpp (instDialog::show): fixed #1462 "if you do a bulk
	install, and then want to do a single install, bulk mode is
	selected"

	* ActionsDialog.cpp (ActionsDialog::setRule): fixed #1464
	SourceForge bug 3004274: "Branch rule set object displays
	improperly".  Branch rule set attribute was not loaded properly
	into Branch action dialog for rules of PF firewalls.

2010-05-17  vadim  <vadim@vk.crocodile.org>

	* PolicyCompiler_iosacl_writers.cpp (PrintRule::_printRule):
	restored function of the "comment the code" in the "Script
	options" of the firewall settings dialog for Cisco IOS ACL and
	ProCurve ACL. When this checkbox is off, comments are not
	added to generated script.

	* RuleSetViewDelegate.cpp (RuleSetViewDelegate::paintOptions):
	fixed #1460 "when "show icons in rules" is turned off, there is no
	way to tell when logging is turned on and non-default options are
	present in a rule".

	* fixed #1339 "Logging" icon appears looking the same as "Rule
	options" icon on Mac

2010-05-15  Vadim Kurland  <vadim@vk.crocodile.org>

	* linux24Interfaces.cpp (linux24Interfaces::basicValidateInterfaceName):
	fixed #1458 Should permit interface name "br-lan" for bridge interface
	on Linux. Bridge interfaces on Linux can have any name, including those
	with "-". OpenWRT creates bridge interface with the name "br-lan" by
	default.

2010-05-14  Vadim Kurland  <vadim@vk.crocodile.org>

	* update_addresses: fixed #1455 Function update_addresses() (host
	OS linux24 and derivatives) uses both ip and ifconfig. Should stick
	with /sbin/ip so the script works on systems where ifconfig is
	not installed.

2010-05-13  Vadim Kurland  <vadim@vk.crocodile.org>

	* FWObjectDropArea.cpp (FWObjectDropArea::editObject): fixed #1452
	double click on a rule set in the branch action dialog should open
	it in rule set view

	* iptables.g (MATCH_RECENT_SET): see #1451 "policy importer should
	support some popular iptables modules". Added support for module
	"recent" and rules that match standard ip/icmp/udp/tcp protocols
	and at the same time module "mark", "length", "limit" or "recent".
	Rules like these are translated into a combination of a branching
	rule and additional rule in a branch rule set that implements
	module match.

	* iptables.g (multiport_tcp_udp_port_spec): fixes #1453 "iptables
	importer should parse multiport module parameter --ports". Module
	multuport with parameter "--ports" matches either source or
	destination port numbers. Importer creates two tcp (or udp)
	service objects to implement this match.

	* IPTImporter.cpp (IPTImporter::addSrv): See #1450, SourceForge
	ticket 3000809: iptables parser can now import "mark" module
	matches with hexadecimal parameters and "length" module
	matches. Also added check in the importer for broken iptables-save
	files where rules for any table are not terminated with "COMMIT".

2010-05-12  vadim  <vadim@vk.crocodile.org>

	* configlets/procurve/installer_commands_pre_config: commands
	for the installer for ProCurve

	* instDialog.cpp (instDialog::isCiscoFamily): Using the same
	built-in installer for Cisco and for ProCurve.

	* procurveaclAdvancedDialog.cpp (procurveaclAdvancedDialog::procurveaclAdvancedDialog):
	fixed #1449 options for ACL remarks and comments for ProCurve

	* PolicyCompiler_procurve_acl_writers.cpp (PolicyCompiler_procurve_acl::printAccessGroupCmd):
	generated commands that attach acl to a regular inetrface needed
	newline after "exit".

	* configlets/procurve/safety_net_acl: generating different
	commands in "Safety net" install mode depending on whether
	management interface is vlan or not.

2010-05-11  Vadim Kurland  <vadim@vk.crocodile.org>

	* ObjectManipulatorTest.cpp (ObjectManipulatorTest::editSelectedObject):
	see #1447 fixed unit test for this change

	* ../src/res/configlets/dd-wrt-jffs/installer_commands_root:
	fixes #1448 "need to commit nvram changes on DD-WRT".

	* ObjectManipulator.cpp (ObjectManipulator::editSelectedObject):
	fixes #1447: context menu item "Edit" associated with rule set
	object in the tree opens it in the rule set view and the editor
	panel. Menu item "Open" only opens it in the rule set view. This
	eliminates strange behavior where it would open in the rule set
	view on first click on "Edit" and then in the editor in the second
	click on "Edit". Double click used to work the same, the first
	double click opened in rule set view, the second in the
	editor. Now double click always opens in rule set view and the
	editor which is more consistent with the behavior for other object
	types.

	* PolicyCompiler_procurve_acl_writers.cpp (PolicyCompiler_procurve_acl::printAccessGroupCmd):
	ProCurve uses different syntax for vlan ACLs and ACLs bound to
	switch ports. Enabled "advanced interface settings" dialog for
	ProCurve interfaces.

	* InterfaceDialog.cpp (InterfaceDialog::loadFWObject): button
	"Advanced interface settings" is controlled by element
	<supports_advanced_interface_options> in the host OS xml resource
	file. Before, it was controlled by the element
	<supports_subinterfaces>. I need this button and associated dialog
	for vlan interfaces on ProCurves, where vlan interfaces are not
	subinterfaces.

2010-05-10  vadim  <vadim@vk.crocodile.org>

	* CompilerDriver_procurve_acl_run.cpp (CompilerDriver_procurve_acl::run):
	See #1442 Support for HP ProCurve. Added experimental support for
	HP ProCurve "intelligent" switches (L3). Code is based on the policy
	compiler for Cisco IOS extended access lists. Differences include
	';' character for comments, different naming convention for Vlan
	interfaces ("VLAN 2", with a space), requirement to unbind an ACL
	from interface before it can be cleared.

	* CompilerDriver_iosacl.cpp (CompilerDriver_iosacl::safetyNetInstall):
	using configlet "safety_net" to add temporary ACL for the "safety
	net" install method.

2010-05-05  Vadim Kurland  <vadim@vk.crocodile.org>

	* ProjectPanel_events.cpp (ProjectPanel::event): fixed #1443
	GUI crashes compiling file opened read-only. If a file that was
	added to RCS was opened read-only and then any firewall object
	in it compiled, the GUI crashed trying to update "last_compiled"
	timestamp.

	* ssh_wrappers.cpp: fixed #1444 compile error on FreeBSD-Current
	Compiler issues error "/usr/include/utmp.h:2:2: error: #error
	<utmp.h> has been replaced by <utmpx.> h>"

	* started work on v4.0.1. VERSION set to 4.0.1 in libfwbuilder and
	fwbuilder

2010-05-04  Vadim Kurland  <vadim@vk.crocodile.org>

	* v 4.0.0 released

2010-05-02  Vadim Kurland  <vadim@vk.crocodile.org>

	* Helper.cpp (Helper::findInterfaceByNetzone): fixed #1439 "ssh
	access rule uses wrong interface in the generated PIX config"

	* instDialog_ui_ops.cpp (instDialog::opError): fixed #1438
	"installer crashes when user interrupts install to PIX". This only
	affected installs to PIX cluster and only if user decided to
	interrupt the process.

2010-05-01  vadim  <vadim@vk.crocodile.org>

	* new_object.cpp (_modObject): fixed #1437: fwbedit should support
	object type Cluster.

	* fwbedit.cpp (usage): fixed #1435: typo in fwbedit "usage" text

	* new_object.cpp (_modObject): fixed #1434 "fwbedit modify comment
	operation expects an attribute"

	* instDialog.cpp (instDialog::show): fixes #1433 "batch install"
	checkbox should be enabled even when when there is only one
	cluster in the list of objects to compile and install.

	* CompilerDriver_ipt_policy.cpp (CompilerDriver_ipt::processPolicyRuleSet):
	fixes #1432 "automatic rule with --restore-mark is missing if
	rules using action Tag are not in the default Policy rule set".

2010-05-01  yalovoy <yalovoy@gmail.com>
	* RuleSetView.cpp: fixes #1431 GUI crash adding rules to rule group

2010-05-01  vadim  <vadim@vk.crocodile.org>

	* PolicyCompiler_ipt.cpp (PolicyCompiler_ipt::insertFailoverRule):
	fixed #1411 outbound rule that permits VRRP should be added
	outside the loop to avoid duplicate rules for clusters with 3 or
	more members.

2010-04-29  Vadim Kurland  <vadim@vk.crocodile.org>

	* SSHSession.cpp (SSHSession::terminate): see #1426, #1428
	QProcess sends signal "finished()" during event processing on
	windows, added checks for that.

	* instDialog.cpp (instDialog::mainLoopInstall): disabling and
	enabling "stop" button in the compile/install dialog appropriately

2010-04-28  Vadim Kurland  <vadim@vk.crocodile.org>

	* instDialog.cpp (instDialog::show): fixes #1429 "Finish" button
	is activated during compile. Also added unit test for this.

2010-04-27  vadim  <vadim@vk.crocodile.org>

	* CompilerDriver_ipt.cpp (CompilerDriver_ipt::dumpScript): fixes #1425
	"iptables script generated for the empty rule set is broken". Compiler
	generated empty shell function for empty Policy rule set. It should
	always include at least automatic rules.

	* SSHSession.cpp (SSHSession::terminate): see #1426, #1428 use
	QProcess::waitForFinished() instead of just sleep() after we send
	TERM signal to the background process. Also let Qt process events
	to update the GUI while waiting.

	* instDialog_installer.cpp (instDialog::stopInstall): fixed #1428
	button "Stop" in the installer dialog does not stop installer
	process

	* SSHSession.cpp (terminate): fixes #1426 "segfault when cancel
	while installing" (SF bug 2990333). No need to process events in
	terminate(); instead, using QProcess::waitForFinished() to give
	QProcess object opportunity to call this signal if user hit Cancel
	at just right time when background process has finished but
	QProcess has not noticed this yet. This situation caused crash
	reported in the SF bug. This problem appears to be specific to
	some versions of Qt. It does not happen with Qt 4.5.0 or Qt 4.6.2
	but happens with 4.5.3.

	* instDialog_ui_ops.cpp (addToLog): working on #1426 "segfault
	when cancel while installing". SF bug 2990333. Processing of large
	chunks of compile or installer output took long time, especially
	scanning for errors and warnings which involves RegEx
	match. Splitting the buffer onto individual QString lines and
	matching each line against all error and warning pattern regexes
	made it much faster. Also do not call qApp->processEvents() from
	addtoLog() to avoid recursive call.

	* PolicyCompiler_ipt.cpp (PolicyCompiler_ipt::checkForShadowingPlatformSpecific):
	see #1417 (SF bug 2992177) rule with greater limit module rate
	value shadows rule with lower rate value. Comments in the code
	explain why.

2010-04-26  vadim  <vadim@vk.crocodile.org>

	* PolicyCompiler_ipt.cpp (PolicyCompiler_ipt::checkForShadowingPlatformSpecific):
	additional fix for #1417 (SF bug 2992177): compiler should compare
	limit rate value and other parameters set for modules limit,
	connlimit and hashlimit while deciding if rules shadow each other.

2010-04-24  Vadim Kurland  <vadim@vk.crocodile.org>

	* PolicyCompiler_ipt.cpp (PolicyCompiler_ipt::checkForShadowingPlatformSpecific):
	fixes #1417 rule shadowing detection should recognize different
	rule options.  Policy compiler for iptables takes into account
	rule options for modules limit, connlimit and hashlimit when it
	considers rules for rule shadowing.

	* instDialog.cpp (instDialog::show): fixed #1419: clear progress
	log display when instDialog is opened

2010-04-23  vadim  <vadim@vk.crocodile.org>

	* MangleTableCompiler_ipt.cpp (keepMangleTableRules::processNext):
	fixed #1415 "action branch that creates branch in mangle table
	should branch in FORWARD chain". Rule with "any" in src and dst
	and action Branch with option "branch in mangle table" will go
	into FORWARD chain in addition to the PREROUTING and POSTROUTING
	chains as before. Note that choice of PREROUTING or POSTROUTING
	chains depends on direction.

2010-04-23  Vadim Kurland  <vadim@vk.crocodile.org>

	* instDialog.cpp (instDialog::show): fixed #1418 "install
	checkboxes disappear from the compile/install dialog". This was a
	regression introduced when we fixed #547 ("User can open multiple
	compile/install dialogs")

	* instDialog_ui_ops.cpp (instDialog::checkIfNeedToCompile): see #1418
	Simplified algorithm that decides whether compile and install checkboxes
	should be turned on in the install/compile dialog. Now always using
	Firewall::needsCompile() and Firewall::needsInstall(), which check
	"last_modified", "last_compiled" and "last_installed" timestamps.
	Before this change, the dialog also tried to take into account how
	the dialog was started, using main toolbar or menu or context menu
	or local toolbar. This was confusing and hard to test.

	* PolicyCompiler_PrintRule.cpp (PrintRule::_printTarget): fixes #1416
	leading blank space in front of the custom action is missing.
	SF bug 2991397.

2010-04-22  vadim  <vadim@vk.crocodile.org>

	* NATCompiler_pf.cpp (VerifyRules::processNext): see #1401. Because
	of the change in the nat and rdr rules syntax in 4.7, I can no
	longer implement no-nat rules correctly for this version. They
	dropped the "no" keyword and their examples suggest using "pass"
	to implement exclusions for the nat rules. I need no-nat rule to
	just not translate but not make a decision whether the packet
	should be passed or dropped. In the new PF model, translation
	rules are just options on the matching policy rules and they do
	not offer any keyword or option to not translate.

	* NATCompiler_pf_writers.cpp (PrintRule::processNext): fixes #1401
	nat rules syntax has changed in OpenBSD 4.7. Nat and rdr rules in
	4.7 should be implemented using action "match" and keywords
	"nat-to" and "rdr-to"

	* PolicyCompiler_pf_writers.cpp (PrintRule::_printAction):
	fixes #1414: use "match" action for tagging. Policy rules
	with action Tag should use pf action "match" instead of "pass"
	if version is 4.6 or later.

2010-04-20  vadim  <vadim@vk.crocodile.org>

	* PolicyCompiler_ipt.cpp (PolicyCompiler_ipt::insertFailoverRule):
	fixes #1411 "automatic rules for the HA protocol should match
	source IP". Rules added for heartbeat in unicast mode already
	matched source IP, this change makes rules added for VRRP, OpenAIS
	and heartbeat in muticast mode also match source address.

	* configlets/ipf/script_skeleton: fixed #1409, SF bug 2985886.
	Depending on the combination of the activated options, shell
	functions in the generated launcher script could have no body,
	which is a syntax error in bash.

2010-04-09  vadim  <vadim@vk.crocodile.org>

	* RoutingCompiler_ipt.cpp (RoutingCompiler_ipt::epilog): fixed #1404
	call to function restore_script_output in the generated iptables
	script is sometimes added without function definition

	* NATCompiler_pf.cpp (ReplaceFirewallObjectsODst::processNext):
	fixes #1397   PF compiler fix: destination nat rule with fw object
	in ODst should skip "on intf"

	* NATCompiler_ipt.cpp (AssignInterface::processNext): fixes #1403
	refs #1150  "Using ip address of wrong interface" is broken in v4.0.
	This effectively rolls back change r2437. With no "Interface" column
	in the NAT rules, it is difficult to build rules with arbitrary
	"-o" clause using address for SNAT that does not match interface
	of the firewall, or especially rules with address for SNAT that does
	match some inetrface but with another interface in "-o". Keeping old
	documented behavior where object in TSrc dictated this. If the object
	was a child of the firewall (an interface or address), then the rule
	was attached to the interface using "-o". If the object is not a child
	of the firewall, then the rule is attached to all interfaces using
	"-o eth+" but skips unnumbered interfaces. Column "interface" should
	be added to the NAT rules in the future to avoid these complications.

	* ProjectPanel_state_ops.cpp (ProjectPanel::saveState): fixed #1402
	GUI crashes on exit when no rules are opened in the ruleset panel view

	* ObjectTreeViewItem.cpp (ObjectTreeViewItem::data): fixed #1398
	bold font and "*" in the tree indicate firewalls that require
	installation but should indicate those that require recompile

2010-04-08  Vadim Kurland  <vadim@vk.crocodile.org>

	* interfacePropertiesObjectFactory.cpp: fixed #1396, SF bug 2984193
	Vlan error when OpenWrt is selected as host

2010-04-08  vadim  <vadim@vk.crocodile.org>

	* CompilerDriver.cpp (CompilerDriver::copyFailoverInterface):
	see #1394  there is no need to add a copy of member interface objects
	to the cluster anymore.

	* PolicyCompiler_ipt.cpp (PolicyCompiler_ipt::_expand_interface):
	fixes #1394 Using existing virtual functions that expand multiple
	addresses to expand cluster interfaces. Added parameter bool
	expand_cluster_interfaces_fully to _expand_addr,
	_expand_addr_recursive and _expand_interface. Now expanding
	cluster interface in the Compiler::_expand_interface instead of
	PolicyCompiler_ipt::_expand_interface. Now it is possible to
	use interface of another cluster in rules (interface of a cluster
	object different from the one being compiled).

	* ProjectPanel_file_ops.cpp (ProjectPanel::exportLibraryTest):
	fixed #1395 "routing rules are not reported properly while
	exporting library"

	* configlets/linux24/update_addresses: fixed #1391 "function
	getaddr_internal does not work with point-to-point interfaces".
	In fact, fwbuilder v3 and v4 can not manage ip addresses of
	point-to-point interfaces. This fix makes generated script skip
	such interfaces and do not try to add, remove or change their ip
	addresses. Proper support for address management of point-to-point
	interfaces will be added in the future versions of the program.

2010-04-07  vadim  <vadim@vk.crocodile.org>

	* IPTImporter.cpp (IPTImporter::pushPolicyRule): see #1390 'update
	iptables importer to recognize rules with "-i intf -o intf"'

2010-04-01  vadim  <vadim@vk.crocodile.org>

	* src/res/os/dd-wrt-nvram.xml: Added direct support for DD-WRT
	in two modes: nvram and jffs

2010-04-01  Vadim Kurland  <vadim@vk.crocodile.org>

	* AddressRangeDialogTest.cpp (AddressRangeDialogTest::initTestCase):
	fixed #1366 - fixed unit test for AddressRangeDialog class

2010-03-29  vadim  <vadim@vk.crocodile.org>

	* RoutingCompiler_iosacl_writers.cpp (PrintRule::_printRItf):
	fixed #1379 "Should be able to build routing rules with interface
	as gateway for IOS". Routing rules for IOS now have column
	"Interface". Rules can be built either with explicit address of
	the gateway or interface.

	* PolicyCompiler_pf.cpp (PolicyCompiler_pf::compile): fixed #1375
	Interface group is not expanded in "Interface" rule element by
	compiler for PF

	* FWObjectPropertiesFactory.cpp (FWObjectPropertiesFactory::getObjectProperties):
	fixed #1371 "interface properties look ugly when interface is a
	member of a group".

2010-03-28  Vadim Kurland  <vadim@vk.crocodile.org>

	* generatedScriptTestsLinux.cpp (GeneratedScriptTest::CheckUtilitiesTest):
	See #1370.  This is a place for the future compiler unit tests. In
	the future we are going to migrate tests from test/ipt/ to this
	directory, using cppunit framework and functions added to the
	class Configlet per #1369

	* Configlet.h (class Configlet): fixes #1369 "Framework for unit
	testing of code generation via configlets"

2010-03-28  vadim  <vadim@vk.crocodile.org>

	* configlets/openbsd/installer_commands_reg_user: see #1368 A fix
	for the problem that causes built-in installer to hang after
	updating configuration of PF firewalls.

2010-03-27  vadim  <vadim@vk.crocodile.org>

	* fixed #1360 "negation of cluster interfaces is broken". Rule
	with one or several cluster interfaces in the "Interface" rule
	element with negation should compile into a rule using all other
	interfaces of the member firewall, or using single object negation
	"!" if appropriate. This is also fixed in compiler for PF.
	Files:
	src/iptlib/PolicyCompiler_ipt.cpp
	src/pflib/PolicyCompiler_pf.cpp
	See also changes r591 , r592 in libfwbuilder

	* platforms.cpp (isDefaultPolicyRuleOptions): fixed #1365 "missing
	some flags for the "non-default" rule options for PF"

	* FWObjectPropertiesFactory.cpp (FWObjectPropertiesFactory::getPolicyRuleOptions):
	fixed #1364 "add synproxy and other missing pf rule options to the
	rule options tooltip"

2010-03-26  vadim  <vadim@vk.crocodile.org>

	* RuleSetModel.cpp (RuleSetModel::getDecoration): fixed #1363
	"GUI crash in newClusterDialog". GUI crashed after a new cluster
	object has been created from two PF firewalls.

	* configlets/linux24/check_utilities: fixed #1359 "generated
	script hangs testing for iptables-restore"

2010-03-25  vadim  <vadim@vk.crocodile.org>

	* FWObjectPropertiesFactory.cpp (FWObjectPropertiesFactory::getObjectPropertiesBrief):
	fixed #1356 "Show number of rules in the rule set object in the
	second column of the tree"

	* PolicyCompiler_pf_writers.cpp (PrintRule::processNext): fixed #1351
	"synproxy rule option is broken"

2010-03-24  Roman Bovsunivskiy <a2k0001@gmail.com>

	* unit tests for IPv4Dialog, IPv6dialog, NetworkDialog, NetworkIPv6dialog
	fixed #1329, #1327

2010-03-23  Vadim Kurland  <vadim@vk.crocodile.org>

	* using CppUnit::TestFixture in unit tests based on cppunit:
	ImporterTest.h
	UsageResolverTest.h
	RCSTest.h
	FWBTreeTest.h
	interfacePropertiesTest.h

	* configlets/linux24/check_utilities: fixes #1348 "check_tools
	should check IPTABLES and IPTABLES_RESTORE as well"

2010-03-20  vadim  <vadim@vk.crocodile.org>

	* FWWindow.cpp (FWWindow::updateGlobalToolbar): additional check
	for condition that happens in unit test

2010-03-19  vadim  <vadim@vk.crocodile.org>

	* FWWindow.cpp (FWWindow::updateGlobalToolbar): fixed SF bug 2973137
	"'warning text goes here'". Main toolbar buttons "Compile" and "Install",
	as well as menu items Rules/Compile and Rules/Install should be
	disabled if currently opened data file has no firewalls to compile.

	* CompilerDriverFactory.cpp (CompilerDriverFactory::createCompilerDriver):
	fixed SF bug 2973221 "single rule compile (x) results in sigsegv".

	* SSHCisco.cpp (SSHCisco::stateMachine): fixed SF bug 2973136,
	fwbuilder bug #1347: ssh 'cancel' rule install sigsegv. Installer
	caused GUI crash if user hit "Cancel" at just the right
	moment. Apparently this also depends on the firewall platform
	(was discovered and reported for Cisco FWSM) and perhaps on how
	fast it responds to the installer commands.

	* platform/fwsm.xml: fixed SourceForge bug 2973121: Added support
	for FWSM v4.x

	* pixAdvancedDialog.cpp: fixed SourceForge bug 2973079 "pix typo"
	(typo in a tooltip)

2010-03-18  vadim  <vadim@vk.crocodile.org>

	* fixed SourceForge bug #2972699 "fwsm/pix syslog name". The dialog
	only accepts ip address for the syslog server.

	* configlets/ipfw/script_skeleton: fixed #1335 "Empty functions in
	ipfw script". Under some circumstances shell functions in the
	generated ipfw script could have no body; /bin/sh does not like
	that.

	* newFirewallDialog::createFirewallFromTemplate: fixes #1340
	firewall object created from template does not inherit fw and host
	os settings. See the ticket and comment in the code for caveats.

	* templates.xml.in: set "stateless rule " option in template rules
	where it makes sense; turned ip forwarding and "assume fw is part
	of any" in the "web server" template object.

2010-03-16    <vadim@vk.crocodile.org>

	* RCS.cpp, FWWindow.cpp: Fixed #1334  Program failed to open data
	file on Windows if it was stored on mounted network volume.
	"File/Open" operation terminated with no error but did not load
	the file. "File/Open Recent" ended with an error message that
	quoted file path as somehting like this:
	"Volume{3c50bdba-21b0-4ea5-b52f-aa5d9755f918}/test1.fwb"
	which was obviously incorrect and the file could not be loaded.

2010-03-15  vadim  <vadim@vk.crocodile.org>

	* PolicyCompiler_PrintRule.cpp (PrintRule::_printOptionalGlobalRules):
	fixes #1333 "Add variable management_interface for the
	automatic_rules configlet". Variable "management_address"
	renamed "ssh_management_address" to avoid ambiguity.

	* ObjectManipulator.cpp (ObjectManipulator::editSelectedObject):
	change in the behavior of double click in the tree.  Open rule set
	object in the editor if it is already opened in RuleSetView. If we
	just opened it in RuleSetView, check if the editor is visible and
	if yes, open the object in the editor right away. Fixes #1331

2010-03-13  vadim  <vadim@vk.crocodile.org>

	* using file name for the floating tree panel title. See #1317

	* fixes #1326 MDI subwindow title is left "Untitled" when GUI
	starts with a file on the command line

2010-03-13  Roman Bovsunivskiy <a2k0001@gmail.com>

	* Object tree panel should have title when detached. Fixes #1317

2010-03-08  yalovoy <yalovoy@gmail.com>
	* RuleSetView.cpp: fixes #1315 menu item "Remove from group" is
	available for rules inside the group.
	"Create new group" action is fixed too.
	* fixes #1202: Main menu "Rules" does not match rule context menu
	Items in the main menu Rules should get disabled and enabled just
	like items in the context menu do.
	Affected files: RuleSetView.cpp, RuleSetView.h
	* src/gui/FWWindow.cpp: fixes #1322 main menu items "Rules" are broken

2010-03-07  vadim  <vadim@vk.crocodile.org>

	* FWWindow.cpp (FWWindow::startupLoad): final (hopefully) design
	of the welcome/startup window. Always showing startup tip dialog;
	added buttons to show "Getting started" and "summary of features"
	to the same dialog window. Fixes #1224

	* renamed menu item Help/Welcome to Help/Summary of features.
	fixes #1311

2010-03-07  yalovoy <yalovoy@gmail.com>
	* refs #1202: Main menu "Rules" does not match rule context menu
	Items in the main menu Rules should get disabled and enabled just
	like items in the context menu do.
	Added action: copyRuleAction; cutRuleAction; pasteRuleAboveAction;
     	pasteRuleBelowAction; disableRuleAction; enableRuleAction;
	setColorEmptyAction; setColorRedAction; setColorBlueAction;
	setColorOrangeAction; setColorPurpleAction; setColorGrayAction;
	setColorYellowAction; setColorGreenAction;
	Affected files:
	FWWindow.cpp
	FWBMainWindow_q.ui
	RuleSetView.cpp
	RuleSetView.h

2010-03-07  Roman Bovsunivskiy <a2k0001@gmail.com>

	* ticket #1307 "cluster names in cyrillic appear garbled in
	instDialog list"

	* ticket #1289 "turn off mouse wheel scrolling of tabs in the main
	window MDI area"

	* Ticket #1310 "New slots in startup dialog". Buttons in the startup
	tip dialog connected to slots that open "Getting started" tutorial
	and "Summary of features"

2010-03-06  vadim  <vadim@vk.crocodile.org>

	* FWWindow.cpp (FWWindow::checkForUpgrade): code that checks if
	upgrade is available shows warning dialog no more than once a day.
	Also framework for unit testing of this function. See #1309

2010-03-05  vadim  <vadim@vk.crocodile.org>

	* instDialog_ui_ops.cpp (instDialog::fillCompileSelectList):
	fixed #1305 "Compilation of cluster firewall". when user tries to
	compile a firewall object that is also a cluster member, but did
	not request compilation of the cluster, a warning should be
	presented.

	* fixed #1303 "Improve design of the global Preferences, tab
	Objects"

2010-03-04  vadim  <vadim@vk.crocodile.org>

	* pfAdvancedDialog.cpp (pfAdvancedDialog::doScrubToggled):
	fixed #1297 "change in scrub rules in PF 4.6". PF 4.6 stopped
	support for several reassemble options except for "reassemble tcp"
	and changed format for the "scrub" rules.

	* PolicyCompiler_cisco_acls.cpp (setInterfaceAndDirectionBySrc::processNext):
	recognize multicast when matching Network and NetworkIPv6
	objects. Fixes #1298

	* ObjectManipulator.cpp (ObjectManipulator::getDeleteMenuState):
	fixed #1301 "can not delete Policy object when it is in Deleted
	Objects lib". SF bug 2962628

2010-03-03  glitch.vk.crocodile.org  <vadim@vk.crocodile.org>

	* CompilerDriver_pix_run.cpp (CompilerDriver_pix::run): 
	fixed #1296 "crash in fwb_pix". Compiler used to create copy of
	each network zone object, expanded it recursively and added
	network and address objects to the newly created group
	directly (rather than via references). This created objects that
	were referenced by two parents in the tree which caused crash in
	FWObject::destroyChildren() because an attempt to free the same
	block of memory twice.

2010-03-03  vadim  <vadim@vk.crocodile.org>

	* compiler_lib/CompilerDriver.cpp (CompilerDriver::commonChecks2):
	fixed #1292  Added check for interfaces with valid address and
	netmask 0.0.0.0

2010-03-03  glitch.vk.crocodile.org  <vadim@vk.crocodile.org>

	* iptables.g (port_def_with_incomplete_range): fixed #1294
	'importer for iptables does not parse "--dport NNNN:"'. Policy
	importer for iptables should recognize the following variant of
	the --dport and --sport port ranges: "port1", "port1:port2",
	":port1" and "port2:"

2010-03-03  vadim  <vadim@vk.crocodile.org>

	* IPTImporter.cpp (IPTImporter::finalize): fixed #1288 "all rules
	created by policy import have rule number 0"

	* FWWindowPrint.cpp (FWWindow::filePrint): fixed #1295 "File/Print
	does not work for clusters"

	* Importer.cpp (Importer::createAddress): fixed #1287 "policy
	importer (iptables) crashes when host name is used in iptables
	rule in place of an address". Importer now creates DNSName object.

	* fixed #1291 "deleted objects 'policy' problem". SF bug 2962628
	If user ended up placing a 'policy' object in the 'Deleted
	Objects' library, it could not be deleted or opened.
        RuleSetView.cpp
        RuleSetModel.cpp
        ActionsDialog.cpp
        RuleSetDialog.cpp
        platforms.cpp

	* Helper.cpp: fixes #1293 When compiler searches for an interface
	that should match given address, it should skip unprotected
	interfaces.

2010-03-02  glitch.vk.crocodile.org  <vadim@vk.crocodile.org>

	* RCS.cpp (RCS::init): checking if RCS tools are installed on the
	system once in the beginning. This helps avoid unnecessary
	QProcess starts that make working with valgrind more difficult
	because of subprocess starts/stops.

2010-03-01  vadim  <vadim@vk.crocodile.org>

	* PolicyCompiler_PrintRule.cpp (PrintRule::_printTimeInterval):
	fixed time format for the iptables parameters --datestart,
	--datestop which is supposed to be ISO 8601 "T" notation but
	apparently with no support for time zone designators.  Timezone
	desginators are an error in iptables 1.4.1.1 and 1.4.5, did not
	test newer versions.  Fixes #1286 SourceForge bug #2961532

2010-02-28  vadim  <vadim@vk.crocodile.org>

	* (many files) fixed warning " format not a string literal and no
	format arguments". Fixes #1285

2010-02-28  yalovoy <yalovoy@gmail.com>
	* refs #1202: Main menu "Rules" does not match rule context menu
	Items in the main menu Rules should get disabled and enabled just
	like items in the context menu do.
	Added action: insertRuleAction, addRuleAfterCurrentAction,
	addToGroupAboveAction, addToGroupBelowAction
	Affected files:
	FWWindow.cpp
	RuleSetView.cpp
	RuleSetView.h

2010-02-27  vadim  <vadim@vk.crocodile.org>

	* ../src/gui/Tutorial/getting_started/html/page0.html: "Getting
	Started" turorial is complete, it can be activated using main menu
	item "Help/Tutorials/Getting Started".

2010-02-27  glitch.vk.crocodile.org  <vadim@vk.crocodile.org>

	* unit_tests.sh (commands): Using Xvfb for GUI unit tests so they
	can run as an automated task. This was broken by r2602

2010-02-26  vadim  <vadim@vk.crocodile.org>

	* ../src/gui/TutorialDialog.cpp (TutorialDialog::showPage):
	TutorialDialog supports multiple tutorials. Each tutorial
	is presented in HTML with accompanying CSS stylesheet. fixes #1274

	* ../src/res/configlets/bsd/update_vlans: fixes #1275 "script
	always deletes, then adds vlans back on OpenBSD"

2010-02-25  Roman Bovsunivskiy     a2k0001@gmail.com

	* TutorialDialog.cpp (TutorialDialog::TutorialDialog): in-program
	tutorial "Getting Started". Activated using menu Help/Tutorial.
	Refs #1217

2010-02-19  vadim  <vadim@vk.crocodile.org>

	* ProjectPanel_state_ops.cpp (ProjectPanel::loadState): refs #1236
	Crash on Mac. The GUI could be crashed by repetetivie scrolling of
	the tree and other parts of the main window with mouse scroll
	wheel on Mac

	* FindObjectWidget.cpp (FindObjectWidget::_findAll): fixed #1256
	search in the policy of firewalls does not work. This problem was
	introduced whith a fix for #1250

2010-02-15  yalovoy <yalovoy@gmail.com>
	* ProjectPanel.cpp: fixes #1244 GUI crash on exit
	Looks like it is sufficient to just open some data file, open rule set
	(I tried with Policy) and insert a rule in the middle. Then exist the
	program and it crashes.

2010-02-18  glitch.vk.crocodile.org  <vadim@vk.crocodile.org>

	* PolicyCompiler_iosacl.cpp (splitTCPServiceWithFlags::processNext):
	fixed #1247 incorrect use of tcp service with flags in
	object-group.  "object-group service" does not seem to support tcp
	flags and "established"

	* ObjectTreeViewItem.cpp (ObjectTreeViewItem::data):
	fixed #1248 Filtering in the object-tree crashes the GUI,
	SourceForge bug #2954501

	* ObjectManipulator_tree_ops.cpp (ObjectManipulator::updateObjectInTree):
	fixed #1249 GUI freezes when filters are applied. The GUI would
	freeze for a few seconds every time user modified anything in rules
	if a filter was applied to the tree at the same time.
	SourceForge bug #2954501

	* ObjectManipulator.cpp (ObjectManipulator::contextMenuRequested):
	fixed #1255 context menu items "Lock" and "Unlock" are not updated
	after object is locked.

	* ProjectPanel_events.cpp (ProjectPanel::event): fixed #1253
	Locking an object in the tree causes GUI crash.

2010-02-18  vadim  <vadim@vk.crocodile.org>

	* FWWindow.cpp (FWWindow::FWWindow): fixed #1252 The "New
	Object"-Dialog is always opened up twice when pressing <CTRL>+<N>

	* FindObjectWidget.cpp (FindObjectWidget::_findAll): fixed #1250
	The Find-Dialog searches 'Deleted Objects'-library although it's
	not enabled in the preferences. Sourceforge bug #2954501

	* IPv4Dialog.cpp (IPv4Dialog::DNSlookup): fixed #1251 DNS-Lookups
	in Address-Objects don't work. Sourceforge bug #2954501

2010-02-17  vadim  <vadim@vk.crocodile.org>

	* PolicyCompiler_iosacl.cpp (mirrorRule::processNext): fixes #1241
	"add mirror rule" checkbox for IOSACL. New feature: policy rule
	option "Add mirrored rule" (checkbox in the rule options dialog)
	makes policy compiler for IOS ACL automatically create a rule with
	mirrored source and destination addresses and service fields. This
	can be used to match "reply" packets using address and service
	parameters matched by this rule.  The action of the mirrored rule
	is the same as that of this one. Firewall Builder recognizes the
	following services and creates "mirrored" versions as follows:
	    - UDP service: mirrored service has source and destination port
	    ranges reversed
	    - TCP service: mirrored service has source and destination
	    port ranges reversed and "established" flag inverted.
	    If TCP service used in this rule does not have "established"
	    flag, the mirrored service gets it, and the other way around.
	    This is designed to simplify creating ACL rules to permit
	    "reply" TCP packets
	    - ICMP service: ICMP echo request is recognized, mirrored service
	    becomes ICMP echo reply. Other ICMP types are simply copied to the
	    mirrored service
	    - ICMPv6 service: like with ICMP, ICMP echo request is recognized
	    and other ICMPv6 types are just copied
	    - IP service: mirrored service is a copy

	* ssh_wrappers.cpp (ssh_wrapper): fixed #1246 policy installer
	fails on Linux. Policy installer failed with error "bash: -c: line
	6: syntax error: unexpected end of file" while trying to activate
	iptables script on Linux. This error was introduced in one of the
	recent builds.

2010-02-16  vadim  <vadim@vk.crocodile.org>

	* fixed #1243 "new cluster" operation creates failover groups that
	recursively refer to the interfaces of the same cluster. This
	happened when new cluster was created with a copy of rules from
	one of the firewalls.
	newClusterDialog_create.cpp

	* fixed #1235 "cluster with dynamic interface can not be used in
	rules". Fixes this and several other problems with policy and nat
	rules that use cluster inetrfaces with dynamic addresses.
	PolicyCompiler_ipt.cpp
	NATCompiler_ipt.cpp

	* fixed #1240 nat rule should get "on interface" when cluster
	interface is used in TSrc.
	NATCompiler_pf.cpp

	* Configlet.cpp (Configlet::expand): added basic protection
	against infinite loops in configlet expansion.

2010-02-15  vadim  <vadim@vk.crocodile.org>

	* Added template for the OpenWRT firewall. Fixes #1237

2010-02-15  glitch.vk.crocodile.org  <vadim@vk.crocodile.org>

	* working on memory leaks with the help of valgrind. Refs #1229
	Help.cpp
	Help.h
	RCS.cpp
	StartTipDialog.cpp
	StartTipDialog.h
	ssh_wrappers.cpp

2010-02-15  yalovoy <yalovoy@gmail.com>

	* refs #1202: Main menu "Rules" does not match rule context menu
	Items in the main menu Rules should get disabled and enabled just
	like items in the context menu do.
	Affected files:
	FWWindow.cpp
	RuleSetView.cpp
	RuleSetView.h


2010-02-14  glitch.vk.crocodile.org  <vadim@vk.crocodile.org>

	* ProjectPanel.cpp (ProjectPanel): refs #1229 memory leak problems.

2010-02-14  yalovoy <yalovoy@gmail.com>
	* fixes #1228: removing consecutive rules from a group in a ruleset
	its currently only possible to remove either the single top rule
	or single last rule from a group
	it would be useful to be able to select say the first several rules
	or last several rules and remove them all at once or if you select
	all rules in the group it would then just remove the group.
	Affected files:
	FWWindow.cpp
	FWWindow.h: #1228
	RuleSetView.cpp: #1228
	RuleSetView.h: #1228

2010-02-14  vadim  <vadim@vk.crocodile.org>

	* PolicyCompiler_ipt.cpp (PolicyCompiler_ipt::_expand_interface):
	fixes #1234 When failover group object is used in the rule, rule
	gets placed in FORWARD chain. Working implementation follows these
	rules: 1) if cluster interface obejct is used in the rule, it is
	expanded to the set of addresses including cluster virtual IP
	address and all addresses of the corresponding member firewall
	interface; 2) Failover Group is treated as any regular object
	group. Expanding Failover group to the address of its
	parent (cluster interface) would work but seems counter-intuitive

	* PolicyCompiler_ipt.cpp (decideOnChainIfDstFW::processNext):
	fixes #1231 rules are placed FORWARD chain if firewall object is
	"bridging firewall". This bugfix concerns specific rule
	configuration used with bridging firewall where firewall object or
	one of its interfaces is used in "destination" and an interface
	which is not a bridge port is in the "interface" rule column. Rule
	like this should go into INPUT chain but compiler used to splut it
	and put generated iptables rules in both INPUT and FORWARD chains.
	Rule should be placed in the FORWARD chain only if interface in
	"interface" column is bridge port. The same algorithm also applies
	to rules with firewall or one if its interfaces in the "Source"
	column.

2010-02-13  vadim  <vadim@vk.crocodile.org>

	* OSConfigurator_bsd.cpp (OSConfigurator_bsd::configureInterfaces):
	New feature: incremental management of pfsync0 interface on
	OpenBSD. The script checks if interface exists and if not, it runs
	"ifconfig pfsync0 create" command to create it. If interface
	exists, the script only runs ifconfig to configure its parameters
	but does not try to create it again. If State Synchronization
	group object is deleted in fwbuilder GUI, interface pfsync0 will
	be deleted on the firewall by the script.

	* OSConfigurator_bsd.cpp (OSConfigurator_bsd::configureInterfaces):
	generated script compares vlan and carp interfaces of the firewall
	with objects created in fwbuilder GUI and deletes any such
	interfaces it finds if they are not defined in fwbuilder. This is
	done even when there are no vlan or carp interfaces in fwbuilder
	configuration. This code is added only when checkboxes "Configure
	VLAN interfaces" and "Configure CARP interfaces" are checked.

	* OSConfigurator_bsd.cpp (OSConfigurator_bsd::configureInterfaces):
	New feature: generated script adds and removes CARP interfaces
	incrementally. This means it is not going to run ifconfig command
	to create carp interface if it is already there and will run
	"ifconfig carp1 destroy" command if interface carp1 has been
	removed in fwbuilder GUI to delete it on the firewall.

	* OSConfigurator_bsd.cpp (OSConfigurator_bsd::configureInterfaces):
	New feature: incremental VLAN interface management for OpenBSD and
	FreeBSD. When user adds or removes VLAN subinterface in fwbuilder
	GUI, geenrated script executes appropriate ifconfig commands to
	add or remove corresponding vlan pseudo-interface on the firewall
	machine.

2010-02-12  vadim  <vadim@vk.crocodile.org>

	* OSConfigurator_bsd.cpp (OSConfigurator_bsd::updateAddressesOfInterfaceCall):
	New feature: incremental IP address management for OpenBSD and
	FreeBSD. Generated script adds and removes ipv4 and ipv6 addresses
	of interfaces as needed. When user adds an address in the
	fwbuilder object, the script adds it. Second run of the same script
	does nothing. If user removes an address in fwbuilder, generated
	script removes it from the interfaces to bring actual configuration
	of the machine in sync with fwbuilder objects.

2010-02-10  yalovoy <yalovoy@gmail.com>
	* src/gui/RuleSetModel.cpp: fixes #1223: GUI crash while adding a host to a group
	 To reproduce:
	 - open test-fw1 / Policy by double clicking Policy object
	 - expand Objects/Groups and Objects/Hosts tree branches
	 - open group LDA-Servers by double clicking it
	 - drag host ldap-server1 to the group dialog

2010-02-10  vadim  <vadim@vk.crocodile.org>

	* UsageResolver.cpp (list): fixes #1222 modification of host or fw
	settings of a member firewall does not trigger cluster recompile

	* InterfaceDialog.cpp (InterfaceDialog::validate): fixes #1221
	warning dialogs for the incorrect interface name would not go
	away.  If user entered incorrect name of the
	subinterace (e.g. name that is not a valid VLAN subinterface name)
	the GUI would pop up warning dialog infinitely.

	* ../src/gui/ProjectPanel_events.cpp (ProjectPanel::event): this
	change attempts to fix a bug that causes main menu item Edit /
	Paste (keyboard shortcut Ctrl-V) to stop working. The bug is hard
	to reproduce and we were not able to find reliable scenario to
	trigger it.

	* PolicyCompiler_ipt.cpp (specialCaseWithFWInDstAndOutbound::processNext):
	fixes #1220 "bridging fw rule using all multicast object in
	destination does not produce any iptables rules".

2010-02-07  vadim  <vadim@vk.crocodile.org>

	* src/gui/ClusterGroupDialog.cpp (ClusterGroupDialog::applyChanges):
	fixes #1215 "Edit protocol parameters" button gets disabled for no
	reason. This button would get disabled after certain manipulations
	in the cluster group object dialog even when no changes were made.

	* FWCmdChange.cpp (FWCmdChangeOptionsObject::notify): fixes #1212
	Cluster object was not marked for recompile when user edited
	conntrack group parameters

2010-02-06  vadim  <vadim@vk.crocodile.org>

	* src/pflib/PolicyCompiler_pf_writers.cpp (PrintRule::processNext):
	fixes #1210 "syntax error in PF rule - "modulate state" is
	required".  Per bug reported in the mailing list (and according to
	the pf.conf manual), pf.conf requires "keep state", "modulate
	state" or "synproxy"if any of the stateful tracking options are
	used in the rule. These include "max", "no-sync", "pflow",
	"sloppy", "source-track" and others.

	* src/pflib/PolicyCompiler_pf_writers.cpp (PrintRule::processNext):
	fixes #1209 "incorrect syntax in PF rules when only "Activate
	source tracking" option is on". Compiler sometimes generated empty
	"( )" in the end of the pf.conf line when there were no state
	tracking options

	* PolicyCompiler_ipt.cpp (PolicyCompiler_ipt::insertConntrackRule):
	fixes #1175 "There is no option for unicast on conntrac
	sync-group (like heartbeat)". User can now choose between multicast
	and unicast for conntrackd communication.

	* FWWindow.cpp (FWWindow::showWelcome): fixes #1213 Welcome screen.
	When user starts the program for the very first time, it shows
	a "Welcome" screen that lists summary of features of fwbuilder and
	provides a link to the Getting Started Guide on the web site. Link
	to the local copy of Release Notes is also provided.

	* InterfaceEditorWidget.cpp (InterfaceEditorWidget::isValid): "new
	cluster" visard should permit the user to create cluster
	interfaces without IP addresses for any failover protocol. Disable
	widgets used to add virtual ip addresses only for protocol "None".
	All other protocols permit adding addresses regardless of the OS
	resource file attribute "no_ip_ok".

	* linux24.xml, openwrt.xml: fixed #1172 It is ok for a cluster
	interface with failover protocol heartbeat to have no ip address.
	There are legitimate configurations where admin might want to run
	heartbeat over an inetrface which itself has no virtual ip
	address, for example to confine heartbeat packets to a dedicated
	link.

2010-02-02  vadim  <vadim@vk.crocodile.org>

	* FWObjectPropertiesFactory.cpp (FWObjectPropertiesFactory::getObjectPropertiesDetailed):
	fixes #1201 "add parent to the object properties tooltip".
	Include parent name in the tooltip that is shown for interface
	objects.  This helps identify interfaces in rules, especially
	subinterfaces and interfaces with common names in complex
	configurations with many firewall objects.

	* NATCompiler_ipt.cpp (ReplaceFirewallObjectsTSrc::processNext):
	fixes #1200 "SNAT with cluster object in TSrc uses all
	interfaces".  When a network or host address used in OSrc of a NAT
	rule matches one of the interfaces of the firewall or a cluster,
	there is not need to use this interface for the "-o" clause in
	SNAT rule.

2010-02-02  glitch.vk.crocodile.org  <vadim@vk.crocodile.org>

	* FWWindow.cpp (FWWindow::closeEvent): fixes #1207 'status
	"maximized" of internal subwindows is not saved correctly'

2010-02-01  vadim  <vadim@vk.crocodile.org>

	* FWWindow.cpp (FWWindow::fileExit): fixes #1197 "clicking Cancel
	in RCS log dialog cancels log but the program still exits".

	* CompilerDriver.cpp (CompilerDriver::populateClusterElements):
	see #1198. The check of subnets defined by the member and cluster
	interfaces has been removed. The check originally implemented by
	Secuwall developers looked only at the first address of the
	interface and ignored others. It also did not allow for the
	cluster interface netmask /32, which is the case with vrrpd. All
	in all, the value here does not seem to be worth the effort of
	implementing checks for all combinations.

	* ../src/res/configlets/linux24/update_addresses: fixes #1196
	"shell function update_addresses_of_interface() does not ignore
	virtual addresses of cluster inetrfaces". When generated iptables
	script updates ip addresses of interfaces, it should ignore
	addresses managed by vrrpd, heartbeat or other failover daemons.
	The script did not ignore them and instead removed them from
	interfaces.

	* objects_init.xml: fixes #1194 "Add standard address objects for
	various multicast groups". Added address objects for standard
	multicast groups OSPF, RIP, EIGRP, DHCP server / relay agent, PIM,
	RSVP-ENCAPSULATION, VRRP, IGMP, OSPFIGP-TE, HSRP, mDNS, Link-local
	Multicast Name Resolution, Teredo.

	* ObjectManipulator.cpp (ObjectManipulator::updateCreateObjectMenu):
	fixes #1195 the GUI should enable "new object" button and menu
	item when objects_init.xml library is opened

	* platforms.cpp (isDefaultPolicyRuleOptions): fixes #1193 default
	setting for "Assume fw is part of any" per-rule option is "follow
	global"

	* ../src/res/os/linux24.xml: fixes #1192 "iptables script should
	skip virtual addresses configured on cluster interfaces while
	updating addresses of interfaces". The problem only affected
	cluster interfaces with VRRP failover protocol.

	* InterfaceEditorWidget.cpp (InterfaceEditorWidget::deleteAddress):
	fixes #1191 "broken behavior in InterfaceEditorWidget". When user
	added and then deleted bunch of ip addresses to an interface in
	the new firewall or new cluster wizard, addresses below the
	deleted row were ignored.

	* InterfaceEditorWidget.cpp (InterfaceEditorWidget::deleteAddress):
	fixes #1189 "GUI crash in newFirewall dialog upon completion".
	GUI crashed in the new firewall wizard if user deleted an address
	of an interface that had 3 or more addresses.

2010-01-31  vadim  <vadim@vk.crocodile.org>

	* NATCompiler_ipt.cpp (ReplaceFirewallObjectsTSrc::processNext):
	fixes #1185 "do not include member ip addresses for cluster NAT
	policies". For NAT rules in a cluster, make it use only cluster ip
	and ignore member ips.

	* PolicyCompiler_cisco_acls.cpp (setInterfaceAndDirectionBySrc::processNext):
	fixes #1187: "regression in compiler for PIX". Rules that have
	cluster or firewall object in src or dst that expands to a bunch
	of addresses that match network zones of different interfaces
	should still be assigned to the interface dictated by the
	combination of both src and dst. There is no need to add them to
	the ACL of inetrface 1 in direction "outbound" if destination
	belongs to the network zone of inetrface 2. Rule like that should
	only be assigned to interface 2, direction outbound. However
	this does not apply to anti-spoofing rules.

	* NATCompiler_ipt.cpp (AssignInterface::processNext): fixes #1184
	"compiler/GUI crash compiling cluster NAT rule when cluster and
	members have dynamic interface". It should be possible to have
	cluster interface that is mapped to dynamic interfaces of the
	member firewalls and then use this interface or whole cluster
	object in rules. Compiler should expand cluster object and replace
	it with its interfaces and corresponding interfaces of the member
	firewall and then correctly handle dynamic ones.

2010-01-31  yalovoy <yalovoy@gmail.com>

	* RuleSetModel.cpp: fixes #1182 rule number column is invisible
	when very first rule is created in a rule set

	* fixes #1164 focus moves in RuleSetView after paste If i am in a
	rule and place the selection to service field of say rule 1 and
	ctrl c and then arrow down the selection to service element in
	rule 2 and ctrl v the focus then moves back to the rule number
	element of rule 2 after the paste instead of staying on the
	service element. likewise if i am on an element and do ctrl x it
	brings the focus back to the rule number element.

	my first expectation was that the focus would remain on the
	service element of the rule and not brought back to the rule
	number element. i guess this has something to do with refresh of
	the gui and you are not keeping track of which element the
	selection was on for the last operation.

	Affected files:
	FWCmdRule.cpp
	FWCmdRule.h
	RuleSetView.cpp
	RuleSetView.h

2010-01-30  vadim  <vadim@vk.crocodile.org>

	* change in libfwbuilder. fixes #1173 "rule ID labels do not match
	rule numbers when disabled rules exist in rule set". Do not remove
	disabled rules in PolicyCompiler::prolog() because some compilers
	might use RuleSet::insertRuleAtTop() and other similar methods
	from prolog() or addPredefinedPolicyRules() and these methods
	renumber rules. As the result, labels stop matching rule positions
	when this is done because labels are configured in prolog() method
	of the base class. See fwbuilder ticket 1173. Instead of dropping
	disabled rules in prolog(), will keep them and drop them in rule
	processor Begin which is always the first in all compilers.

	* PolicyCompiler_ipt.cpp (checkInterfaceAgainstAddressFamily::processNext):
	fixes #1172 "fwb_ipt does not generate rule for cluster interface
	with no ip address".

	* OSConfigurator_linux24.cpp (OSConfigurator_linux24::processFirewallOptions):
	fixes #1177 "problems with commands for conntrack_max, hashsize
	and other advanced conntrack parameters". Needed to add a line
	break between shell commands that set up kernel variables and
	those that set up conntrack kernel variables.

	* FWWindow.cpp (FWWindow::showSub): fixes #1181 "save state of
	subwindow on maximize/restore". The GUI would revert to the
	non-maximized subwindows display if user de-maximized subwindow,
	then maximized it again and tried to open new data file.

	* ProjectPanel_file_ops.cpp (ProjectPanel::fileNew): fixes #1178
	window title stays "[Untitled]" after File/new

2010-01-30  yalovoy <yalovoy@gmail.com>

	* fixes #1159 GUI crash on redo() :
	FWCmdChange.cpp
	FWCmdChange.h

	* fixes #1121 changing "rules font" in global preferences has no effect
	PrefsDialog.cpp
	RuleSetModel.cpp
	RuleSetViewDelegate.cpp

2010-01-30  vadim  <vadim@vk.crocodile.org>

	* ../src/res/os/linux24.xml: fixes #1180 "heartbeat failover
	protocol uses virtual ip address". New cluster wizard did not
	allow the user to add ip address to cluster interface configured
	with heartbeat failover protocol.

	* ../src/gui/instDialog_ui_ops.cpp (instDialog::setFlags): fixes #1176
	GUI crash while compiling cluster object with no StateSyncGroup.

	* PolicyCompiler_ipt.cpp (PolicyCompiler_ipt::insertFailoverRule):
	fixes #1174 "OUTPUT rule is not generated for
	heartbeat". Automatically generated rules for cluster members using
	heartbeat should be placed in both INPUT and OUTPUT chains.

	* ../src/gui/FirewallDialog.cpp (FirewallDialog::applyChanges):
	fixes #1171: the warning dialog asking if ip address objects
	should be renamed automatically appears twice. when user renames
	cluster, firewall, host or interface object, the GUI asks if they
	want to rename ip address objects as well to make them adhere to
	some naming convention. The warning dialog appeared twice on Mac
	and Windows with Qt 4.6

2010-01-29  vadim  <vadim@vk.crocodile.org>

	* ../src/res/configlets/linux24/installer_commands_reg_user: try
	to cancel reboot only if one is pending. This avoids a warning
	saying "cant find pid of running shutdown" every time user
	installs updated iptables script on Linux firewall. Fixes #1169
	Fwbuilder can schedule reboot in a few minutes if user installs
	updated policy in "test mode" and requests reboot as a brute-force
	rollback to safeguard against locking themselves out of the
	firewall in case of error in the policy.

	* ../src/gui/ObjectManipulator_ops.cpp (ObjectManipulator::autorename):
	cluster failover group objects are now included in the algorithm
	that automatically renames addresses of interfaces when user
	renames firewall or cluster object. Fixes #1170

	* ../src/gui/ObjectManipulator_slots.cpp (ObjectManipulator::copyObj):
	show a not on the status bar whenever user copies an object to
	clipboard. fixes #1167

2010-01-28  vadim  <vadim@vk.crocodile.org>

	* ../src/gui/ProjectPanel.cpp (ProjectPanel::isManipulatorSelected):
	fixes #1130 "Ctrl-C , Ctrl-V shortcuts do not work for selected
	objects in rule elements". Global keyboard shortcuts Ctrl-C,
	Ctrl-V, Ctrl-X should work on objects in rule elements when
	keyboard focus belongs to the rule set view or on objects in the
	tree when focus is on the tree. This also fixes #1138 "ctrl+x and
	edit->cut problems in both Policy and NAT". These keyboard
	shortcuts operate only on objects in the tree and rule elements
	but not on rules.  Visual difference between the state when whole
	rule is selected and the state when an object is selected in one
	of the rule elements is insufficient so making Ctrl-X cut whole
	rule may appear unextected for the user.

2010-01-26  vadim  <vadim@vk.crocodile.org>

	* RuleSetView.cpp (RuleSetView::showContextMenu): fixes #1155
	context menu is not updated on rule enable/disable

	* NATCompiler_PrintRule.cpp (PrintRule::processNext): fixes #1147
	--persistent option for DNAT and SNAT. This adds support for the
	"--persistent" option in NAT rules. Version should be set to 1.4.3
	or later in the firewall object.

	* NATCompiler_PrintRule.cpp (PrintRule::processNext): fixes #1146
	support for NAT MASQUERADE source port randomization. This adds
	support for the "--random" option for SNAT, DNAT and MASQUERADE
	targets in iptables NAT rules. User needs to turn on the checkbox
	that adds this option in NAT rules again

2010-01-26  yalovoy <yalovoy@gmail.com>

	* RuleSetView.cpp: fixes #1145
	show keyboard shortcuts for "move rule up/down" in the rule context menu
	* RuleSetView.cpp: fixes #1158 
	ctrl page up/down breaks arrowing in the ruleset

2010-01-26  vadim  <vadim@vk.crocodile.org>

	* FWCmdChange.cpp (FWCmdChange::notify): fixes #1139
	GUI crash on click in undo panel view. Sequence that caused crash:
	1) new firewall next next finish
	2) rename firewall couple of times
	3) click to top of undo stack and it crashes

	* DiscoveryDruid.cpp (DiscoveryDruid::createRealObjects): fixes #1144
	after snmp discovery object attributes are not shown properly
	in the tree

2010-01-25  vadim  <vadim@vk.crocodile.org>

	* ProjectPanel_file_ops.cpp (ProjectPanel::chooseNewFileName):
	fixes #1157 Qt dialog does not detect conflict of filenames
	properly for linux. When user tried to create new file using
	File/New or save existing one using using File/SaveAs and entered
	a name without extension when prompted to enter the file name, the
	program would overwrite existing file with the same name and
	suffix ".fwb" without warning. This happened on Linux but did not
	happen on Mac OS X where dialog automatically added the suffix to
	the file name.

	* PolicyCompiler_pf.cpp (PolicyCompiler_pf::insertCarpRule):
	fixes #1152 CARP and pfsync rules should match "in" and "out".
	Automatically added rules for CARP and pfsync for the PF firewall
	should match in both directions, rather than just "out".

	* NATCompiler_ipt.cpp (AssignInterface::processNext): fixes #1150
	"fwb_ipt should check AddressRange in TSrc against addresses of
	interfaces". Compiler for iptables finds interface that matches
	AddressRange object used in Translated Source of a NAT rule and
	uses it for the "-o intf" clause. Addresses of interface can match
	the range excactly or partially. Exact match is when range
	boundaries match the beginning and the end of the subnet defined
	by the interface address and netmask. Partial match is when one of
	the range boundaries belongs to the subnet but another one does
	not. In this case compiler uses inetrface but issues a warning. If
	interface has multiple ip addresses, all of them are taken into
	consideration and interface is used if at least one matches. If
	address range in TSrc is wide and matches subnets of several
	interfaces, compiler splits the rule and uses all of them but does
	not replace the range with narrower one and still issues a
	warning.

	* ProjectPanel.cpp (ProjectPanel::getDestDir): fixes #1149:
	ProjectPanel::getDestDir should use userDataDir dir on all OS

2010-01-24  yalovoy <yalovoy@gmail.com>

	* #1127 GUI crash when clicking in undo panel
	1) new firewall (set name, Next, Next, Finish)
	2) add interface
	3) open Policy rule set view
	4) insert rule
	5) drag interface to the "Interface" rule element of the rule
	6) click on <empty> in the undo panel
	6) click on the last entry in the undo panel
	Affected files: RuleSetModel.cpp

	* #1132 Keyboard shortcuts for moving rules with "move up", "move down"
	Affected files: src/gui/RuleSetView.cpp, src/gui/RuleSetView.h

	* #1131 after rule moves with "move up" or "move down", it loses selection
	Affected files: src/gui/RuleSetView.cpp, src/gui/RuleSetView.h, src/gui/FWCmdRule.cpp

	* #1142 GUI crash on moving rule into a group with russian name
	Affected files: src/gui/RuleSetModel.cpp

2010-01-23  vadim  <vadim@vk.crocodile.org>

	* ../src/gui/FWWindow.cpp (FWWindow::startupLoad): fixes #147:
	show Release Notes only once when user starts the program for the
	first time. When user upgrades to a new version, Release Notes for
	it will be shown once again. Show tip of the day on all subsequent
	runs, unless user disables it.

	* instDialog_ui_ops.cpp (instDialog::setFlags): fixes #1136:
	"install" checkbox appears next to the cluster object in
	instDialog and "compile" checkoxes appear next to cluster
	member firewalls.

2010-01-23  yalovoy <yalovoy@gmail.com>

	* FWCmdRule.cpp (FWCmdRuleInsert::redoOnModel): refs #1127:
	GUI crash when clicking in undo panel.
	* FWCmdRule.h
	* RuleSetModel.cpp
	* RuleSetModel.h

2010-01-22  vadim  <vadim@vk.crocodile.org>

	* PolicyCompiler_iosacl.cpp (PolicyCompiler_iosacl::compile):
	fixes #1134: object-group clause can only be used with ipv4
	access lists in IOS per
	http://www.cisco.com/en/US/docs/ios/sec_data_plane/configuration/guide/sec_object_group_acl.html#wp1058359

	* IOSObjectGroup.cpp (IOSObjectGroup::toString): fixes #1107:
	support for "object-group" clause in IOS access lists. Fixed
	syntax for the subnet clause inside "object-group network".

2010-01-21  vadim  <vadim@vk.crocodile.org>

	* RuleOptionsDialog.cpp (RuleOptionsDialog::limitLabelChange):
	Added support for negation in the "-m limit --limit rate" clause
	for iptables.

2010-01-20  vadim  <vadim@vk.crocodile.org>

	* PolicyCompiler_PrintRule.cpp (PrintRule::_printModules): fixes
	#1123, #1124: Text label next to the option that translates into
	--connlimit-above clause for the iptables "connlimit" module
	now matches description in the iptables manual. Added checkbox
	that allows the user to add negation to the generated code
	(make it ! --connlimit-above NN)

	* IOSObjectGroup.cpp (IOSObjectGroup::toString): Refs #1107: first
	draft of the object-groups support for Cisco IOS. Controlled by a
	checkbox in the "Advanced" settings dialog of the firewall object;
	this feature requires IOS v12.4(20)T or later and is off by
	default.

	* CompilerDriver.cpp (CompilerDriver::validateClusterGroups):
	fixes #1119 "add test for the integrity of failover cluster
	groups".  Compilers require all failover group objects to be
	configured with interfaces of member firewalls.

	* PolicyCompiler_cisco_acls.cpp (setInterfaceAndDirectionBySrc::processNext):
	fixes #1120 "redundant commands generated for ssh
	access". Compiler for PIX generated two "ssh address netmask
	inside" commands for the same rule that permits ssh to the firewall.

	* CompilerDriver_pix_run.cpp (CompilerDriver_pix::assembleFwScript):
	fixes #1106 "fwb_pix does not include prolog". Prolog script was
	not included in generated configuration if firewall object was
	converted from some other platform because FirewallOptions? object
	inherited old "prolog_place" variable

	* Helper.cpp (Helper::findInterfaceByNetzone): fixes #1118
	"fwb_pix uses wrong interface compiling the second cluster
	member".  NAT compiler for PIX failed to find interface with
	correct network zone if interface was a child of another
	interface, e.g. vlan subinterface.

	* clusterMembersDialog.cpp (clusterMembersDialog::getSelectedMembers):
	fixes #1117 "failover group member editor loses interfaces". If
	failover group included vlan interfaces of the member firewalls,
	the dialog that appears when user clicks on "manage members"
	button would not show members at all.

	* NATCompiler_pix.cpp (NATCompiler_pix::_expand_interface): fixes
	#1115: "fwb_pix crash compiling cluster NAT rule set with
	interface in TSrc". A cluster interface was used in the TSrc rule
	element of a NAT rule. Cluster interfaces of PIX cluster have no
	ip addresses of their own (PIX HA pair uses ip addresses of the
	master unit), this caused rule element to become empty after
	interface object was supposed to be replaced with its ip address.

2010-01-19  vadim  <vadim@vk.crocodile.org>

	* ../src/cisco_lib/NATCompiler_pix.cpp (NATCompiler_pix::compile):
	fixes #1108: fwb_pix: incorrect access list is generated for
	"static". When a firewall or host object with an interface that
	was configured with netmask that was not
	255.255.255.255 (i.e. configured correctly) was used in TDst of a
	NAT rule for PIX firewall, compiler generated configuration that
	used subnet instead of just the address of the inetrface.

	* (NATCompiler_pix::_expand_interface): reimplemented virtual
	method Compiler::_expand_interface() to process cluster
	interfaces. Using member interface instead of the cluster
	interface while compiling the rule.

	* (createNATCmd::processNext): fixes #1114: "fwb_pix crash when fw
	with dynamic interface is used in TDst".

	* ../src/iptlib/NATCompiler_ipt.cpp (VerifyRules2::processNext):
	fixes #1109: "rules that do not pass verifyRules() checks may
	cause compiler crash in test mode or gui crash in single rule
	compile mode"

	* CompilerDriver.cpp (CompilerDriver::formSingleRuleCompileOutput):
	fixes #1110: "when compiler detects fatal error and drops the rule
	that caused it, the error does not appear in the single rule
	compile output".

	* ../src/pflib/TableFactory.cpp (TableFactory::createTablesForRE):
	fixes #1111: "NAT compiler for PF does not recognize dynamic
	interface of the firewall in rule element". Compiler issued an
	error that it can not generate code using dynamic interface that
	does not belong to the firewall because its address is unknown.

	* ../src/cisco_lib/NATCompiler_pix.cpp (VerifyRules::processNext):
	fixes #1104: policy compiler for PIX crashed when it enountered
	NAT rule trying to trsnslate both source and destination addresses.

	* ../src/cisco_lib/Helper.cpp (triplet::hash): fixes #1105:
	compiler for PIX crashed when interface with dynamic address
	was used in ODst of a NAT rule.

2010-01-17  vadim  <vadim@vk.crocodile.org>

	* instDialog_ui_ops.cpp (instDialog::checkIfNeedToInstall):
	Regression: fixed #1092 "missing "install" checkboxes in the list
	of firewalls on the first page of the installer
	wizard". Checkboxes "install" disappeared randomly from the first
	page of the installer wizard.

2010-01-16  vadim  <vadim@vk.crocodile.org>

	* FWCmdAddObject.cpp (FWCmdAddObject::redo): fixes #1088
	"duplicate objects on redo". Click on the last line in undo stack
	view created duplicate objects in the tree if some undo/redo
	commands created new objects.

	* ObjectManipulator_create_new.cpp (ObjectManipulator::newInterfaceAddress):
	fixes #1090: extra undo command added to the stack on "New address"

	* FWWindow.cpp (FWWindow::event): If user opens two data files
	with the same names but located in different directories, titles
	of the subwindows, the list in the main Windows menu and entries
	in the recently opened files list will display full path. See #936

	* FWWindow.cpp (FWWindow::fileOpen, FWWindow::alreadyOpened): The
	GUI should not let the user open the same data file twice. If user
	tries to do this, even using different (e.g. relative) path, the
	program will instead activate project window that already holds
	this file. Still can not open the same data file in two
	subwindows. See #396

2010-01-15  vadim  <vadim@vk.crocodile.org>

	* PolicyCompiler_ipt.cpp (PolicyCompiler_ipt::compile): Using rule
	processor Compiler::checkForObjectsWithErrors to find objects with
	errors and generate proper calls to abort(). This exposes errors
	that happened when Preprocessor failed to resolve compile-time
	AddressTable and DNSName objects. If compiler runs in test mode,
	preprocessor did not abort but used dummy substitution addresses
	and continued. Call to checkForObjectsWithErrors generates proper
	error messages tied to rules. Using this rule processor in all
	compilers. Fixes #1087

	* PolicyCompiler_ipt.cpp (processMultiAddressObjectsInRE::processNext):
	fixes #1086: incorrect processing of run time address tables.
	SourceForge bug 2932680. Rules with two run-time AddressTable
	objects in the same rule element (source or destination) were
	converted to the shell script that read addresses from the address
	table files, plus wrong iptables command that matched any to any.
	This change removes this extra command.

	* OSConfigurator_linux24.cpp (OSConfigurator_linux24::printShellFunctions):
	fixes #1084 "if all user turns off all interface management and
	configuration checkboxes, the check_tools shell function is not
	added to the script but still called". Shell function
	"check_tools" verifies that system tools iptables script needs to
	operate properly are installed on the firewall. These are: ip,
	modprobe and optionally vconfig, brctl, ifenslave. The bug made
	compiler for iptables to add the call to the function but function
	definition was missing if user unchecked all "configure
	interfaces" checkboxes in the Script tab of firewall object
	settings dialog.

	* CompilerDriver_ipt_run.cpp (CompilerDriver_ipt::run): Refs #869
	making sure non-english comments appear correctly in the single
	rule compile output and generated configuration files and scripts.

2010-01-14  vadim  <vadim@vk.crocodile.org>

	* FirewallInstaller.cpp: fixed #1083: "installer uses incorrect
	path when GUI runs on windows" (Sourceforge bug
	#2932446). Built-in installer used incorrect path on the firewall
	to store copy of the .fwb data file. This happened only when
	the GUI ran on Windows.

	* PolicyCompiler_pf_writers.cpp (PrintRule::processNext): Added
	support for pf state tracking options "no-sync" and "pflow". Set
	version to "4.5" or "4.6" in the firewall object to be able to use
	these new options.

2010-01-13  vadim  <vadim@vk.crocodile.org>

	* CompilerDriver.cpp (CompilerDriver::commonChecks2): fixes #1080:
	"Add warning when "top" rule set is missing". All compilers issue
	a warning when the firewall has no top level NAT or Policy rule
	set. This could be an important error because rule set is used to
	generate iptables rules for the built-in chains
	INPUT/OUTPUT/FORWARD or the main PF rules. However there are
	legitimate cases when administrator may want to use fwbuilder to
	only generate iptables commands for a custom chain or
	configuration for a custom PF anchor, in which case this is not an
	error. Compilers generate warning for this condition to bring it
	to the attention of administrator but continue processing the
	rules.

	* PolicyCompiler_ipt.cpp (PolicyCompiler_ipt::flushAndSetDefaultPolicy):
	fixes #178: "remove chain initialization commands in the single
	rule compile output". Lines that create chains do not need to be
	printed when user compiles just one rule, they take up display space
	and do not provide any useful information.

	* PolicyCompiler_PrintRuleIptRst.cpp (PrintRuleIptRst::_printRuleLabel):
	really fixed #869 '"compile rule" should also print the comment'.
	Printing rule comment in the compiler output in the single rule
	compile mode when firewall object is configured to use
	iptables-restore. Code that prints rule label and comment has been
	unified for compilers for all firewall platforms.

2010-01-12  vadim  <vadim@vk.crocodile.org>

	* TCPServiceDialog.cpp (TCPServiceDialog::applyChanges): fixed bug
	#1076: "when the start of a port range is greater than the end,
	the GUI goes into a loop showing error dialogs". Ths problem
	affected TCP and UDP service objects

2010-01-10  vadim  <vadim@vk.crocodile.org>

	* TableFactory.cpp (TableFactory::PrintTables): suppress comment
	"Tables: (0)" in the compiler for PF output when there are no
	tables.

	* CompilerDriver.cpp (CompilerDriver::findImportedRuleSets): fixed
	bug #1072: "member ruleset override produces empty config files
	for PF". In this case, cluster nat rule branched to a separate nat
	rule set. There was nat rule set with the same name in the member
	firewall but compiler seemed to ignore it and produced empty .conf
	file for this rule set. The warning about member having rule set
	with the same name was not issued

	* NATCompiler_pf.cpp (checkForDynamicInterfacesOfOtherObjects::findDynamicInterfaces):
	fixed bug #1071 "can't use dynamic cluster interface in NAT rules
	for PF". In this case, cluster has interface rl1 which is mapped
	to dynamic interfaces rl1 of two member firewalls. Cluster
	interface object is used in the TSrc of a NAT rule. Compiler
	refused to compile this rule with error "cluster:NAT:2: error: Can
	not build rule using dynamic interface 'rl1' of the object 'member1'
	because its address in unknown."

2010-01-09  Vadim Kurland  <vadim@vk.crocodile.org>

	* src/res/configlets/openwrt/installer_commands_root: Added
	support for OpenWRT. Generated iptables script has standard format
	of the OpenWRT system scripts and should be installed in
	/etc/init.d/. The script loads firewall policy when it is started
	with command line argument "start" and stops it when it runs with
	argument "stop". Other standard arguments recognized by OpenWRT
	startup scripts are also supported. To make the system run
	fwbuilder script during boot, run it with argument "enable".  See
	Release Notes for more details.


	* OSConfigurator_bsd.cpp (OSConfigurator_bsd::configureInterfaces):
	Added support for configuring ipv6 addresses of interfaces for *BSD,
	including CARP cluster interfaces

2010-01-08  Vadim Kurland  <vadim@vk.crocodile.org>

	* NATCompiler_ipt.cpp (AssignInterface::processNext): fixed bug
	#1064: "Dedicated IPv6 interfaces show up in IPv4-NAT rules". Use
	interface only if it has addresses that match address family we
	compile for.

	* PolicyCompiler.cpp (PolicyCompiler::checkInterfacesForShadowing):
	(change in libfwbuilder) include interface rule element in the
	shadowing detection algorithm. See ticket #1068

2010-01-07  Vadim Kurland  <vadim@vk.crocodile.org>

	* FWObjectPropertiesFactory.cpp (FWObjectPropertiesFactory::getObjectPropertiesBrief):
	fixes #1059: "set attribute field in gui tree for policy and nat
	based on its settings". Show "top ruleset" and "ipv4" or "ipv6" in
	the second column of the object tree for rule set objects.

	* ProjectPanel_file_ops.cpp (ProjectPanel::loadLibrary): fixed bug
	#1053 "duplicate objects created on "Import library" operation".
	When user used "File/Import Library" function, the library is
	checked for objects with duplicate IDs. Library name is also
	checked for duplicates and changed by adding suffix "-1" if it
	matches existing library name. This means the same library can now
	be imported several times, which creates several copies (all with
	their unique IDs to make XML file valid)

2010-01-06  vadim  <vadim@vk.crocodile.org>

	* bug fixes in installer for PF: fixed commands it runs on the
	firewall when it authenticates as regular user.

	* ObjectManipulator_create_new.cpp (ObjectManipulator::newInterface):
	fixed bug #1051: GUI crash when user tried to add an interface to
	an interface.

	* CompilerDriver_pf.cpp (CompilerDriver_pf::getRemoteConfFileName):
	fixed bug #1049 (SourceForge bug #2927165) '(windows only)
	installer uses incorrect path on the OpenBSD firewall'

2010-01-01  vadim  <vadim@vk.crocodile.org>

	* instOptionsDialog.cpp (instOptionsDialog::instOptionsDialog):
	fixed bug #1043: added explanation of the risk associated with
	password caching to the Preferences dialog and Release Notes;
	checkbox "remember passwords" will be disabled if user name is not
	configured

	* ObjectManipulator_tree_ops.cpp (ObjectManipulator::updateLibName):
	fixed bug #1042: editing name of a library updates it in the tree
	but does not update it in the drop-down list

2009-12-29  vadim  <vadim@vk.crocodile.org>

	* RuleSetView.cpp (RuleSetView::restoreCurrentRowColumn): fixed
	bug that caused rule set view to scroll all the way to the top
	every time user modified any object used in the rules. Fixes #968

2009-12-28  vadim  <vadim@vk.crocodile.org>

	Ticket #1040 (Another GUI crash in newClusterDialog) closed by a2k
	fixed

	Ticket #1038 (GUI crash in newClusterDialog on Ubuntu 8.04) closed
	by a2k fixed: (In [2296]) Fixed #1038

	Ticket #1014 (fix tab order of elements in iptadvanceddialog_q.ui)
	closed by a2k fixed: (In [2292]) Fixed #1013, #1014, #1015, #1016,
	#1017

	Ticket #1015 (fix tab order in pixadvanceddialog_q.ui) closed by
	a2k fixed: (In [2292]) Fixed #1013, #1014, #1015, #1016, #1017

	Ticket #1016 (fix tab order in pfadvanceddialog_q.ui) closed by
	a2k fixed: (In [2292]) Fixed #1013, #1014, #1015, #1016, #1017

	Ticket #1017 (fix tab order in openbsdadvanceddialog_q.ui) closed
	by a2k fixed: (In [2292]) Fixed #1013, #1014, #1015, #1016, #1017

	Ticket #1013 (fix tab order of elements in
	iosacladvanceddialog_q.ui) closed by a2k fixed: (In [2292]) Fixed
	#1013, #1014, #1015, #1016, #1017

	Ticket #1030 (firewall name should be prepended with library name
	in the list on the ...) closed by a2k fixed: (In [2290]) Fixed
	#1030

	Ticket #1025 (newCLuster dialog loses all interface addresses if
	user hits Back on the ...) closed by a2k fixed: (In [2289]) Fixed
	#1025, #1019

	Ticket #1019 (unit test failure) closed by a2k fixed: (In [2289])
	Fixed #1025, #1019


	* instDialog_ui_ops.cpp (instDialog::setFlags): For the PIX
	cluster, built-in installer installs generated configuration only
	on the master member firewall. It determines which one is the
	master by looking in the StateSyncGroup object (state
	synchronization cluster group). Fixes #998

	* fixed a bug in the rule options dialog: if user tried to edit
	iptables log prefix for the rule and deleted a character in the
	middle of the string, cursor jumped to the end of the line. Also,
	undo command was created for each keystroke in this input field.
	fixes #1037

2009-12-27  vadim  <vadim@vk.crocodile.org>

	* PolicyCompiler_iosacl.cpp (PolicyCompiler_iosacl::addDefaultPolicyRule):
	compiler for IOS ACL added only inbound automatic rule to permit
	ssh access from the management workstation but did not add a rule
	to permit reply packets. This fixes #993

	* CompilerDriver_iosacl_run.cpp (CompilerDriver_iosacl::run):
	fixed bug (no #): compiler for iosacl failed to open output file
	because of the wrong path.

	* pfAdvancedDialog.cpp (pfAdvancedDialog::pfAdvancedDialog): fixed
	SF bug #2919941 "Wrong optimization flag for PF". If "For high
	latency" is selected the compiler outputs the following value for
	OpenBSD PF: "set optimization For high latency". Which is wrong
	syntax, should be high-latency. Fixes #1005

	* bug fixes and changes 2009-12-27:

	Ticket #1032 ("creating cluster from selected firewalls" does not
	work) closed by vadim fixed: (In [2279])

	Ticket #1031 ("New Cluster" function creates two undo commands and
	two cluster objects) closed by vadim fixed: (In [2278])

	Ticket #969 ("Create and add to group" creates several undo
	commands) closed by yalovoy fixed: (In [2277])


2009-12-26  vadim  <vadim@vk.crocodile.org>

	* ObjectManipulator_ops.cpp (ObjectManipulator::actuallyPasteTo):
	when an object was duplicated to another library, suffix "-1" was
	appended to its name even if there were no other objects with the
	same name. Also when an object was pasted into a group, its name
	was preserved. If the group had an object with the same name and
	user opened new one in the editor and tried to change anything,
	the program complained about duplicate name. fixes #1028

	* newClusterDialog.cpp: program crashed when user tried to create
	new cluster dialog and turned the option to copy rules from one
	of the members to the cluster. Fixes #1026

2009-12-25  vadim  <vadim@vk.crocodile.org>

	* ObjectManipulator.cpp (ObjectManipulator::contextMenuRequested):
	fixed bug #1022: context menu item "New Interface" is disabled.
	if user selected an interface object in the tree and opens context
	menu, the "New Interface" menu item was always disabled.

2009-12-23  vadim  <vadim@vk.crocodile.org>

	* instOptionsDialog.cpp (instOptionsDialog::instOptionsDialog):
	Added support for the "dry run" installer option for Cisco
	routers.  When this option is on, installer logs into the router
	and switches to the enable mode, but does not execute any actual
	commands. If scp is used to copy configuration to the router,
	installer will copy the file but will not activate it. This tests
	ssh session in general, login password, enable password and scp
	but does not make any changes to the router configuration.

	* OSConfigurator_pix_os.cpp (OSConfigurator_pix_os::_printSSHConfiguration):
	Implemented pushing of the PIX configuration using scp. This
	requires PIX v7, ssh v2 and scp should be enabled on the
	firewall. This method is much faster than running configuration
	line by line. Controlled by a checkbox in the pix advanced
	settings dialog. fixes #995

2009-12-22  vadim  <vadim@vk.crocodile.org>

	* src/res/configlets/ios/installer_commands_reg_user: Built-in
	installer can use command scp to copy IOS configuration to the
	router using ssh and then command "copy file running-config" to
	activate it.  This method is much faster than running
	configuration line by line.  The router should be configured with
	ssh v2 and scp server. This method can be combined with
	rollback (by reload or EEM).

	* src/res/configlets/ios/installer_commands_pre_config: Built-in
	policy installer uses EEM (Embedded Event Manager) on IOS 12.4 or
	later to schedule automatic configuration rollback instead of
	reloading the router.  EEM appears in IOS 12.4 and supports
	background operations that can be triggered by some events on the
	router or by timers. In this new feature, fwbuilder creates EEM
	applet with a countdown timer that executes command "config
	replace nvram:startup-config force" when timer expires. User has
	the following options:

	 - install updated ACL configuration and schedule automatic
	rollback in a few minutes. This can be used to test new policy and
	revert to the original one after some short period of time. This
	also helps to avoid a situation when updated policy blocks access
	to the router because of an error; rolling back to the ACL
	configuration that was running before the update will restore
	access automatically.

	 - install updated ACL, schedule rollback in a few minutes but
	cancel rollback if installation of the new configuration was
	successful. This is mostly intended to prevent blocking access to
	the router in case of an error in the new ACL configuration. If
	fwbuilder was able to enter all lines of the new configuration all
	the way to the end, then new configuration does not block access
	and installer executes command "no event manager applet
	fwbuilder-rollback" to cancel scheduled rollback.

2009-12-21  vadim  <vadim@vk.crocodile.org>

	* bug fixes and changes for 2009-12-21:

	Ticket #982 (raise floating tree window when user switches between
	different project windows) closed by vadim fixed: (In [2233])

	Ticket #981 (Error entering new service. User could not change
	port range start before changing port range end for TCP and UDP
	services) closed by vadim fixed: (In [2234])

	Ticket #983 (crash on IOS configuration import) closed by vadim
	fixed: (In [2235])

	Ticket #875 (unit tests for the policy importers) closed by a2k
	fixed: (In [2237])

	Ticket #897 (Add paragraph to the release notes explaining new
	"conntrack" tab in host OS dialog for Linux) closed by vadim
	fixed: (In [2239])

	Ticket #901 (mention support for openWRT in release notes) closed
	by vadim fixed: (In [2239])

	Ticket #900 (mention support for ipcop in release notes) closed by
	vadim fixed: (In [2239])

	Ticket #899 (paragraph about script structure and command line
	args in release notes) closed by vadim fixed: (In [2239])

	Ticket #788 (review ChangeLog and update release notes for v4.0)
	closed by vadim fixed: (In [2240])


2009-12-20  vadim  <vadim@vk.crocodile.org>


	* interfaceProperties.cpp (interfaceProperties::validateInterface):
	permit unnumbered cluster interfaces. If member firewalls have
	unnumbered interfaces that user wants to use in rules, then
	cluster needs corresponding cluster interface as well. Previously
	the GUI did not allow copy/paste of an unnumbered interface from a
	firewall to a cluster and compiler complained about such interface
	not having ip address. Now both operations are permitted.

	* minor bug fixes:

	Ticket #971 (cluster interface should inherit properties of the
	member interfaces) closed by vadim fixed: (In [2225]) refs #487
	fixes #966, #971

	Ticket #947 (Add new options to the "help" dialog) closed by vadim

	Ticket #975 (if fw object has empty platform, it can not be
	changed) closed by vadim fixed: (In [2228])

	Ticket #977 (context menu items Delete and Cut are disabled if
	library is Template ...) closed by vadim fixed: (In [2229])

	Ticket #974 (fw template 3 is broken) closed by vadim

	Ticket #979 (recognize extension .fwl for the template file)
	closed by vadim

2009-12-19  vadim  <vadim@vk.crocodile.org>

	* src/res/configlets/linux24/status_action: Fixes #954 : generated
	iptables script now recognizes "status" command line
	parameter. When the script runs with this parameter, its exist
	status code indicates the state of the firewall: 0 means iptables
	modules are loaded and some rules are configured; 3 means either
	modules are not loaded or there are no tables. The script can not
	verify that the rules are those configured in fwbuilder, it only
	verifies that modules are loaded and there are some
	rules. Configuration with no rules but with default policies, even
	if these policies are ACCEPT in all chanins, returns "0" return
	code. This is consistent with behavior of
	/etc/rc.d/init.d/iptables script on Fedora Core Linux.

	* RuleSetView.cpp (RuleSetView::changeAction): fixed #957: when
	user changes action of a policy rule, it should be opened in the
	editor only if the new action has some parameters that can be
	edited. Such actions as "accept" and "deny" have no parameters and
	it does not make sense to open blank editor panel.

	* Ticket #959 (context menu items appear rearranged) closed by a2k
	fixed: (In [2212]) Fixed #959

	* Ticket #958 (when user compiles single firewall, skip the first
	page of the wizard) closed by a2k fixed: (In [2210]) Fixed #958

	* Ticket #952 (tooltips in RuleSetView should be controlled by ...)
	closed by yalovoy fixed: (In [2209]) fixes #952 tooltips in
	RuleSetView? should be controlled by …

	* Ticket #941 (Add Rule Below adds the new rule above) closed by
	yalovoy fixed: (In [2208]) fixes #941 Add Rule Below adds the new
	rule above

	* Ticket #951 (double click on an object in the group member list
	should open it in the ...) closed by a2k fixed: (In [2206]) Fixed
	#951

	* Ticket #931 (context menu item "New cluster from selected
	firewalls" should be enabled ...) closed by a2k fixed: (In [2205])
	Fixed #931


2009-12-18  vadim  <vadim@vk.crocodile.org>

	* CompilerDriver_ipt_run.cpp (CompilerDriver_ipt::run): generated
	script can now install backup ssh access rule when it shuts down
	the firewall. This is optional and is controlled by a checkbox in
	the "advanced settings" dialog for iptables firewall. To shut down
	the firewall user should run the script with command line option
	"stop". fixes #939

2009-12-17  vadim  <vadim@vk.crocodile.org>

	* fixed bug in the GUI: when user duplicated an object, it was
	created with the same name as the original, then the program
	complained about duplicate name on every attempt to modify it.

	* creating IPv4 or IPv6 address object using main "New object"
	menu ended up creating two identical objects instead of one

	* built-in policy installer failed if the GUI was running on
	Windows, the firewall was running CentOS5 system and regular user
	account was used to authenticate

	* fixed bug in the GUI: it was not possible to add interface
	object to the "Interface" rule element of Policy and Routing
	rules.

	* fixed bug in the GUI: if the user hit Tab to move from one
	input field in the object editor to another after making some
	changes, keyboard focus jumped to the object tree.

	* improvement in the built-in policy installer: now installer
	dialog terminates background ssh or scp process if user clicks
	"Cancel" or closes dialog window in the middle of the process.

	* documentation: Added comment to all configlet files explaining
	how user can modify them.

2009-12-16  vadim  <vadim@vk.crocodile.org>

	* src/res/configlets/linux24/installer_commands_root: Added
	command "chomd +x" to make firewall script executable on the
	firewall. Before, this was only done when the program used
	regular user account rather than root. Fixes #909

	* src/res/configlets/linux24/installer_commands_root: Built-in
	policy installer gets commands that it needs to execute on the
	firewall from configlets (small scripts using simple macro
	language) that are installed in the
	/usr/share/fwbuilder-3.1.0/configlets on Linux. User can modify
	them by making a copy in $HOME/fwbuilder/configlets without having
	to touch the code. Fixes #268.

2009-12-15  vadim  <vadim@vk.crocodile.org>

	* FirewallInstaller.cpp (FirewallInstaller::readManifest): fixed
	bug in installer: when the GUI ran on Windows, the path of the
	file on the firewall was generated with mixed separators '/' and
	'\'. As the result, pscp.exe failed to copy the file to the
	firewall.

	* OSConfigurator_linux24::printInterfaceConfigurationCommands:
	call shell function clear_addresses_except_known_interfaces() with
	a list of all interfaces configured in fwbuilder. This will clear
	ip addresses of interfaces that are not configured in fwbuilder
	and bring them down. Before, the call to this function did not
	include dynamic interfaces and as the result, the script deleted
	their addresses and brought them down.

	* ../src/res/os/linux24.xml: the GUI and compiler should not
	assume that when failover protocol is VRRP, then there should be
	interface vrrpN. This seems to be the case and the default only
	for Secunet Secuwall firewall. Vrrpd daemon on Linux does not
	create vrrp inetrfaces and just manipulates alias IP and MAC
	addresses. Fixes #895

	* objects_init.xml: Standard objects library now comes with new
	IPv6 Network objects. These objects represent IPv6 networks that
	should not be routed on the Internet. Included: RFC3849
	"Documentation Network" 2001:db8::; RFC4291 "Link local"
	fe80::/10; RFC4773 "Experimental Network" 2001:0000::/29 to
	2001:01F8::/29. Also added a group "ipv6 private" that includes
	all these networks. Fixes #888

	* instDialog.cpp (instDialog::instDialog): Moved "batch install"
	checkbox to the page that shows compiler progress so the user can
	decide to do batch install right before they perform installations
	instead of doing this before they start compile.

2009-12-14  vadim  <vadim@vk.crocodile.org>

	* src/res/configlets/linux24/automatic_rules: Generation of the
	automatic rules (matching ESTABLISHED and INVALID states,
	backup ssh access and others) now uses configlet. Fixes #883

	* src/res/configlets/linux24/automatic_rules: generated script can
	now include automatic rules to match IPv6 neighbor discovery ICMP6
	packets. This is controlled by a checkbox in the iptables
	"advanced" settings dialog and is off by default. Fixes #878

	* PrefsDialog.cpp (PrefsDialog::accept): Added a place in the
	global Preferences dialog for options specific for different
	object types. First parameters include options for DNSName and
	AddressTable to let the user decide if the newly created objects
	of these types should be automatically configured with "Compile
	Time" or "Run Time" mode. Also, added an option that makes DNSName
	object editor copy the name of the object into the DNS record
	input field when new object is created or whenever the name
	changes.  This is useful when the user does not want to keep
	object name and dns record different because they need to enter
	the name only once.

	* DNSNameDialog.cpp (DNSNameDialog::applyChanges): If global
	Preferences option "Use DNS Name object name for the DNS record"
	is turned on, copy the name into the record on every name change.
	Fixes #866

2009-12-11  vadim  <vadim@vk.crocodile.org>

	* GroupObjectDialog.cpp (GroupObjectDialog::newObject):
	Implemented feature request #2245537 "Add service object to
	service groups directly from groups". Group object dialog now has
	a button that shows a menu when clicked, this menu allows the user
	to create new object and add it to the group in one operation.
	This fixes #119

	* ObjectManipulator::addNewObjectMenuItem: fixes #850 Redesigned
	methods used to create "new object" menu and call functions that
	create new objects to be able to build menus with limited sets
	of new object types.

	* ../src/gui/FWBTree.h (class FWBTree): added methods
	getTranslatableObjectTypeName and getTranslatableNewObjectMenuText
	that return translatable strings for the given object type name.

2009-12-09  vadim  <vadim@vk.crocodile.org>

	* FindWhereUsedWidget.cpp (FindWhereUsedWidget::_find): "Find
	where used" function can now find all uses of the given object, as
	well as all uses of its children. For example, if the object is
	firewall, then this function can find all groups and rules that
	refer to it directly, or to it and all its interfaces and their
	addresses. This extension is optional, it is controlled by a
	checkbox in the "Find" dialog.

2009-12-08  vadim  <vadim@vk.crocodile.org>

	* ../src/fwbedit/merge.cpp: fixed bug #2794851 (fwbuilder bug
	#202): "Ability to import Library using fwbedit". User can now
	merge objects from two files together using fwbedit just like the
	"Import library" function in the GUI.

2009-12-07  vadim  <vadim@vk.crocodile.org>

	* instDialog_ui_ops.cpp (instDialog::getInstOptions): fixed bug
	#2908220 (fwbuilder bug #803): "Running fwbuilder as root
	hardcodes batch install user".  Built-in installer ignored user
	name entered in the installer options dialog and communicated with
	the firewall using the name of the user running the program.

2009-12-04  vadim  <vadim@vk.crocodile.org>

	* ../src/res/platform/pf.xml, iptables.xml: unified terminology
	for policy rule actions that create branching in the rule set or
	tag packets. Now we call these actions "Branch" and "Tag" for all
	platforms. Before, the name was different and matched original
	action on each platform, that is for PF it was "Anchor" and "Tag"
	and for iptables "Chain" and "Mark" respectively.

2009-12-01  vadim  <vadim@vk.crocodile.org>

	* src/res/configlets/linux24/run_time_wrappers: fixed #651:
	"support for dynamic ipv6 addresses is broken". When an interface
	with dynamic address was used in a rule in IPv6 rule set,
	generated shell script was supposed to read its IPV6 address and
	use it in the rule. This code was broken and never worked
	properly. Implemented idea for getaddr6 code suggested by
	<j.kammer@eurodata.de>, it now reads all IPv6 addresses of the
	interface and uses them in the rule via shell "for"
	loop. Implemented the same change for IPv4 as well. This changes
	behavior of the generated iptables script compared to fwbuilder v2
	and v3 where it only used the first IPv4 address of the dynamic
	interface. In v3.1 and v4 it will use all addresses of such
	interface.

2009-11-29  vadim  <vadim@vk.crocodile.org>

	* newClusterDialog.cpp (newClusterDialog::finishClicked): New
	feature: the wizard that creates new cluster object starts with
	the list of firewall objects where the user can choose which
	firewalls should become members of the cluster. Next, the program
	finds interfaces of the member firewalls that have the same name
	and can be part of the cluster and creates cluster interfaces with
	the same name. Not all interfaces are eligible, for example bridge
	ports, bonding interface slaves or parents of vlan interfaces can
	not be used for the cluster. Cluster interfaces define failover
	groups. The user can add, remove or rename cluster interfaces, as
	well as change which interfaces of the member firewalls are used
	with each one. On the next page of the wizard user changes
	failover protocols and can add or remove or change ip addresses of
	cluster interfaces. Not all failover protocols require ip
	addresses, for example VRRP or CARP do but heartbeat or OpenAIS
	don't. Finally, the user can choose to use policy and NAT rules of
	one of the member firewalls to populate Policy and NAT rule sets
	of the new cluster. If this is done, all references to the
	original member firewall and its interfaces in rules are replaced
	with references to the cluster and its interfaces. The program
	also creates backup copies of the member firewall objects with
	the name with suffux "-bak" and clears Policy and NAT rule sets of
	the member firewall objects used with the cluster before new cluster
	is created.

2009-11-21  vadim  <vadim@vk.crocodile.org>

	* ObjectEditor.cpp (ObjectEditor::apply): New feature: behavior of
	all object dialogs has changed. According to the results of the
	user community opinion poll and discussion, object dialogs are
	losing button "Apply". All changes made in dialog entry fields are
	saved into the object immediately. This does not change the data
	in the .fwb file, only objects in memory. Combined with Undo, this
	allows for faster object editing and roll back of changes.

	* New feature: Undo/Redo facility. Undo supports changes to object
	parameters in editors, creation of new objects, deletion of
	objects, adding and removed objects to groups. Undo stack can be
	displayed in a special docked window.

2009-11-14  vadim  <vadim@vk.crocodile.org>

	* newFirewallDialog_from_template.cpp (newFirewallDialog::replaceReferencesToNetworks):
	New feature: when user creates new firewall from a template, the
	wizard dialog now offers a new page where they can change ip
	addresses of the interfaces of the template. User can change name,
	label, address, netmask, MAC address and type (regular/dynamic) of
	the interface, as well as add and delete interfaces. The program
	then creates interface objects with new parameters and updates
	policy and NAT rules of the template. It creates new Network and
	NetworkIPv6 objects using new addresses and replaces references to
	network objects that match old addresses with references to these
	new objects in rules and groups. This eliminates the need to do
	manual search and replace to update firewall object created from a
	template to make it match actual user network configuration.
	Fixes #613

2009-11-10  vadim  <vadim@vk.crocodile.org>

	* configlets/pix_os/failover_commands: New feature: Added ability
	to generate failover commands for PIX. Summary:

	- only "lan" type failover configuration is supported

	 - one interface in each member firewall should be marked as
	"dedicated failover" interface. These interfaces must have the
	same name.

	 - cluster should have interface with the same name as failover
	interface of the member firewalls; this cluster interface should
	have failover cluster group child object. The failover group is
	configured with failover interfaces of both members. One interface
	must be marked as "master". Compiler checks for this.

	- Protocol in this failover group should be configured as "PIX
	failover protocol"

	 - cluster must have state synchronization cluster group object,
	configured with interfaces of member firewalls. Use the same
	interface as for the failover or another dedicated inetrface. In
	the latter case interface objects of the member firewalls used for
	state sync must be marked as "dedicated failover" as well.

	 - Failover and state sync groups should have the same member
	firewall configured as "master". Compiler checks for this.

	 - Regular interfaces: cluster should have interface object with
	the name matching corresponding interface of member
	firewalls. Each of these cluster interfaces should have failover
	cluster group child object configured with member firewall
	interfaces. Protocol in this failover group can be set to
	"None" (or blank). It is also not necessary to mark member
	interface as master.


	* OSConfigurator_pix_os.cpp (OSConfigurator_pix_os::_printInterfaceConfiguration):
	Using configlet to generate interface configuration commands for
	PIX. Now user can change generated script if necessary without
	making changes in the fwbuilder code.

	* ObjectManipulator.cpp (ObjectManipulator::libChanged):
	Experimental change in the GUI, new feature: Now the program does
	not switch object in the editor on a single click in the tree.
	User should double click object in the tree or use context menu
	item "Edit" to open object in the editor. User can select
	different object in the tree or switch to another library while
	editor has unsaved changes. This helps, for example, when they
	need to populate large object group and need to switch between
	libraries to find objects. Switching to another library or
	accidentally clicking on a wrong object in the tree does not cause
	editor to switch.

2009-11-09  vadim  <vadim@vk.crocodile.org>

	* CompilerDriver_pix_run.cpp (CompilerDriver_pix::run): Added
	support for failover configurations for PIX.

	- Interfaces of member firewalls used for failover configuration
	should be marked as "Dedicated failover" interfaces. They should
	have normal IP addresses. These interfaces will be used to
	generate "failover" commands in the PIX configuration.

	- Cluster should have interface with the same name as failover
	interfaces of the members, with protocol set to "PIX failover" and
	members configured as usual. This interface has no ip address.

	- Other interfaces of the cluster have the same name as
	corresponding interfaces of the member firewalls, protocol "None"
	and failover groups that define members as usual. These cluster
	interfaces also have no ip address.

	- Cluster state synchronization group uses protocol "PIX state
	synchrnization" and its members should be configured as usual.
	Use failover interfaces of the members as members of the state
	sync group.

	* Interface.cpp: Added attribute "dedicated_failover" to the
	Interface object. Interfaces with this attribute are treated like
	other "unprotected" interfaces, that is they are not used to
	attach ACLs to and not used in rules. Dedicated failover
	interfaces have special meaning in PIX configurations and are used
	to describe interfaces used for LAN failover.

2009-11-07  vadim  <vadim@vk.crocodile.org>

	* PolicyCompiler_iosacl_writers.cpp (PrintRule::_printTCPFlags):
	Implemented TCP flag matching per #2865044: "Add TCP options
	support for IOS ACL". Uses extended ACL option "match-all" that
	supports list of TCP flags that should be set and cleared. This
	requires IOS v12.4 or later even though Cisco documentation seems
	to indicate this option was introduced in 12.3(4)T. Fixes #455

2009-11-06  vadim  <vadim@vk.crocodile.org>

	* PolicyCompiler_pix_writers.cpp (PrintRule::_printDstService): PIX
	does not support IP options matching, compiler issues warning.
	Fixes #567

	* res/platform/iosacl.xml: Recognized IOS versions: 12.1, 12.2,
	12.3, 12.4

	* PolicyCompiler_iosacl_writers.cpp (PrintRule::_printIPServiceOptions):
	Added support for IP options matching, requires IOS v12.4 or
	later. Fixes #566, #568

	* configlets/sveasoft/script_skeleton: Fixes #571 /bin/sh on
	Sveasoft (busybox) does not like empty shell functions and fails
	with an error "36: Syntax error: "}" unexpected". Will call
	/bin/true as a placeholder so that if some other commands are
	added to the function body during template expansion, they are
	executed after /bin/true and their return code is preserved. If no
	commands are added, then the function body won't be empty and will
	return success.

	* NATCompiler_pf.cpp (NATCompiler_pf::compile): fixed bug
	#2889579: "fwb_pf crash when unnumbered interface is used in nat
	rule". Compiler for PF crashed when unnumbered interface was used
	in TSrc element of a NAT rule.

	* PolicyCompiler_PrintRule.cpp (PrintRule::_printSrcAddr): Fixed
	bug #2892100: "'Old boradcast' object produces 0/0 in iptables
	script". The bug triggered when iptables version was set to 1.3.x
	or later. "Old broadcast" object is defined as AddressRange with
	0.0.0.0 as a start and end addresses of the range. Generated
	script should have "0.0.0.0" but the compiler uses "0/0" instead.

2009-11-04  Vadim Kurland  <vadim@vk.crocodile.org>

	* PolicyCompiler_ipfw_writers.cpp (PrintRule::_printDstService):
	Added support for IP options matching in ipfw using "ipoptions"
	keyword. Matching IPService object with "any options" attribute
	is not supported though.

	* IPServiceDialog.cpp (IPServiceDialog::loadFWObject): IPService
	object now has attribute "any options". If this attribute is
	turned on, compilers will generate configuration to match IP
	packets with any options present. Fixes #561

2009-11-03  Vadim Kurland  <vadim@vk.crocodile.org>

	* NATCompiler_ipt.cpp (dynamicInterfaceInTSrc::processNext):
	Implemented feature request #2829661: "SNAT instead of MASQUERADE
	on dynamic interfaces". NAT rule options dialog now has a checkbox
	that makes compiler use SNAT target instead of MASQUERADING when
	checked when TSrc has dynamic interface. Apparently MASQ target
	has problems when iptables NAT is used in combination with policy
	routing. Using SNAT with a variable that gets interface address
	solves the problem. By default this option is off, that is
	compiler uses MASQUERADE target when TSrc has dynamic interface.
	Fixes #560

	* PolicyCompiler_ipt.cpp (PolicyCompiler_ipt::prolog): Fixed bug
	#2792847 (SourceForge) "cant turn off "part of any" for a rule if
	default is on". There was no way to turn option "Assume firewall
	is part of any" for just one rule when it was ON globally. Now
	this attribute is presented as a tri-state control in the rule
	options dialog, with options "Follow global setting", "On" and
	"Off". Now this option can be turned on and off in individual
	rules regardless of the global setting. Default is "follow
	global".  Old "Off" maps to the new "follow global", old "On" maps
	to the new "On". Fixes #559.

2009-11-02  Vadim Kurland  <vadim@vk.crocodile.org>

	* PolicyCompiler_pf_writers.cpp (PrintRule::_printInterface): New
	feature: optimization in compiler for PF. Rules that have several
	interface objects (or a group) in the "Interface" column are
	compiled using "{ }" grouping to produce only one configuration
	line instead of several for such rule. Fixes #76

	* PolicyCompiler_pf.cpp (SpecialServices::processNext): Compiler
	for PF generates "allow-opts" keyword when IPService object used
	in the rule has IP options. This includes new option "router-alert".
	Fixes #503

	* IPServiceDialog.cpp (IPServiceDialog::applyChanges): Added GUI
	elements to support IP option "router-alert" which is now
	available as an attribute of IPService object. Fixes #502

2009-11-01  Vadim Kurland  <vadim@vk.crocodile.org>

	* CompilerDriver_pf.cpp (CompilerDriver_pf::printStaticOptions):
	Added support for PF configuration parameter "set state-policy"
	which can have values "if-bound" or "floating". The GUI input
	element provides these options in addition to the default empty
	option. If empty list item is selected, command "set state-policy"
	is not added to the generated .conf file at all. Fixes #423

2009-10-31  Vadim Kurland  <vadim@vk.crocodile.org>

	* instOptionsDialog.cpp (instOptionsDialog::instOptionsDialog):
	New feature: password caching. Built-in installer can remember
	firewall password (and enable password for Ciscos) for the
	duration of the session. Passwords are never stored permanenetly
	in any form, encrypted or plain text. The user needs to enter
	password once when they activate generated policy. If they keep
	the program open and need to modify and activate policy again, the
	password fields in the installer dialog can be filled
	automatically. The feature is optional and is off by default.
	Cached passwords are associated with the firewall object and
	account name used to activate policy. Implemented by a2k@codeminders.com

2009-10-22  vadim  <vadim@vk.crocodile.org>

	* RuleSetView.cpp (RuleSetView::itemDoubleClicked): Fixes #545.
	Change in the GUI behavior: both left and right mouse click on an
	object in rules should not select it in the tree. If user wants to
	open it in the tree, they can use context menu item "Reveal in the
	tree" or double click the object. This solves the following
	inconvenient behavior (quoting from email):

	1) anytime I copy something and then right click to paste into a
	policy or nat it immediately changes the tree to the location of
	the object under the cursor which is usually to the standard
	library on any and then i have change it back to the user
	library.

	2) if I want to compile a rule, unless I am careful and right
	click on the rule number instead of any field in the rule to
	select compile it move the tree to whatever is under the cursor.

2009-10-20  vadim  <vadim@vk.crocodile.org>

	* NATCompiler_pf_writers.cpp (PrintRule::processNext): Added
	support for branching NAT rules for PF. Compiler generates
	keyword "anchor" if PF version is 4.3 or later and "nat-anchor"
	and "rdr-anchor" for earlier versions.

	* platforms.cpp (getActionNameForPlatform): Human-readable names
	for Policy and NAT rule actions come from the platform .xml
	resource file (attribute "description"). This implements Feature
	Requests #1948874 and #1796803

	* Support for branch rules in NAT rule sets. Currently only
	supported for iptables and PF. NAT rules get column "Action" for
	these platforms, with possible acctions "Translate" and "Branch".
	Action parameters dialog for the Branch action provides drop well
	where another NAT ruleset object can be dropped (just like with
	Branch action in the Policy rules). Action "Translate" performs
	translation as defined in the rule. Objects in the "Translated
	source/destination/service" are ignored in NAT rules with action
	"Branch" and a warning is issued at compile time.

	* NATCompiler_ipt.cpp (splitNATBranchRule::processNext): Support
	for branching NAT rules for iptables. Rules in the branch rule set
	are processed first and their targets and corresponding chains are
	recorded. These rules are placed in the user-defined chains with
	the name composed of the rule set name and the
	chain ("POSTROUTING" or "PREROUTING") that corresponds to the
	chosen target. Then top NAT rule set is processed. Branching rules
	found in it pass control to the chains used for the rules from the
	branching rule set. IF branching rule set uses a mix of SNAT and
	DNAT rules, the branching rule in the top rule set is split and
	placed in both PREROUTING and POSTROUTING chains as appropriate.

2009-10-14  vadim  <vadim@vk.crocodile.org>

	* src/res/configlets/linux24/conntrack: Implemented support for
	conntrack performance tuning parameters and tcp window tracking
	option. Parameters CONNTRACK_MAX and HASHSIZE are described at
	http://www.wallfire.org/misc/netfilter_conntrack_perf.txt.  The
	conntrack_tcp_be_liberal option is described at
	http://conntrack-tools.netfilter.org/manual.html . Parameters can
	be set in the host OS dialog for Linux (added new tab
	"conntrack").  Commands that will be added to the generated script
	come from the new configlet "conntrack". Commands are different
	for iptables versions <1.4.0 and >=1.4.0. User can customize the
	commands by substituting the configlet if necessary. Fixes #198, #511.

2009-10-13  vadim  <vadim@vk.crocodile.org>

	* PolicyCompiler_ipf.cpp (SplitDirectionIpfilter::processNext):
	fixed bug #2874571: "ipfilter version 3.4.29 issues after
	introduction of 282860". Optimizations added for PF broke rule
	generation for ipfilter which does not allow rule without explicit
	direction specification.

	* FWBSettings.cpp (FWBSettings::getCollapsedRuleGroups): fixed bug
	#2872365: "problem with group names containing comma". State of
	the rule group with a comma in the name could not be saved in
	program settings and the group could not be expanded once it was
	collapsed.

	* CustomServiceDialog.cpp (CustomServiceDialog::loadFWObject):
	fixed bug #2870562: "custom service - protocol name
	options". Added protocol "ipv6-icmp" to the list of predefined
	protocols in the CustomService object and fixed the dialog to make
	it properly save protocol name entered by the user (the widget
	where user choses protocol name also supports editing so the user
	can enter any protocol name not offered in the list of standard
	protocols).

	* FWWindow.cpp (FWWindow::toolsDiscoveryDruid): fixed bug
	#2867550: "Discovery Druid dieswhen there is no active'project
	window".

	* debugDialog.cpp (debugDialog::debugDialog),
	DiscoveryDruid.cpp (DiscoveryDruid::DiscoveryDruid) Reversing the
	change made in 3.0.7 in the debug and discovery druid windows, the
	change was intended to make the window title bar show "close"
	button on Mac OS X. Unfortunately the caused the title bar to
	disappear all together on Linux under some window managers. Modal
	QT dialogs do not have title bar buttons on Mac OS X, but since
	they always have "OK", "Finish", "Close" or "Cancel" buttons as
	part of the dialog contents, absense of the "close" button in the
	title bar is not critical.

	* VERSION (VERSION): started v3.0.8

2009-10-07  vadim  <vadim@vk.crocodile.org>

	* FindWhereUsedWidget.cpp (FindWhereUsedWidget::itemClicked):
	"find where used" panel selects object in the tree or in rules on
	single click in the list of the results. To open the object in the
	editor user needs to switch to the editor tab in the bottom docked
	panel.

2009-10-03  vadim  <vadim@vk.crocodile.org>

	* PolicyCompiler_ipt.cpp (PolicyCompiler_ipt::insertFailoverRule):
	Added support for heartbeat over unicast. Protocol options dialog
	for heartbeat offers checkbox "Use unicast" (off by default, when
	checked, address input field for the multicast heartbeat address
	becomes disabled). When checkbox is checked, compiler
	automatically adds rules to permit unicast heartbeat health checks
	between addresses of interfaces which are members of the failover
	group.

2009-10-02  Vadim Kurland  <vadim@vk.crocodile.org>

	* ProjectPanel.cpp (topLevelChangedForTreePanel): Main window
	layout redesign: Panels that show object tree and object editor
	now use docked widget and are detachable. User can "float" these
	panels to be able to rearrange information on the screen. When
	panel showing objects tree is detached, it can be expanded to show
	multiple columns of information comfortably. Also, when the tree
	is detached, panel showing rules expands to occupy whole window
	which helps to see rules using objects with long names. This
	provides easy way to see attrivbutes of many objects at
	once. Panel that shows object editor dialogs also shows "find" and
	"find where used" dialogs in a Tab widget. This panel is part of
	the main window (it used to be part of the internal MDI subwindow)
	and also can be detached. Editor panel now occupies whole bottom
	part of the main window. Since editor dialogs show all relevant
	information about the object, the "Info" panel has been
	deprecated. Since the editor and search dialogs are now placed
	inside docked widget that has its own "close" button, "Close"
	buttons in these dialogs have been removed.

2009-09-30  vadim  <vadim@vk.crocodile.org>

	* ObjectManipulator.cpp (ObjectManipulator::setAttributesColumnEnabled):
	New feature: the GUI can show brief summary of object attributes
	in the second column in the object tree. This is controlled by a
	checkbox in the global preferences dialog, tab "Objects". This is
	off by default. The first column always shows object icon and its
	name, the second (optional) column shows its attributes. Interface
	label is shown in the second column. The width of both columns in
	the tree is set automatically to accommodate all the text, then
	can be adjusted by the user using mouse. Column width is saved in
	settings and will be restored upon program restart. Column width
	is saved per-file, per-library.

2009-09-23  vadim  <vadim@vk.crocodile.org>

	* ../src/res/configlets/linux24/update_bonding: Generated iptables
	script incrementally updates bonding interfaces:

	- It creates new bonding interfaces with parameters configured in
	the GUI if module 'bonding' is not loaded. This is what happens
	if fwbuilder script runs after reboot.

	- if there are no bonding interfaces in fwbuilder configuration,
	the script removes bonding module to kill any bonding interfaces
	that might exist on the machine

	- if you add new bonding interface in fwbuilder, the script checks
	if it exists on the machine. It will not create it because to do
	so, it would have to remove the module which kills other bonding
	interfaces. If this second bonding interface exists, it will be
	configured with slaves and addresses. If it does not exist, script
	aborts. In this case you need to either 1) reload module manually
	or 2) add max_bonds=2 to /etc/modules.conf and reboot or 3) unload
	module and run fwbuilder script again (if module is not loaded,
	the script loads it with correct max_bonds parameter)

	- if a bonding interface exists on the machine but not in
	fwbuilder configuration, the script removes all slaves from it and
	brings it down. It can not delete it because to do so it would
	need to remove the module, which kills other bonding interfaces.

	Limitation: currently all bonding interfaces will use the same
	protocol parameters. This is because module loading with parameter
	"-obond1" that is supposed to be the way to obtain more than one
	bonding interface and also the way to specify different parameters
	for different interfaces causes kernel panic in my tests. Tested
	with bonding module v3.5.0 and kernel 2.6.29.4-167.fc11.i686.PAE
	on Fedora Core 11. The only working way to get two bonding
	interfaces I could find is to load the module with parameter
	max_bonds=2, but this means all bonding interfaces work with the
	same protocol parameters. If bond interfaces are configured with
	different parameters in fwbuilder, compiler uses the first and
	issues warning for others.

2009-09-18  vadim  <vadim@vk.crocodile.org>

	* PolicyCompiler.cpp (ItfNegation::processNext): (change in
	libfwbuilder) fix for bug #2710034 "PF Compiler in 3.0.3
	Unprotected Interface Bug". When we expand "interface" rule
	element which uses negation, skip unprotected interfaces.

2009-09-16  vadim  <vadim@vk.crocodile.org>

 	* RoutingCompiler_ipt_writers.cpp (PrintRule::processNext): Fixed
	security issue with temporary file handling in the generated
	iptables script. The problem only affects Linux systems where
	Firewall Builder is used to generate static routing
	configuration. The problem exists in Firewall Builder versions
	3.0.4, 3.0.5, 3.0.6

2009-09-14  vadim  <vadim@vk.crocodile.org>

	* standardized compiler error and warning messages using format
	fw_name:ruleset_name:rule_number: warning: message
	fw_name:ruleset_name:rule_number: error: message

	* dialogs that show compiler output recognize error and warning
	messages and highlight them using different color and bold font.

2009-09-07  vadim  <vadim@vk.crocodile.org>

	* single rule compile feature implemented for all
	platforms (iptables, ipfilter, pf, ipfw, iosacl, pix) and
	integrated with the GUI. Currently using keyboard shortcut "x".
	Fixes #23.

2009-09-06  vadim  <vadim@vk.crocodile.org>

	* RuleSetView_single_rule_compile.cpp (RuleSetView::compileForCurrentRow):
	Single rule compile implementation. Currently this is triggered by
	hitting keyboard key 'x', the event is processed by RuleSetView
	class which calls RuleSetView::compileForCurrentRow(). This
	creates compiler driver object and calls it to compile currently
	selected rule. The result is shown in the editor panel. User can
	select parts or the whole of the generated script in the editor
	panel but it is read-only.  Works only with iptables yet. Refs #23.

	* src/iptlib/iptlib.pro (SOURCES): Moved all modules for fwb_ipt
	except main module ipt.cpp to a separate library so that they can
	be linked with either command line compiler fwb_ipt or the
	GUI. Refs #23

2009-09-05  vadim  <vadim@vk.crocodile.org>

	* PolicyCompiler_iosacl_writers.cpp (PrintRule::_printDstService):
	fixed bug (no #): policy compiler for Cisco IOS ACL did not add
	icmp type to the generated ipv6 access-list statements for rules
	that matched ICMPv6 services.

2009-09-03  vadim  <vadim@vk.crocodile.org>

	* src/res/configlets/linux24/update_bridge: configlet that updates
	bridge interfaces will now completely synchronize interfaces with
	configuration created in fwbuilder even if no bridge interfaces
	are used in fwbuilder. Bridge interfaces that exist on the
	firewall but not in fwbuilder will be deleted and those that exist
	in fwbuilder but are missing on the machine will be added. Bridge
	ports are deleted and added after bridge interfaces have been
	synchronized.

	* src/res/configlets/linux24/update_vlans: fixed command line in
	the command that removed vlan interface

2009-08-30  vadim  <vadim@vk.crocodile.org>

	* instDialog_ui_ops.cpp (instDialog::addToLog): fixed bug #2847263
	"Batch compiling incrementally slow". The time it took to add a
	log line to the progress window in the "Compile" dialog slowed
	down a lot as amount of text in QTextEditor increased.

2009-08-28  vadim  <vadim@vk.crocodile.org>

	* ProjectPanel.cpp (ProjectPanel::event): instead of several
	methods in FWWindow that scan all project panel windows and
	execute some operation, using user defined events. Currently have
	two events: dataModifiedEvent and updateObjectInTreeEvent. The
	first one signals that some object has changed so that
	ProjectPanel::event() can update timestamps and do other things.
	It then posts the second event, which it will catch and process on
	the next event processing run. The second event does UI updates.
	Both events carry file name and object ID. Only those ProjectPanel
	objects that have the same file process the event. Events are
	dispatched to project panels in FWWindow::event(). Concentrating
	all UI update logic in one place helps avoid unnecessary redraws.
	This replaces FWWIndow::updateLastModifiedTimestampForOneFirewall,
	FWWindow::updateLastModifiedTimestampForAllFirewalls,
	FWWindow::reloadAllWindowsWithFile.

	* interfaceProperties.cpp (interfaceProperties::manageIpAddresses):
	this is a generic method that implements a policy to decide
	whether generated script should manage ip addresses of a given
	interface. It checks if it belongs to a cluster or a firewall and
	failover protocol (if it belongs to a cluster). It fills two
	lists: one is the list of addresses that the interface should have
	and another is a list of interfaces the script must not remove
	even if they are assigned to the interface. The method uses data
	from host_os XML resource file.

2009-08-27  vadim  <vadim@vk.crocodile.org>

	* CompilerDriver.cpp (CompilerDriver::mergeRuleSets): See #372:
	this change reverses the logic of the program when it merges rule
	sets from the cluster into its member firewalls. In the original
	Secunet implementation rule sets of members were ignored and only
	one top level rule set from the cluster was ever used. Now we
	check if member firewall has rule set of the same name as cluster
	and use it if it is not empty and issue a warning. If rule set of
	the member firewall with the same name is empty, rules from the
	cluster are used. All rule sets of the cluster that do not match
	anything in member firewalls are merged into firewalls and used
	for compilation. This way, we can have multiple rule sets in the
	cluster and can have slightly different rules in member firewalls
	if necessary. See ticket #372 for more details and info for the
	documentation.

	* PolicyCompiler_ipt.cpp (PolicyCompiler_ipt::addPredefinedPolicyRules):
	fixes #388: "automatic rules are added to second rule set in
	cluster member". IF a cluster member firewall had several policy
	rule set objects, automatic rules for conntrackd, vrrp, heartbeat
	were added multiple times.

	* OSConfigurator_linux24_interfaces.cpp (printInterfaceConfigurationCommands):
	fixes #387: add calls to update_addresses shell function in
	generated script even for interfaces with no ip addresses. This
	way, if such interface has an address on the machine, it will be
	removed. This helps synchronize configuration with fwbuilder when
	user removes all addresses from an interface and converts it to
	"unnumbered". Note that update_addresses never removes scope link
	and scope host addresses of the interface even if they are not
	configured in fwbuilder GUI.

	* PolicyCompiler_pf.cpp (SplitDirection::processNext): applied
	patch per #2844561: "PF Compiler Direction Both Duplicate for
	Route Action". Need to split the rule if direction is Both
	and action is Route.

	* newFirewallDialog.cpp (newFirewallDialog::templateSelected):
	fixed bug #2844596: "Crash during newFirewallDialog". GUI crashed
	if user clicked "next" in the new firewall dialog to open page
	with templates, then clicked "Back" and then "Next" again.

	* ObjectManipulator.cpp (ObjectManipulator::select): fixed bug
	#2845667 "Crash after find object". When host object was found
	using "Find object" function while searching by ip address,
	clicking on the selected host in the tree caused crash.

	* VERSION (LIBFWBUILDER_SOMAJOR): started 3.0.7

2009-08-26  vadim  <vadim@vk.crocodile.org>

	* ObjectManipulator.cpp (ObjectManipulator::validateForPaste):
	User should be able to add vlan interface to a bridge (vlan
	interface becomes bridge port). Fixes #384

	* CompilerDriver.cpp (CompilerDriver::populateClusterElements):
	moved this method from class Compiler. fixes #367

	* CompilerDriver_compile.cpp (compileSingleRule): entry point for
	single rule compile. Takes one argument - rule ID and returns a
	QMap<QString,QString> where key is firewall name and value is
	generated script for this rule. Currently using this entry point
	in the command line compilers via cli argument -s rule_id. Fully
	implemented in fwb_ipt.  Fixes #358, #206

	* CompilerDriver_ipt_run.cpp (CompilerDriver_ipt::run): using
	std::auto_ptr to protect OSConfigurator, PolicyCompiler and
	NATCompiler objects and to properly delete them to avoid memory
	leaks in fwb_ipt. fixes #371

2009-08-24  vadim  <vadim@vk.crocodile.org>

	* CompilerDriver.cpp (CompilerDriver::commonChecks2): refactored
	bunch of common sense checks from compilers for ipt and pf into
	common module. This also fixes #337 by checking if it is ok for
	the cluster interface to have no ip address using xml resource
	file for the fw host OS. Protocols such as heartbeat and openais
	can operate when failover interface has no shared cluster address
	because these protocls can use multicast address. However
	configuration when cluster interface using one of these protocols
	has shared IP is also legit. The check here only suppresses error
	message when interface has no ip.

	* platforms.cpp (setInterfaceTypes): Fixes #335 : if interface
	name matches naming convention for vlan interfaces and vlan type
	is in the list that came from the resource file, then leave only
	vlan in the list we return.  Note that if resource file says this
	subint can not be vlan, we dan't return vlan type on the list even
	if its name looks like it could be one.

	* ProjectPanel.cpp (ProjectPanel::updateTreeViewItemOrder):
	Removed ProjectPanel::updateTreeViewItemOrder() and removed call
	to it from ObjectEditor::notifyChangesApplied(). We take care of
	QT bug workaround for improper sorting in other places. This
	change fixes #329.

2009-08-21  vadim  <vadim@vk.crocodile.org>

	* ObjectManipulator.cpp (ObjectManipulator::newInterface): If
	newly created interface object is a top-level interface, always
	set its type to "ethernet". If it is subinterface, call
	guessInterfaceType() to guess.

	* ObjectManipulator.cpp (guessInterfaceType): fixes #334.  the GUI
	guesses correct subinterface type when it is created and when user
	hits "Apply" in the interface object dialog after some changes
	have been made. If inetrface name matches one of the patterns of
	the vlan inetrface for the given OS, its type is set to "vlan" and
	vlan ID is assigned. If its name does not match naming pattern of
	a vlan interface but parent interface type is "bridge" or
	"bonding", subinterface type is set to "ethernet". This covers
	most of the use cases and makes subinterface type assignment
	automatic.

	* ObjectManipulator.cpp (ObjectManipulator::newInterfaceAddress):
	fixes #330: the name of the ip address of an interface should
	follow the schema "firewall:interface:subinterface:ip". The same
	schema should be followed when address object is automatically
	renamed when the user renames firewall or interface object.

	* ObjectManipulator.cpp (ObjectManipulator::copyObj): call
	Interface::getOptionsObject() at the beginning of copy and
	dragStart operations to make sure interface has options object
	later in paste and drop operations when we need it to do some
	validation checks.

2009-08-20  vadim  <vadim@vk.crocodile.org>

	* ObjectManipulator.cpp (ObjectManipulator::validateForPaste):
	perform checks for the valid vlan subinterface configuration
	for copy/paste and d&d drop operations; this uses the same
	algorithms as the check done when user renames an interface.
	This means user can not copy/paste or d&d interface "eth1.100"
	to make it a subinterface of "eth0" or top-level interface.

	* InterfaceDialog.cpp (InterfaceDialog::validate): Additional
	checks for validity of interface name: the name can not contain
	white space, if the name looks like vlan interface, checking
	if it is valid (base name must match name of the parent interface
	and vlan ID must be in the allowed range)

	* InterfaceDialog.cpp (InterfaceDialog::applyChanges): Fixes #328:
	"automatically assign vlan id to interface based on interface
	name". The GUI automatically sets interface type to "vlan" and
	configures vlan ID if user changes name of the interface to
	something that matches regex for vlan interfaces on given OS.
	This is done when user hits "Apply" button in the Interface object
	dialog.

	* src/compiler_lib/interfaceProperties.h (class
	interfaceProperties): refactored class linux24Intrfaces into class
	hierarchy with base class interfaceProperties and factory
	class interfacePropertiesObjectFactory. These classes are now
	part of the compiler extensions library in src/compiler_lib
	and can be used by both the GUI and compilers.

	* Configlet.cpp (Configlet::Configlet): New constructor for the
	class Configlet accepts os name perifx and default os name prefix.
	If configlet file is not found in the directory defined by the
	first prefix, the program tries to find it in the default place
	defined by the second prefix.

	* src/res/configlets/sveasoft/script_skeleton: Using separate
	configlets for Linksys/Sveasoft host os.

2009-08-19  vadim  <vadim@vk.crocodile.org>

	* ObjectManipulator.cpp (ObjectManipulator::newInterfaceAddress):
	fixes #318: New ip address of interface was always created with
	the same name even if there was an address object with the same
	name under the same interface.

	* OSConfigurator_linux24_interfaces.cpp (validateInterfaces):
	Tests for unsupported interface configurations, see #315, 324.

	The first test scans all subinterfaces of each interface and tries
	to find top level inetrfaces wth the same name, then checks their
	type. For the combination some_interface/br1, we look for the top
	level interface "br1" and if it exists and its type is "bridge",
	then this is unsupported configuration. This test does not allow
	subinterface to have the same name as a bridge interface
	regardless of the type of the parent interface. So, bridge/bridge
	or bonding/bridge combinations are not allowed. The test has to
	search top level interfaces because bridge port subinterfaces can
	be copies (e.g. when a vlan interface is at the same time a bridge
	port).

	The second test looks for the following combinations: 1) vlan
	interfaces under bridge interface (e.g. br0 = [eth1, eth2], vlan
	inetrface br0.100 is not supported) and 2) vlan interfaces as
	slaves of bonding interfaces (e.g. eth0.100, eth1.100, bond0
	= [eth0.100, eth1.100], note the difference between this and vlan
	of bonding interface such as bond0.201). Only regular interfaces
	can be slaves of bonding interface. If subinterface type is
	"ethernet" but its name matches one of the vlan interface regexes,
	assume this is vlan. Slave subintrfaces do not have to be copies,
	one can have "eth4" only once, as a slave, so we cant search for a
	top level interface with the same name and rely on the
	subinterface type.

2009-08-18  vadim  <vadim@vk.crocodile.org>

	* ObjectManipulator.cpp (ObjectManipulator::makeNameUnique): The
	program should never change the name of vlan interface when such
	interface is being copied/pasted or dropped to become a
	subinterface. The name of the vlan interface carries vlan ID and
	changing name is not allowed. One of the typical usage patterns is
	to create vlan interface "eth0.101" and then immediately try to
	copy/paste it to under br0 to make it bridge port. In this case
	interface eth0.101 wont have type "8021q" just yet because the
	user did not open interface "advanced" settings dialog to set its
	type and VLAN ID. Users assume that if its name is "eth0.101",
	then it must be vlan interface. We should follow this assumption
	too. Also, check for names "vlanNNN" as well.

	* ObjectManipulator.cpp (ObjectManipulator::actuallyPasteTo):
	during "paste" operation, call makeNameUnique() to make the name
	of the copy unique before actually adding the object to its
	parent.  Otherwise makeNameUnique() finds it and changes the name.

	* src/res/configlets/ipcop/script_skeleton: Using configlet to
	define script structure for generated IPCOP script. IPCOP script
	is executed as /etc/rc.d/rc.firewall.local and does not manage ip
	addresses of interfaces or vlan/bond/bridge interfaces so it does
	not need corresponding shell functions. Script can check if
	interfaces configured in fwbuilder GUI match actual appliance, so
	the shell code to do that is included. Since we should be able to
	use interfaces with addresses assigned dynamically in rules, the
	code that gets their addresses at run time is included. Code to
	check if data files used by run time address table objects exist
	is also included. Using configlets helps better manage what is
	included for the given os family ("linux24" or "ipcop" or some
	other in the future). Also, user can override our configlets by
	placing file with the same name in "fwbuilder/configlets"
	directory in their $HOME.

2009-08-17  vadim  <vadim@vk.crocodile.org>

	* src/res/configlets/linux24/shell_functions: cleaned up coding
	style in shell functions in configlets: using uniform 4 spaces
	indentation.

	* src/res/configlets/linux24/script_skeleton: This configlet
	defines structure of generated iptables script. Script recognizes
	the following command line options: start|stop|interfaces

	* CompilerDriver_ipt_run.cpp (CompilerDriver_ipt::run): Building
	whole iptables script from configlet.

	* OSConfigurator_linux24.cpp (OSConfigurator_linux24::configureInterfaces):
	See #314. Need to update vlans and bond interfaces first and only
	then deal with bridges because bridge may use bonding interface or
	vlan created in the first step. Unsupported configurations: vlan
	interfaces under bridge interface (e.g. br0 = [eth1, eth2], vlan
	inetrface br0.100 is not supported), bridge interface as part of
	bonding interface (e.g. bond0 = [br0, br1]), vlan interface as a
	slave of bonding interface (e.g. eth0.100, eth1.100, bond0
	= [eth0.100, eth1.100]). Only regular interfaces can be slaves of
	bonding interface; vlans can be created under bonding interface
	(e.g. bond0.100), both regular interfaces and vlans can be bridge
	ports. Script first updates bonding interfaces, then updates all
	vlans, including possibly those under bonding interfaces, and
	finally updates bridge configurations using interfaces created in
	first two steps.

2009-08-12  vadim  <vadim@vk.crocodile.org>

	* NATCompiler_ipt.cpp (splitSDNATRule::processNext): fixed bug
	#2836321: "SNAT rule that changes Trans Src and Trans Port does
	not work". Dual translation rule that changes source address and
	destination port was not supported.

2009-08-10  vadim  <vadim@vk.crocodile.org>

	* PolicyCompiler_pf_writers.cpp (PrintRule::processNext): For bug
	#2835193: "Modulate state doesnt work for PF". Check variable
	"modulate state" in rule optiopns and global firewall options. If
	checkbox is turned on in the firewall options, then we always use
	"modulate state". This option can also be turned on for an
	individual rule using rule options dialog.

	* pfAdvancedDialog.cpp (pfAdvancedDialog::pfAdvancedDialog): Fixed
	bug #2835193: "Modulate state doesnt work for PF".  The name Xml
	attribute used to hold the value of "module state" option was
	entered incorrectly in the dialog.

2009-08-09  vadim  <vadim@vk.crocodile.org>

	* ipfw.cpp (main): compiler for ipfw uses new manifest format
	and supports remote file name for the generated .fw script
	Fixes #308

	* ipf.cpp (main): compiler for ipfilter uses new manifest format
	and supports remote file names for generated .fw and .conf
	files. Fixes #307

	* CompilerDriver_pf.cpp (CompilerDriver_pf::getRemoteConfFileName):
	compiler for PF uses new manifest format and supports remote file names
	for generated .fw and .conf files. Fixes #306

	* CompilerDriver_ipt_run.cpp (CompilerDriver_ipt::run): compiler
	for iptables uses new manifest format to implement support for
	alternative name of the script on the firewall. Fixes #305

2009-08-08  vadim  <vadim@vk.crocodile.org>

	* instDialog.cpp: Installation process is controlled by sevral
	variables that the user can change in the "advanced" dialog
	for the firewall platform:

	Tab "Compiler":
	 - output file name
	 - script name on the firewall
	 - for PF and ipfilter additionally .conf file name on the firewall

	Tab "Installer":
	 - directory on the firewall where script should be installed
	 - command that installer should execute on the firewall

	These variables have default values if input fields are left blank
	in the dialog as follows:

	output file name: the name of the firewall object, plus extension
	".fw". For PF two files are generated: <firewall>.fw and
	<firewall>.conf; for ipfilter files <firewall>.fw, <firewall>-ipf.conf
	and <firewall>-nat.conf are generated.

	script name on the firewall: the same as the output file name

	directory on the firewall: "/etc"

	command that installer executes to activate policy: installer runs
	script <firewall>.fw

	If user enters alternative name in the "script name on the
	firewall", it is used when generated script is copied to the
	firewall. There are two input fields in the dialogs for PF and ipf
	where user can enter alternative name for the .fw script and .conf
	file. The name can be relative or absolute path. If it is a
	relative path or just a file name, it is treated as a file name in
	the directory specified by the "directory on the firewall" input
	field in the "Installer" tab. If the name is an absolute path, the
	directory entered in "directory on the firewall..." input field is
	ignored.  If user entered alternative name for the script on the
	firewall, the command that installer should execute to activate it
	must be entered as well. If the alternative name was entered as an
	absolute path, activation command should take this into account
	and use the same absolute path. The command can start with "sudo "
	if user account used to copy and activate policy is not root.

	* iptAdvancedDialog.cpp (iptAdvancedDialog::iptAdvancedDialog):
	Added input fields to the "advanced" dialogs for iptables, pf,
	ipfilter and ipfw to make it possible to specify the name of the
	generated script on the firewall. With this change, fwbuilder can
	generate the script using unique name but use standard common name
	such as "rc.firewall" when the script is copied to the firewall
	machine. This is important when two firewalls that are part of a
	cluster are compiled at the same time. In this case we can not use
	name such as "rc.firewall" for the output script because file
	generated for the second firewall in the pair overwrites the one
	generated earlier for the first. Now we can use unique names for
	scripts generated for each member of the pair but copy them to the
	firewall machines using the same common name. Fixes #304 The
	implementation is not complete yet, I still need to make changes
	in the installer and policy compilers.

2009-08-07  vadim  <vadim@vk.crocodile.org>

	* src/res/configlets/linux24/process_bridge: Configlets that
	updated ip addresses, vlan, bridge and bonding interfaces bring
	interfaces up using $IFCONFIG command. Fixes #301

2009-08-06  vadim  <vadim@vk.crocodile.org>

	* ObjectManipulator.cpp (ObjectManipulator::actuallyPasteTo): When
	a subinterface is copied to make a subinterface of another
